;	include	system.gs
	include hardware/custom.i
	include graphics/graphics_lib.i
	include	dh0:dos_lib.i
	include	libraries/asl.i
	include	intuition/intuition_lib.i
;
	include	exec/exec.i
	include	exec/exec_lib.i
	include	exec/execbase.i
	include	libraries/dosextens.i
;
	opt	p=68040
;
;==============================================
;	Main Menu
;==============================================
;
	section	Main,code_f
;
;
tMAIN:
	movem.l	d0/a0,-(sp)		; save initial values
	clr.l	returnMsg
	sub.l	a1,a1
	CALLEXEC FindTask		; find us
	move.l	d0,a4
	tst.l	pr_CLI(a4)
	bne.s	fromCLI
	lea	pr_MsgPort(a4),a0
	CALLEXEC WaitPort		; wait for a message
	lea	pr_MsgPort(a4),a0
	CALLEXEC GetMsg			; then get it
	move.l	d0,returnMsg		; save it for later reply
fromCLI:
	movem.l	(sp)+,d0/a0		; restore
;
	move.l	4.w,a6
	move.w	AttnFlags(a6),d0
	btst	#3,d0			; 0 - not 040, 1 - 040 presents
	bne.s	.1
	clr.l	d0			; set 0 ->CPU? (68030 detected)
.1:
	move.l	d0,CPU?

;
	bsr	OpenLibs
	beq	NoLibs
;
	bsr	LoadROM			; load 48, 128, tr-dos roms
	bsr 	CompileKBD		; init keyboard
	beq	NoLibs
	move.l	4.w,a6
	lea	gfxname(pc),a1
	clr.l	d0
	jsr	-$228(a6)
	move.l	d0,gfxbase
CLI:
	bsr	LoadConfig		; load CBSpeccy config file
;
	move.w	saveVTOTAL,EmulGTags+18
	move.l	ScreenMode,xScrMode
	move.w	RefreshMode,d0
	and.l	#$1,d0
	move.l	d0,EmulGTags+160
;
	move.w	BRD?,EmulGTags+$15E
	move.w	WaitKBD?,EmulGTags+52*4+2
	move.w	JoyMode,EmulGTags+57*4+2
	lea	JoyKeys(pc),a0
	move.b	(a0)+,JKleftString
	move.b	(a0)+,JKrightString
	move.b	(a0)+,JKupString
	move.b	(a0)+,JKdownString
	move.b	(a0)+,JKfireString
;
IniMMASK:
	move.l	MemoryMask,d0
	lea	MemMaskString,a0
	bsr	GenTMASK
	move.l	MemoryMask2,d0
	lea	MMASK2String,a0
	bsr	GenTMASK
	lea	WBsname,a0
	move.l	_IntuitionBase,a6
	jsr	_LVOLockPubScreen(a6)
	move.l	d0,d2
	move.l	d0,a0
	lea	$2c(a0),a0
	move.l	gfxbase,a6
	jsr	_LVOGetVPModeID(a6)
	move.l	d0,ScreenTags+68
	move.l	_IntuitionBase,a6
	sub.l	a0,a0
	move.l	d2,a1
	jsr	_LVOUnlockPubScreen(a6)
;
	bsr	IniEmul			; init emulator code and tables
;
	jsr	SetupScreen
	jsr	OpenEmulWindow
	MOVEQ	#0,D0
	LEA	LoadTags(PC),A0
	MOVE.L	EmulWnd,4(A0)
	MOVE.L	_AslBase,A6
	JSR	-$30(A6)	; AllocAslRequest.
	MOVE.L	D0,InsReqBase
	MOVEQ	#2,D0
	LEA	ScrTags(PC),A0
	MOVE.L	EmulWnd,4(A0)
	MOVE.L	_AslBase,A6
	JSR	-$30(A6)	; AllocAslRequest.
	MOVE.L	D0,ScrReqBase
;
	bsr	DrawLogo
	bsr	IniCheat
;
MenuLoop:
	move.l	ScreenMode,d0
	move.l	gfxbase,a6
	jsr	_LVOFindDisplayInfo(a6)
	tst.l	d0
	beq	MenuLoop
	move.l	d0,a0
	moveq	#nif_SIZEOF,d0
	move.l	#DTAG_NAME,d1
	moveq	#-1,d2
	lea	MNTRbuf,a1
	move.l	gfxbase,a6
	jsr	_LVOGetDisplayInfoData(a6)
;
	move.l	EmulNGads+GD_Gadget180*30,d0
	add.l	#$5000D,d0
	move.l	d0,XTextXY
;
	lea	MNTRbuf+16(pc),a0
	move.l	a0,XText+12
	moveq	#29,d0
.1:
	tst.b	(a0)+
	dbeq	d0,.1
	bne.s	.3
	tst.w	d0
	bmi.s	.2
	move.b	#" ",-1(a0)
.4
	move.b	#" ",(a0)+
	dbra	d0,.4
	clr.b	-1(a0)
	bra.s	.2
.3:
	clr.b	(a0)
.2:
	move.l  EmulWnd,a0
	move.b  54(a0),d0
	ext.w   d0
	move.b  55(a0),d1
	ext.w   d1
	move.l  50(a0),a0
	lea	XText(pc),a1
	move.l  _IntuitionBase,a6
	jsr	PrintIText(a6)
;
	LEA	EmulGadgets+(GD_save_trda*4),A0
	MOVE.w	Change_TRDA,D0
	BSR	GadsOnOff
	LEA	EmulGadgets+(GD_save_trdb*4),A0
	MOVE.w	Change_TRDB,D0
	BSR	GadsOnOff
;
	LEA	EmulGadgets+(GD_SelScr*4),A0
	MOVE.w	RefreshMode,D0
	BSR	GadsOnOff
	LEA	EmulGadgets+(GD_IsBorder*4),A0
	MOVE.w	RefreshMode,D0
	BSR	GadsOnOff
	LEA	EmulGadgets+(GD_I_VTOTAL*4),A0
	MOVE.w	RefreshMode,D0
	not.w	d0
	and.w	#1,d0
	BSR	GadsOnOff
	move.w	JoyMode,d0
	and.w	#4,d0
	move.l	d0,-(a7)
	LEA	EmulGadgets+(GD_JKleft*4),A0
	BSR	GadsOnOff
	move.l	(a7),d0
	LEA	EmulGadgets+(GD_JKright*4),A0
	BSR	GadsOnOff
	move.l	(a7),d0
	LEA	EmulGadgets+(GD_JKup*4),A0
	BSR	GadsOnOff
	move.l	(a7),d0
	LEA	EmulGadgets+(GD_JKdown*4),A0
	BSR	GadsOnOff
	move.l	(a7)+,d0
	LEA	EmulGadgets+(GD_JKfire*4),A0
	BSR	GadsOnOff
;
	move.l	EmulWnd,A0
	MOVE.L	$56(A0),A0
	MOVE.L	$4,A6
	JSR	-$180(A6)	; Wait Port. (iport)(A0)
	move.l	EmulWnd,A0
	MOVE.L	$56(A0),A0
	MOVE.L	_GadToolsBase,A6
	JSR	-$48(A6)	; GT_GetIMsg(iport)(A0)
	TST.L	D0
	BEQ	MenuLoop
	MOVE.L	D0,-(SP)
	MOVE.L	D0,A1
	MOVE.L	$1C(A1),-(SP)
	MOVE.L	$14(A1),-(SP)
	MOVE.L	_GadToolsBase,A6
	JSR	-$4E(A6)	; GT_ReplyIMsg(imsg)(A1)
	MOVEM.L	(SP)+,D0-D1/A1
;
;	CMP.W	#$200,D0	; CloseGadget.
;	BEQ	CONTROLNOGADS
;
;	CMP.W	#$100,D0	; Men?
;	BEQ.s	Check_M
;
;	CMP.W	#$010,D0	; Slider?
;	BEQ.S	Slider
;
	CMP.W	#$040,D0	; Gadget?
	BEQ.S	Check_G
;
;	CMP.W	#$400,D0	; Keyboard?
;	BEQ.S	Keyboard
;
	BRA	MenuLoop
Check_G:
	lea	EmulGadgets,a0
	cmp.l	GD_G_Start*4(a0),d1
	beq	.1
	cmp.l	GD_G_Reset*4(a0),d1
	beq	.2
	cmp.l	GD_G_Quit*4(a0),d1
	beq	.3
	cmp.l	GD_I_VTOTAL*4(a0),d1
	beq	SetVTOTAL
	cmp.l	GD_POKE_ADR*4(a0),d1
	beq	SetPOKEADR
	cmp.l	GD_POKE_DAT*4(a0),d1
	beq	SetPOKEDAT
	cmp.l	GD_get_trda*4(a0),d1
	beq	Get_TRDA
	cmp.l	GD_get_trdb*4(a0),d1
	beq	Get_TRDB
	cmp.l	GD_get_tap*4(a0),d1
	beq	Get_TAP
	cmp.l	GD_save_trda*4(a0),d1
	beq	Save_TRDA
	cmp.l	GD_save_trdb*4(a0),d1
	beq	Save_TRDB
	cmp.l	GD_Save_ZX_Scr*4(a0),d1
	beq	Save_ZX_Screen
	cmp.l	GD_SaveFRZ*4(a0),d1
	beq	Save_Frozen
	cmp.l	GD_LoadFRZ*4(a0),d1
	beq	Load_Frozen
	cmp.l	GD_InsHB1*4(a0),d1
	beq	InsertHB1
	cmp.l	GD_InsHB2*4(a0),d1
	beq	InsertHB2
	cmp.l	GD_StartSNA*4(a0),d1
	beq	StartSNA
	cmp.l	GD_RMODE*4(a0),d1
	beq	SetRMODE
	cmp.l	GD_SAVEC*4(a0),d1
	beq	SaveConfig
	cmp.l	GD_SelScr*4(a0),d1
	beq	SelectScr
	cmp.l	GD_ScrMode*4(a0),d1
	beq	SelectRfsh
	cmp.l	GD_JoyM*4(a0),d1
	beq	SetJoyM
	cmp.l	GD_KBDwait*4(a0),d1
	beq	SetWKBD
	cmp.l	GD_IsBorder*4(a0),d1
	beq	SetBRDmode
	cmp.l	GD_ChView*4(a0),d1
	beq	SetCheatPoke
	cmp.l	GD_ChStart*4(a0),d1
	beq	CheatStart
	cmp.l	GD_ChNext*4(a0),d1
	beq	CheatNext
	cmp.l	GD_SaveTZXinfo*4(a0),d1
	beq	SaveTZXinfo
	cmp.l	GD_FramePoke*4(a0),d1
	beq	FRMpoke
	cmp.l	GD_LoadC*4(a0),d1
	beq	LoadCFG
	cmp.l	GD_Fast10*4(a0),d1
	beq	ChFast10
	cmp.l	GD_Sel_QFDrv*4(a0),d1
	beq	Sel_QFD
	cmp.l	GD_QFormat*4(a0),d1
	beq	Q_Format
;
	moveq	#0,d7
	cmp.l	GD_JKleft*4(a0),d1
	beq	SetJKEY
	addq.l	#1,d7
	cmp.l	GD_JKright*4(a0),d1
	beq	SetJKEY
	addq.l	#1,d7
	cmp.l	GD_JKup*4(a0),d1
	beq	SetJKEY
	addq.l	#1,d7
	cmp.l	GD_JKdown*4(a0),d1
	beq	SetJKEY
	addq.l	#1,d7
	cmp.l	GD_JKfire*4(a0),d1
	beq	SetJKEY
	cmp.l	GD_MemMask*4(a0),d1
	beq	SetMMASK
	cmp.l	GD_MMASK2*4(a0),d1
	beq	SetMMASK2
;
	bra	MenuLoop
.2:
	st	HardRes
.1
	jsr	StartEmul
	bra	MenuLoop
.3					
	bsr	FreeTAP
	bsr	FreeCheat
	MOVE.L	InsReqBase,A0
	MOVE.L	_AslBase,A6
	JSR	-$36(A6)	; FreeAslRequest.
	jsr	CloseEmulWindow
	jsr	CloseDownScreen
NoLibs:
	bsr	CloseLibs
	clr.l	d0
	move.l	d0,-(sp)		save it
	tst.l	returnMsg
	beq.s	exitToDOS		if I was a CLI
	CALLEXEC Forbid
	move.l	returnMsg(pc),a1
	CALLEXEC ReplyMsg
exitToDOS:
	move.l	(sp)+,d0		exit code
	rts
;
returnMsg:	dc.l	0
;
	CPU?:	dc.l	1		;0 - 030, 1 - 040/060
;
SetJoyM:
	move.l	d1,a0
	move.w	$56(a0),JoyMode
	bra	MenuLoop
SetWKBD:
	move.l	d1,a0
	move.w	$56(a0),WaitKBD?
	bra	MenuLoop
;
FRMpoke:
	move.l	d1,a0
	move.w	$50(a0),FPoke?
	bra	MenuLoop
ChFast10:
	move.l	d1,a0
	move.w	$50(a0),Fast10?
	bra	MenuLoop
;
SetVTOTAL:				; Set VTOTAL
	move.l	d1,a0
	move.l	gg_SpecialInfo(a0),a0
	move.l	si_LongInt(a0),d0
	cmp.w	#312,d0
	bcs.s	.1
	cmp.w	#341,d0
	bcc.s	.1
	move.w	d0,saveVTOTAL
	bra	MenuLoop
.1:
	move.l	EmulWnd,a1
	move.l	d1,a0
	sub.l	a2,a2
	move.l	_IntuitionBase,a6
	jsr	-$1ce(a6)
	bra	MenuLoop
;
SetPOKEADR:				; Set Poke Adress
	move.l	d1,a0
	move.l	gg_SpecialInfo(a0),a0
	move.l	si_LongInt(a0),d0
	cmp.w	#16384,d0
	bcs.s	.1
	cmp.l	#65536,d0
	bcc.s	.1
	move.w	d0,POKE_ADR_S
	bra	MenuLoop
.1:
	move.l	EmulWnd,a1
	move.l	d1,a0
	sub.l	a2,a2
	move.l	_IntuitionBase,a6
	jsr	-$1ce(a6)
	bra MenuLoop

MENSWB:
	dc.l	0
POKE_ADR_S:
	dc.w	0
POKE_dat:
	dc.w	0
FPoke?:
	dc.w	0
;
SetPOKEDAT:				; Set POKE data
	move.l	d1,a0
	move.l	gg_SpecialInfo(a0),a0
	move.l	si_LongInt(a0),d0
	cmp.w	#256,d0
	bcc.s	.1
	move.b	d0,POKE_dat
	move.l	Pages,a0
	clr.l	d1
	move.w	POKE_ADR_S,d1
	add.l	d1,a0
	move.b	d0,(a0)
	bra	MenuLoop
.1:
	move.l	EmulWnd,a1
	move.l	d1,a0
	sub.l	a2,a2
	move.l	_IntuitionBase,a6
	jsr	-$1ce(a6)
	bra MenuLoop
;
Q_Format:
	move.l	#DSKbuf,a0
	tst.w	QF_ActDrv
	beq.s	.1
	add.l	#4096*160,a0
.1:
	move.l	a0,a1
	move.w	#1024-1,d0
.2:
	clr.l	(a1)+
	dbra	d0,.2
;
	lea	$8e2(a0),a0
	move.l	#$011600f0,(a0)+
	move.l	#$09100000,(a0)+
	move.l	#$20202020,(a0)+
	move.l	#$20202020,(a0)+
	move.l	#$20000043,(a0)+
	move.l	#$42535045,(a0)+
	move.l	#$43435921,(a0)
	bra MenuLoop

Sel_QFD:
	move.l	d1,a0
	move.w	$56(a0),QF_ActDrv
	bra MenuLoop
QF_ActDrv:
	dc.w	0

SetJKEY:
	move.l	d1,a0
	move.l	gg_SpecialInfo(a0),a0
	move.l	si_Buffer(a0),a0
	bsr	IsKey
	beq.s	.1
	lea	JoyKeys(pc),a1
	move.b	-1(a0),(a1,d7.w)
	bra	MenuLoop
.1:
	move.l	EmulWnd,a1
	move.l	d1,a0
	sub.l	a2,a2
	move.l	_IntuitionBase,a6
	jsr	-$1ce(a6)
	bra	MenuLoop
GenTMASK:
	moveq	#7,d7
.1:
	move.b	#"x",d1
	btst	#23,d0
	bne.s	.2
	move.b	#"0",d1
	btst	#31,d0
	beq.s	.2
	move.b	#"1",d1
.2:
	move.b	d1,(a0)+
	lsl.l	#1,d0
	dbra	d7,.1
;
	rts
SetMMASK:
	move.l	d1,a0
	move.l	gg_SpecialInfo(a0),a0
	move.l	si_Buffer(a0),a0
;
	moveq	#7,d7
	moveq	#0,d2
.2:
	lsl.l	#1,d2
	move.b	(a0)+,d0
	cmp.b	#"x",d0
	beq.s	.x
	cmp.b	#"0",d0
	beq.s	.0
	cmp.b	#"1",d0
	beq.s	.1
	move.l	EmulWnd,a1
	move.l	d1,a0
	sub.l	a2,a2
	move.l	_IntuitionBase,a6
	jsr	-$1ce(a6)
	bra	MenuLoop
.x:
	bset	#16,d2
	bra.s	.0
.1:
	bset	#24,d2
.0:
	dbra	d7,.2
	move.w	#$c000,d2
	move.l	d2,MemoryMask
	bra	MenuLoop
;
SetMMASK2:
	move.l	d1,a0
	move.l	gg_SpecialInfo(a0),a0
	move.l	si_Buffer(a0),a0
;
	moveq	#7,d7
	moveq	#0,d2
.2:
	lsl.l	#1,d2
	move.b	(a0)+,d0
	cmp.b	#"x",d0
	beq.s	.x
	cmp.b	#"0",d0
	beq.s	.0
	cmp.b	#"1",d0
	beq.s	.1
	move.l	EmulWnd,a1
	move.l	d1,a0
	sub.l	a2,a2
	move.l	_IntuitionBase,a6
	jsr	-$1ce(a6)
	bra	MenuLoop
.x:
	bset	#16,d2
	bra.s	.0
.1:
	bset	#24,d2
.0:
	dbra	d7,.2
	move.w	#$c000,d2
	move.l	d2,MemoryMask2
	bra	MenuLoop
;
SelectScr:
	move.l	ScreenMode,xScrMode
	MOVE.L	ScrReqBase,A0
	LEA	ScrTags,A1
	MOVE.L	_AslBase,A6
	move.l	a0,-(a7)
	JSR	-$3C(A6)	; RequestFile.
	move.l	(a7)+,a0
	TST.L	D0
	BEQ	MenuLoop
;
	move.l	(a0),ScreenMode
	move.l	(a0),xScrMode
;
	bra MenuLoop
;
MNTRbuf:
	ds.b	48
	dc.w	0
;
SetBRDmode:
	move.l	d1,a0
	move.w	$50(a0),BRD?
	bra	MenuLoop
;
LoadROM:
	clr.l	TrDos+$3ea0	; Patch Internal TR-Dos Rom...
	clr.l	TrDos+$3ea4
	clr.b	TrDos+$3ea8
	clr.l	TrDos+$3dfd
	clr.l	TrDos+$3dfd+4
	clr.w	TrDos+$3dfd+8
	clr.b	TrDos+$1f13
;
	lea	FN_Rom(pc),a0
	lea	Rom,a5
	bsr.s	.1
	lea	FN_Rom128(pc),a0
	lea	Rom_128,a5
	bsr.s	.1
	lea	FN_TrDos(pc),a0
	lea	TrDos,a5
.1:
	move.l	a0,d1
	move.l	#1005,d2
	CALLDOS	Open
	move.l	d0,d7
	tst.l	d0
	beq.s	.2
	move.l	a5,d2
	move.l	d7,d1
	move.l	#16384,d3	
	CALLDOS	Read
	move.l	d7,d1
	CALLDOS	Close
.2:
	rts
;
FN_Rom:
	dc.b	"PROGDIR:ROMS/48.rom",0
	even
FN_Rom128:
	dc.b	"PROGDIR:ROMS/128.rom",0
	even
FN_TrDos:
	dc.b	"PROGDIR:ROMS/trdos.rom",0
	even
;
PrintHex:
	moveq	#7,d7
.1:
	rol.l	#4,d0
	move.l	d0,-(a7)
	move.b	d0,d1
	and.w	#$000f,d1
	move.l	(HEXtab,pc,d1.w),-(a7)
	CALLDOS	Output
	move.l	d0,d1
	move.l	a7,d2
	moveq	#1,d3
	CALLDOS	Write
	addq.l	#4,a7
	move.l	(a7)+,d0
	dbra	d7,.1
	CALLDOS	Output
	move.l	d0,d1
	move.l	#EOL,d2
	moveq	#1,d3
	CALLDOS	Write
	rts
;
HEXtab:
	dc.b	"0123456789ABCDEF"
EOL:
	dc.b	10,0
;
	even
WBsname:
	dc.b	"Workbench",0
	even
;
SelectRfsh:
	move.l	d1,a0
	move.w	$56(a0),RefreshMode
	bra	MenuLoop
;
ScrReqBase:
	dc.l	0
	CNOP	0,4
ScrTags:
	dc.l	ASLSM_Window,0
	dc.l	ASLSM_TitleText,TScrTXT
	dc.l	ASLSM_InitialDisplayWidth,320
	dc.l	ASLSM_InitialDisplayHeight,256
	dc.l	ASLSM_InitialDisplayDepth,4
	dc.l	ASLSM_InitialOverscanType,0
	dc.l	ASLSM_InitialAutoScroll,1
	dc.l	ASLSM_DoWidth,1
	dc.l	ASLSM_DoHeight,1
	dc.l	ASLSM_DoDepth,1
	dc.l	ASLSM_MinWidth,320
	dc.l	ASLSM_MaxWidth,320
	dc.l	ASLSM_MinHeight,256
	dc.l	ASLSM_MaxHeight,256
	dc.l	ASLSM_MinDepth,4
	dc.l	ASLSM_MaxDepth,4
	dc.l	ASLSM_InitialDisplayID
xScrMode:
	dc.l	0
	DC.L	0,0
;
TScrTXT:
	dc.b	"Select Screen Mode...",0
	even
	CNOP	0,4

InsReqBase:
	dc.l	0
	CNOP	0,4
LoadTags:
	DC.L	$80080002,0
	DC.L	$80080012,tLoad
	DC.L	$80080003,165
	DC.L	$80080004,11
	DC.L	$80080006,196
	DC.L	$8008003C,11		; No muestra los "#?.info"
	DC.L	0,0
;
	CNOP	0,4
InsLoadTags:
	DC.L	$80080012,tLoad
	DC.L	$80080001,tLoad1
	DC.L	$80080009,TRD_dir
	DC.L	$8008000A,TRD_mask
	DC.L	$8008002E,1
	DC.L	0,0
	EVEN
InsSaveTags:
	DC.L	$80080012,tSave
	DC.L	$80080001,tSave1
	DC.L	$80080009,TRD_dir
	DC.L	$8008000A,TRD_mask
	DC.L	$8008002E,1
	DC.L	0,0
	EVEN
InsSaveZxScrTags:
	DC.L	$80080012,tSave
	DC.L	$80080001,tSaveZxScr
	DC.L	$80080009,SCR_dir
	DC.L	$8008000A,SCR_mask
	DC.L	$8008002E,1
	DC.L	0,0
	EVEN
InsSaveTZXinfoTags:
	DC.L	$80080012,tSave
	DC.L	$80080001,tSaveTZXinfo
	DC.L	$80080009,TFI_dir
	DC.L	$8008000A,TFI_mask
	DC.L	$8008002E,1
	DC.L	0,0
	EVEN
InsSaveFrzTags:
	DC.L	$80080012,tSave
	DC.L	$80080001,tSaveFRZ
	DC.L	$80080009,FRZ_dir
	DC.L	$8008000A,FRZ_mask
	DC.L	$8008002E,1
	DC.L	0,0
	EVEN
InsLoadFrzTags:
	DC.L	$80080012,tLoad
	DC.L	$80080001,tLoadFRZ
	DC.L	$80080009,FRZ_dir
	DC.L	$8008000A,FRZ_mask
	DC.L	$8008002E,1
	DC.L	0,0
	EVEN
InsInsertHBTags:
	DC.L	$80080012,tLoad
	DC.L	$80080001,tInsertHOB
	DC.L	$80080009,HOB_dir
	DC.L	$8008000A,HOB_mask
	DC.L	$8008002E,1
	DC.L	0,0
	EVEN
InsLoadTapTags:
	DC.L	$80080012,tLoad
	DC.L	$80080001,tTap1
	DC.L	$80080009,TAP_dir
	DC.L	$8008000A,TAP_mask
	DC.L	$8008002E,1
	DC.L	0,0
	EVEN
InsLoadSNATags:
	dc.l	$80080012,tLoad
	dc.l	$80080001,tSNA
	dc.l	$80080009,SNA_dir
	dc.l	$8008000A,SNA_mask
	dc.l	$8008002E,1
	dc.l	0,0
	even

;========================================================
;	Config file
;========================================================

ConfigFile:
	dc.l	"ZeCf"
SNA_dir:
	dc.b	"PROGDIR:SNAPSHOT",0
	ds.b	239
	even
TRD_dir:
	dc.b	"PROGDIR:TRD",0
	ds.b	244
	even
TAP_dir:
	dc.b	"PROGDIR:TAPE",0
	ds.b	243
;
saveVTOTAL:
	dc.w	320
RefreshMode:
	dc.w	0
ScreenMode:
	dc.l	0
SCR_dir:
	dc.b	"PROGDIR:SCR",0
	ds.b	244
FRZ_dir:
	dc.b	"PROGDIR:FROZEN",0
	ds.b	241
JoyMode:
	dc.w	0
JoyKeys:
	dc.b	"OPQAM",0
WaitKBD?:
	dc.w	0
HOB_dir:
	dc.b	"PROGDIR:HOBETA",0
	ds.b	241
BRD?:
	dc.w	0
TFI_dir:
	dc.b	"PROGDIR:TAPE",0
	ds.b	243
MemoryMask:
	dc.l	$0807C000
MemoryMask2:
	dc.l	$403FC000
LenConfig	equ	*-ConfigFile

;==========================================================

ConfigName:
	dc.b	"S:CBSpeccy.config",0
	even
LoadCFG:			; reload Config from menu.
	MOVE.L	InsReqBase,A0
	MOVE.L	_AslBase,A6
	JSR	-$36(A6)	; FreeAslRequest.
	jsr	CloseEmulWindow
	jsr	CloseDownScreen
	bra	CLI
;
LoadConfig:			; load Config on StartUp.
	move.l	#ConfigName,d1
	move.l	#1005,d2
	CALLDOS	Open
	move.l	d0,d7
	tst.l	d0
	beq.s	.1
	subq.l	#4,a7
	move.l	a7,d2
	move.l	d7,d1
	move.l	#4,d3	
	CALLDOS	Read
	cmp.l	#"ZeCf",(a7)+
	bne.s	.2
	move.l	#ConfigFile+4,d2
	move.l	d7,d1
	move.l	#LenConfig,d3	
	CALLDOS	Read
.2:
	move.l	d7,d1
	CALLDOS	Close
.1:
	rts

SaveConfig:			; Save config
	move.l	#ConfigName,d1
	move.l	#1006,d2
	CALLDOS	Open
	move.l	d0,d7
	tst.l	d0
	beq.s	.1
	move.l	#ConfigFile,d2
	move.l	d7,d1
	move.l	#LenConfig,d3	
	CALLDOS	Write
	move.l	d7,d1
	CALLDOS	Close
.1:
	bra	MenuLoop

;==========================================================

TRD_mask:
	dc.b	"#?.(trd|dsk|TRD|DSK)",0
	even
TFI_mask:
	dc.b	"#?.(tfi|TFI)",0
	even
SNA_mask:
	dc.b	"#?.(sna|z80|SNA|Z80|snapshot)",0
	even
TAP_mask:
	dc.b	"#?.(tap|TAP|tzx|TZX)",0
	even
SCR_mask:
	dc.b	"#?.(scr|SCR)",0
	even
FRZ_mask:
	dc.b	"#?.(frz|FRZ)",0
	even
HOB_mask:
	dc.b	"#?.($#?|!#?|SCL)",0
	even
tTap1:
	dc.b	"Load TAP/TZX file...",0,0
tSNA:
	dc.b	"Load Snapshot...",0,0
tLoad:
	DC.B	"Load",0,0
tLoad1:
	DC.B	"Load TRD file...",0,0
tSave:
	DC.B	"Save",0,0
tSave1:
	DC.B	"Save TRD file...",0,0
	even
tSaveZxScr:
	DC.B	"Save ZX Screen file...",0,0
	even
tSaveTZXinfo:
	DC.B	"Save TZX/TAP file info...",0,0
	even
tSaveFRZ:
	DC.B	"Save Frozen file...",0,0
	even
tLoadFRZ:
	DC.B	"Load Frozen file...",0,0
	even
tInsertHOB:
	DC.B	"Insert HOBETA/SCL file...",0,0
	even
;
	ds.b	4
FileName:
	ds.b	256

;==========================================================

GenFName:
	LEA	FileName(PC),A1
	MOVE.W	#$100-1,D0
	MOVE.L	8(A2),A0
	TST.B	(A0)
	BEQ.S	.1
	BSR.s	.2
	SUBQ	#1,A1
	CMP.B	#":",-1(A1)
	BEQ.S	.1
	MOVE.B	#"/",(A1)+
.1:
	MOVE.W	#$100-1,D0
	MOVE.L	4(A2),A0
	move.l	a0,tzxfname
.2:
	MOVE.B	(A0)+,(A1)+
	DBEQ	D0,.2
	RTS
;
StorePath:
	MOVE.W	#$100-1,D0
	MOVE.L	8(A2),A2
.2:
	MOVE.B	(A2)+,(A0)+
	DBEQ	D0,.2
	RTS


;=============================================
;	Load TR-DOS Disk A from file...
;=============================================

Get_TRDA:
	MOVE.L	InsReqBase,A0
	LEA	InsLoadTags,A1
	MOVE.L	_AslBase,A6
	JSR	-$3C(A6)	; RequestFile.
	TST.L	D0
	BEQ	MenuLoop
	MOVE.L	InsReqBase,A2
	bsr.s	GenFName
	lea	TRD_dir(pc),a0
	bsr.s	StorePath
	move.l	#FileName,d1
	move.l	#1005,d2
	CALLDOS	Open
	move.l	d0,d7
	tst.l	d0
	beq	NoFile
;
	move.l	#DSKbuf,d2
	move.l	d7,d1
	move.l	#4096*160,d3	
	CALLDOS	Read
	move.l	d7,d1
	CALLDOS	Close
	clr.w	Change_TRDA
	move.l	EmulNGads+GD_dskA*30,d0
	bsr	PrintFNAME
	bra	MenuLoop


;=============================================
;	Load TR-DOS Disk B from file...
;=============================================

Get_TRDB:
	MOVE.L	InsReqBase,A0
	LEA	InsLoadTags,A1
	MOVE.L	_AslBase,A6
	JSR	-$3C(A6)	; RequestFile.
	TST.L	D0
	BEQ	MenuLoop
	MOVE.L	InsReqBase,A2
	bsr	GenFName
	lea	TRD_dir(pc),a0
	bsr	StorePath
	move.l	#FileName,d1
	move.l	#1005,d2
	CALLDOS	Open
	move.l	d0,d7
	tst.l	d0
	beq	NoFile
;
	move.l	#DSKbuf+4096*160,d2
	move.l	d7,d1
	move.l	#4096*160,d3	
	CALLDOS	Read
	move.l	d7,d1
	CALLDOS	Close
	clr.w	Change_TRDB
	move.l	EmulNGads+GD_dskB*30,d0
	bsr	PrintFNAME
;
	bra	MenuLoop


;=============================================
;	Save TR-DOS Disk A -> File...
;=============================================

Save_TRDA:
	MOVE.L	InsReqBase,A0
	LEA	InsSaveTags,A1
	MOVE.L	_AslBase,A6
	JSR	-$3C(A6)	; RequestFile.
	TST.L	D0
	BEQ	MenuLoop
	MOVE.L	InsReqBase,A2
	bsr	GenFName
	move.l	#FileName,d1
	move.l	#1006,d2
	CALLDOS	Open
	move.l	d0,d7
	tst.l	d0
	beq	NoFile
;
	move.l	#DSKbuf,d2
	move.l	d7,d1
	move.l	#4096*160,d3	
	CALLDOS	Write
	move.l	d7,d1
	CALLDOS	Close
	clr.w	Change_TRDA
	move.l	EmulNGads+GD_dskA*30,d0
	bsr	PrintFNAME
	bra	MenuLoop

;=============================================
;	Save TR-DOS Disk B -> File...
;=============================================

Save_TRDB:
	MOVE.L	InsReqBase,A0
	LEA	InsSaveTags,A1
	MOVE.L	_AslBase,A6
	JSR	-$3C(A6)	; RequestFile.
	TST.L	D0
	BEQ	MenuLoop
	MOVE.L	InsReqBase,A2
	bsr	GenFName
	move.l	#FileName,d1
	move.l	#1006,d2
	CALLDOS	Open
	move.l	d0,d7
	tst.l	d0
	beq	NoFile
;
	move.l	#DSKbuf+4096*160,d2
	move.l	d7,d1
	move.l	#4096*160,d3	
	CALLDOS	Write
	move.l	d7,d1
	CALLDOS	Close
	clr.w	Change_TRDB
	move.l	EmulNGads+GD_dskB*30,d0
	bsr	PrintFNAME
	bra	MenuLoop
;
Change_TRDA:
	dc.w	0
Change_TRDB:
	dc.w	0


;=============================================
;	Save Active ZX Screen
;=============================================

Save_ZX_Screen:
	MOVE.L	InsReqBase,A0
	LEA	InsSaveZxScrTags,A1
	MOVE.L	_AslBase,A6
	JSR	-$3C(A6)	; RequestFile.
	TST.L	D0
	BEQ	MenuLoop
	MOVE.L	InsReqBase,A2
	bsr	GenFName
	lea	SCR_dir(pc),a0
	bsr	StorePath
	move.l	#FileName,d1
	move.l	#1006,d2
	CALLDOS	Open
	move.l	d0,d7
	tst.l	d0
	beq	NoFile
;
	move.l	Pages,d2
	btst	#3,Copy7FFD+1	; Check Screen 1 or 2?
	beq.s	.1
	add.l	#$4000*7,d2
.1:
	add.l	#$4000,d2
	move.l	d7,d1
	move.l	#6912,d3	
	CALLDOS	Write
	move.l	d7,d1
	CALLDOS	Close
	bra	MenuLoop


;=============================================
;	Save TAP/TZX info....
;=============================================
tmpFileName:
	dc.b	"con:",0
	even
SaveTZXinfo:
	move.l	TAP_base,a4
	cmp.l	#"ZXTa",(a4)
	bne	NoFile
	cmp.l	#"pe!"*256+$1a,4(a4)
	bne	NoFile
;
	MOVE.L	InsReqBase,A0
	LEA	InsSaveTZXinfoTags,A1
	MOVE.L	_AslBase,A6
	JSR	-$3C(A6)	; RequestFile.
	TST.L	D0
	BEQ	MenuLoop
	MOVE.L	InsReqBase,A2
	bsr	GenFName
	lea	TFI_dir(pc),a0
	bsr	StorePath
	move.l	#FileName,d1
	move.l	#1006,d2
	CALLDOS	Open
	move.l	d0,d7
	tst.l	d0
	beq	NoFile
;
	bsr.s	GenInfoFile
;
	move.l	d7,d1
	CALLDOS	Close
	bra	MenuLoop
;
TPrint:	macro
;
	move.l	#\@text,d2
	move.l	#\@len,d3
	move.l	d7,d1
	CALLDOS	Write
	bra.w	\@ret
\@text:
	dc.b	\1\2\3\4\5\6\7\8\9
\@len	equ	*-\@text
	even
\@ret:
	endm
;
GenInfoFile:
	move.l	#"0000",filenum-3
	clr.l	InfoBlockCNT
	move.l	TAP_base,a4
	addq.l	#8,a4
;
	TPrint	'Major, version:, '
	clr.l	d0
	move.b	(a4)+,d0
	bsr	PrintDec
;
	TPrint	10
	TPrint	'Minor, version:, '
	clr.l	d0
	move.b	(a4)+,d0
	bsr	PrintDec
	TPrint	10
;
GenInfo_loop:
	clr.l	d0
	move.b	(a4)+,d0
;
	lea	InfoJumps-4(pc),a3
	moveq	#InfoJumpsNum-1,d6
.1:
	addq.l	#4,a3
	cmp.l	(a3)+,d0
	dbeq	d6,.1
	tst.w	d6
	bmi.s	GenInfoEnd
	bsr	PrintNBlock
	pea	GenInfo_loop(pc)
	jmp	([a3])
GenInfoEnd:
	rts
;
InfoJumps:
	dc.l	$10,InfoBlock10
	dc.l	$11,InfoBlock11
	dc.l	$12,InfoBlock12
	dc.l	$13,InfoBlock13
	dc.l	$14,InfoBlock14
	dc.l	$15,InfoBlock15
	dc.l	$20,InfoBlock20
	dc.l	$21,InfoBlock21
	dc.l	$22,InfoBlock22
	dc.l	$23,InfoBlock23
	dc.l	$24,InfoBlock24
	dc.l	$25,InfoBlock25
	dc.l	$26,InfoBlock26
	dc.l	$27,InfoBlock27
	dc.l	$28,InfoBlock28
	dc.l	$2A,InfoBlock2A
	dc.l	$30,InfoBlock30
	dc.l	$31,InfoBlock31
	dc.l	$32,InfoBlock32
	dc.l	$33,InfoBlock33
	dc.l	$35,InfoBlock35
InfoJumpsNum	equ	(*-InfoJumps)/8
;
PrintNBlock:
	addq.l	#1,InfoBlockCNT
	TPrint	'Block, #'
	move.l	InfoBlockCNT,d0
	bsr	PrintDec
	TPrint	':, '
	rts
;
InfoBlockCNT:
	dc.l	0
;
PrintSize:
	move.l	d0,d6
	TPrint	'Block, size:, '
	move.l	d6,d0
	bsr.s	PrintDec
	TPrint	10
	TPrint	10
	rts
;
PrintDec:
	lea	DecBuf(pc),a5
	move.l	a5,d2
	move.l	#1000000000,d3
.1:
	divul.l	d3,d1:d0
	beq.s	.2
	add.b	#"0",d0
	move.b	d0,(a5)+
	bra.s	.3
.2:
	move.l	d1,d0
	divu.l	#10,d3
	cmp.l	#1,d3
	bne.s	.1
	add.b	#"0",d0
	move.b	d0,(a5)+
	move.l	a5,d3
	sub.l	d2,d3
	bra.w	dskwrite	
.4:
	divul.l	d3,d1:d0
	add.b	#"0",d0
	move.b	d0,(a5)+
.3:
	move.l	d1,d0
	divu.l	#10,d3
	cmp.l	#1,d3
	bne.s	.4
	add.b	#"0",d0
	move.b	d0,(a5)+
	move.l	a5,d3
	sub.l	d2,d3
	bra.w	dskwrite	
DecBuf:
	ds.b	16
;
InfoBlock10:
	TPrint	'Standart, speed, data, block.'
	TPrint	10
	clr.l	d0
	move.w	2(a4),d0
	move.l	a4,CurFileAdr
	rol.w	#8,d0
	move.w	d0,DataLen+2
	add.l	d0,a4
	addq.l	#4,a4
;	bsr.s	SaveData
	bra	PrintSize
SaveData:
	movem.l	d0-d7/a0-a6,-(a7)
	move.l	#DataName,d1
	move.l	#1006,d2
	CALLDOS	Open
	tst.l	d0
	beq.s	.1
	move.l	d0,d7
;
	clr.l	d0
	move.l	#filenum,a0
	move.b	(a0),d0
	addq.b	#1,d0
	cmp.b	#":",d0
	bne.s	.2
	move.b	#"0",d0
	addq.b	#1,-1(a0)
.2:
	move.b	d0,(a0)
;
	move.l	CurFileAdr,a0
	lea	5(a0),a0	; normal 5!!!
	move.l	a0,d2
	move.l	d7,d1
	move.l	DataLen,d3
	subq.l	#2,d3
	CALLDOS	Write
	move.l	d7,d1
	CALLDOS	Close
.1:
	movem.l	(a7)+,d0-d7/a0-a6
	rts

CurFileAdr:
	dc.l	0
DataLen:
	dc.l	0
DataName:
	dc.b	"Ram:file0000",0
filenum	equ	*-2
	even
;
InfoBlock11:
	TPrint	'Turbo, loading, data, block.'
	TPrint	10
	clr.l	d0
	move.b	$11(a4),d0
	lsl.l	#8,d0
	move.b	$10(a4),d0
	lsl.l	#8,d0
	move.b	$0f(a4),d0
	add.l	d0,a4
	lea	$12(a4),a4
	bra	PrintSize
;
InfoBlock12:
	TPrint	'Pure, tone.'
	addq.l	#4,a4
	TPrint	10
	TPrint	10
	rts
;
InfoBlock13:
	TPrint	'Sequence, of, pulses, of, different, lengths.'
	TPrint	10
	clr.l	d0
	move.b	(a4),d0
	move.l	d0,d1
	lsl.l	#1,d1
	addq.l	#1,d1
	add.l	d1,a4
	bra	PrintSize
;
InfoBlock14:
	TPrint	'Pure, data, block.'
	TPrint	10
	clr.l	d0
	move.b	$9(a4),d0
	lsl.l	#8,d0
	move.b	$8(a4),d0
	lsl.l	#8,d0
	move.b	$7(a4),d0
	add.l	d0,a4
	lea	$0a(a4),a4
	bra	PrintSize
;
InfoBlock15:
	TPrint	'Direct, recording.'
	TPrint	10
	clr.l	d0
	move.b	$7(a4),d0
	lsl.l	#8,d0
	move.b	$6(a4),d0
	lsl.l	#8,d0
	move.b	$5(a4),d0
	add.l	d0,a4
	lea	$08(a4),a4
	bra	PrintSize
;
InfoBlock20:
	clr.l	d0
	move.w	(a4)+,d0
	tst.w	d0
	beq.s	ib21
	TPrint	'Pause, ,'
	rol.w	#8,d0
	divu	#1000,d0
	bsr	PrintDec	
	bra.s	ib22
ib21:	
	TPrint	'Stop, the, tape.'
ib22:
	TPrint	10
	TPrint	10
	rts
;
InfoBlock21:
	TPrint	'Group, <'
	clr.l	d3
	move.b	(a4)+,d3
	move.l	a4,d2
	add.l	d3,a4
	bsr	dskwrite
	TPrint	'>, start.'
	TPrint	10
	TPrint	10
	rts
InfoBlock22:
	TPrint	'Group, end.'
	TPrint	10
	TPrint	10
	rts
InfoBlock23:
	TPrint	'Jump, to, block, #'
	clr.l	d0
	move.w	(a4)+,d0
	rol.w	#8,d0
	add.l	InfoBlockCNT,d0
	bsr	PrintDec
	TPrint	10
	TPrint	10
	rts
;
InfoBlock24:
	TPrint	'Loop, start., '
	clr.l	d0
	move.w	(a4)+,d0
	rol.w	#8,d0
	bsr	PrintDec
	TPrint	', repetition(s).'
	TPrint	10
	TPrint	10
	rts
;
InfoBlock25:
	TPrint	'Loop, end., '
	TPrint	10
	TPrint	10
	rts
InfoBlock26:
	TPrint	'Call, sequence, from, block, #'
	clr.l	d0
	move.w	(a4)+,d0
	rol.w	#8,d0
	move.l	d0,-(a7)
;
	clr.l	d0
	move.w	(a4)+,d0
	rol.w	#8,d0
	add.l	InfoBlockCNT,d0
	bsr	PrintDec
	TPrint	', with, '
	move.l	(a7)+,d0
	bsr	PrintDec
	TPrint	', repetition(s).'
	TPrint	10
	TPrint	10
	rts
;
InfoBlock27:
	TPrint	'Return, from, sequence.'
	TPrint	10
	TPrint	10
	rts
;
InfoBlock28:
	TPrint	'Select, block:'
	TPrint	10
	addq.l	#2,a4
	move.b	(a4)+,d6
InfoBlock28.1:
	TPrint	'Block, #'
	clr.l	d0
	move.w	(a4)+,d0
	rol.w	#8,d0
	add.l	InfoBlockCNT,d0
	bsr	PrintDec
	TPrint	':, <'
	clr.l	d3
	move.b	(a4)+,d3
	move.l	a4,d2
	add.l	d3,a4
	bsr	dskwrite
	TPrint	'>'
	TPrint	10
	subq.w	#1,d6
	bne	InfoBlock28.1
	TPrint	10
	TPrint	10
	rts
;
InfoBlock2A:
	addq.l	#4,a4
	TPrint	'Stop, tape, if, in, 48K, Mode.'
	TPrint	10
	TPrint	10
	rts
;
InfoBlock30:
	clr.l	d3
	move.b	(a4)+,d3
	move.l	a4,d2
	add.l	d3,a4
	bsr	dskwrite
	TPrint	10
	TPrint	10
	rts
;
;
InfoBlock31:
	TPrint	'Message:, Seconds, , '
	clr.l	d0
	move.b	(a4)+,d0
	bsr	PrintDec
	clr.l	d3
	move.b	(a4)+,d3
	move.l	a4,d2
	add.l	d3,a4
	bsr	dskwrite
	TPrint	10
	TPrint	10
	rts
;
InfoBlock32:
	TPrint	'Archive, Info.'
	TPrint	10
	addq.l	#2,a4
	clr.w	d6
	move.b	(a4)+,d6
InfoBlock32.1:
	clr.w	d0
	clr.l	d2
	move.b	(a4)+,d2
	addq.b	#1,d2
	move.l	#ArchTitlen,d3
	mulu	d3,d2
	add.l	#ArchTitles,d2
	bsr	dskwrite
	clr.l	d3
	move.b	(a4)+,d3
	move.l	a4,d2
	add.l	d3,a4
	bsr	dskwrite
	TPrint	10
	subq.w	#1,d6
	bne.s	InfoBlock32.1
	TPrint	10
	rts
;
ArchTitles:
	dc.b	'Comment(s)...................'
ArchTitlen	equ	*-ArchTitles
	dc.b	'Full Title...................'
	dc.b	'Software House / Publisher...'
	dc.b	'Author(s)....................'
	dc.b	'Year of publication..........'
	dc.b	'Language.....................'
	dc.b	'Game/Utility Type............'
	dc.b	'Price........................'
	dc.b	'Protection Scheme / Loader...'
	dc.b	'Origin.......................'
;
dskwrite:
	move.l	d7,d1
	CALLDOS	Write
	rts
;
InfoBlock33:
	clr.l	d0
	move.b	(a4)+,d0
	move.l	d0,d1
	add.l	d0,d0
	add.l	d1,d0
	add.l	d0,a4
	TPrint	'Hardware, type, block.'
	TPrint	10
	TPrint	10
	rts
;
InfoBlock35:
	TPrint	'Custom, info, block:,'
	move.l	a4,a5
	move.l	#IB35cb,a0
	move.l	a0,a1
	move.w	#2-1,d0		; now supported only 2 custom blocks
.1:
	cmp.l	(a5)+,(a1)+
	bne.s	.2
	cmp.l	(a5)+,(a1)+
	bne.s	.2
	cmp.l	(a5)+,(a1)+
	bne.s	.2
	cmp.l	(a5)+,(a1)+
	bne.s	.2
	cmp.b	#1,d0
	beq	IB35poke	; go to POKes block
	tst.b	d0
	beq.s	IB35inst	; go to Instructions block
	bra.s	.3
.2:
	move.l	a4,a5
	add.l	#$10,a0
	move.l	a0,a1
	dbra	d0,.1
.3:
	TPrint	'Not, supported, custom, block, !!!!!'
	rts
IB35cb:
	dc.b	"POKEs           "
	dc.b	"Instructions    "
;
IB35inst:			; Instructions block
	move.l	a4,d2
	move.l	#$10,d3
	bsr	dskwrite
	TPrint	10
	clr.l	d6
	move.b	$13(a4),d6
	lsl.l	#8,d6
	move.b	$12(a4),d6
	lsl.l	#8,d6
	move.b	$11(a4),d6
	lsl.l	#8,d6
	move.b	$10(a4),d6
	add.l	#$14,a4
	clr.l	d3
	move.l	a4,a5
ib351:
	subq.l	#1,d6
	addq.l	#1,d3
	move.b	(a5)+,d0
	cmp.b	#$d,d0
	bne.s	ib352
	move.l	a4,d2
	move.l	a5,a4
	subq.l	#1,d3
	beq.s	.1
	bsr	dskwrite
.1:
	TPrint	10
	clr.l	d3
ib352:
	tst.l	d6
	bne.s	ib351
	rts
;
IB35poke:			; POKes block
	move.l	a4,d2
	move.l	#$10,d3
	bsr	dskwrite
	TPrint	10
	clr.l	d6
	move.b	$13(a4),d6
	lsl.l	#8,d6
	move.b	$12(a4),d6
	lsl.l	#8,d6
	move.b	$11(a4),d6
	lsl.l	#8,d6
	move.b	$10(a4),d6
	add.l	d6,a4
	add.l	#$14,a4
	TPrint	10
	rts
;
	even
;=============================================
;	Save Frozen File...
;=============================================

Save_Frozen:
	MOVE.L	InsReqBase,A0
	LEA	InsSaveFrzTags,A1
	MOVE.L	_AslBase,A6
	JSR	-$3C(A6)	; RequestFile.
	TST.L	D0
	BEQ	MenuLoop
	MOVE.L	InsReqBase,A2
	bsr	GenFName
	lea	FRZ_dir(pc),a0
	bsr	StorePath
	move.l	#FileName,d1
	move.l	#1006,d2
	CALLDOS	Open
	move.l	d0,d7
	tst.l	d0
	beq	NoFile
;
	move.l	#Copy7FFD,d2
	move.l	d7,d1
	move.l	#30,d3	
	CALLDOS	Write
	move.l	#I,d2
	move.l	d7,d1
	move.l	#12,d3
	CALLDOS	Write
	move.l	Pages,d2
	add.l	#$4000,d2
	move.l	d7,d1
	move.l	#131072,d3	
	CALLDOS	Write
	move.l	d7,d1
	CALLDOS	Close
	bra	MenuLoop


;=============================================
;	Load Frozen File...
;=============================================

Load_Frozen:
	MOVE.L	InsReqBase,A0
	LEA	InsLoadFrzTags,A1
	MOVE.L	_AslBase,A6
	JSR	-$3C(A6)	; RequestFile.
	TST.L	D0
	BEQ	MenuLoop
	MOVE.L	InsReqBase,A2
	bsr	GenFName
	lea	FRZ_dir(pc),a0
	bsr	StorePath
	move.l	#FileName,d1
	move.l	#1005,d2
	CALLDOS	Open
	move.l	d0,d7
	tst.l	d0
	beq	NoFile
;
	move.l	#Copy7FFD,d2
	move.l	d7,d1
	move.l	#30,d3
	CALLDOS	Read
	move.l	#I,d2
	move.l	d7,d1
	move.l	#12,d3	
	CALLDOS	Read
	move.l	Pages,d2
	add.l	#$4000,d2
	move.l	d7,d1
	move.l	#131072,d3	
	CALLDOS	Read
	move.l	d7,d1
	CALLDOS	Close
;
	move.w	Copy7FFD,d0
	move.l	tree_base,a3
	lea	(PageTab,d0.w*8),a1
	move.l	2048(a1),p0000-Tree(a3)
	move.l	(a1),pC000-Tree(a3)
	bra	MenuLoop


;=============================================
;	Insert HOBETA File...
;=============================================

InsertHB1:				; Drive A
	lea	DSKbuf,a0
	bra.s	InsertHB
InsertHB2:
	lea	DSKbuf+4096*160,a0	; Drive B
InsertHB:
	move.l	a0,DrvDisp
;
	move.l	InsReqBase,a0
	lea	InsInsertHBTags,a1
	move.l	_AslBase,a6
	jsr	-$3c(a6)	; RequestFile.
	tst.l	D0
	beq	MenuLoop
	move.l	InsReqBase,A2
	bsr	GenFName
	lea	HOB_dir(pc),a0
	bsr	StorePath
	move.l	#FileName,d1
	move.l	#1005,d2
	CALLDOS	Open
	move.l	d0,d7
	tst.l	d0
	beq	NoFile
;
	move.l	#HOBheader,d2
	move.l	d7,d1
	move.l	#9,d3		; Load 9 bytes from Header...
	CALLDOS	Read
;
	lea	HOBheader,a5
	cmp.l	#"SINC",(a5)+	; Check SCL file header....
	beq	Insert_SCL
;
	move.l	#HOBheader+9,d2
	move.l	d7,d1
	move.l	#8,d3		; Load last 8 byte from HOBETA header...
	CALLDOS	Read
;
	move.l	DrvDisp,a0	; Insert Drive Disp -> a0
	lea	HOBheader,a1
	cmp.b	#127,$8e4(a0)	; How many files on disk?
	bcc	.1
	move.w	$8e5(a0),d6
	rol.w	#8,d6
	sub.w	$d(a1),d6	; How many FREE space on disk?
	bcs.s	.1
	rol.w	#8,d6
	move.w	d6,$8e5(a0)	;
	clr.l	d6
	move.b	$8e4(a0),d6
	lsl.w	#4,d6
	moveq.w	#12,d5		; Tranfer 13 bytes to DISK catalog...
.2:
	move.b	(a1)+,(a0,d6.w)
	addq.w	#1,d6
	dbra	d5,.2
	move.b	1(a1),(a0,d6.w)	; Transfer file lenght (in sectors)...
	move.w	$8e1(a0),1(a0,d6.w)	; Transfer first track & sector...
	addq.b	#1,$8e4(a0)	; Increase files counter...
;
	clr.l	d2
	move.b	$8e2(a0),d2
	lsl.w	#4,d2
	add.b	$8e1(a0),d2
	lsl.l	#8,d2
	add.l	a0,d2		; Load address...
;
	clr.l	d6
	move.b	$8e2(a0),d6
	lsl.w	#4,d6
	or.b	$8e1(a0),d6
	add.w	(a1),d6		; Add file lenght...
	rol.w	#4,d6
	ror.b	#4,d6
	rol.w	#8,d6
	move.w	d6,$8e1(a0)	; insert track & sector in sector 8...
;
	clr.l	d3
	move.w	(a1),d3
	rol.w	#8,d3		; File lenght...
;
	move.l	d7,d1
	CALLDOS	Read		; Read file body...
;
	cmp.l	#DSKbuf,DrvDisp
	bne.s	.3
	st	Change_TRDA	; Information on disk A changed...
	bra.s	.1
.3:
	st	Change_TRDB	; Information on disk B changed...
.1:
	move.l	d7,d1
	CALLDOS	Close
;
	bra	MenuLoop

DrvDisp:
	dc.l	0
HOBheader:
	ds.w	9


;=============================================
;	Insert SCL file...
;=============================================

Insert_SCL:
	cmp.l	#"LAIR",(a5)+	; Check last 4 bytes from header...
	bne	.1
	move.l	DrvDisp,a4	; Drive A or B?
	move.b	(a5),d6		; Get haw many files in SCL file....
	subq.b	#1,d6
	move.b	d6,d5
	add.b	$8e4(a4),d5
	cmp.b	#127,d5		; How many files on disk?
	bcc	.1
	move.b	d6,d5
	and.l	#$ff,d5
	move.b	$8e4(a4),d2
	and.l	#$ff,d2
	mulu	#16,d2
	add.l	a4,d2		; d2 = begin free space in catalog...
	move.l	d2,a3		; begin of new entryes in catalog.
.2:
	move.l	#14,d3
	move.l	d7,d1
	CALLDOS	Read		; read filenames in catalog...
	add.l	#16,d2
	dbra	d5,.2
;
	and.l	#$ff,d6
.3:
	move.b	13(a3),d5
	and.w	#$ff,d5
	move.w	$8e5(a4),d4
	rol.w	#8,d4
	sub.w	d5,d4
	bcs	.4		; if no more disk space;(
	rol.w	#8,d4
	move.w	d4,$8e5(a4)	; write new free space in sector 8...
	move.w	$8e1(a4),14(a3)	; Transfer first track & sector...
	addq.b	#1,$8e4(a4)	; Increase files counter...
;
	clr.l	d2
	move.b	$8e2(a4),d2
	lsl.w	#4,d2
	add.b	$8e1(a4),d2
	lsl.l	#8,d2
	add.l	a4,d2		; Load address...
;
	clr.l	d5
	move.b	$8e2(a4),d5
	lsl.w	#4,d5
	or.b	$8e1(a4),d5
	move.b	13(a3),d4
	and.w	#$ff,d4
	add.w	d4,d5		; Add file lenght...
	rol.w	#4,d5
	ror.b	#4,d5
	rol.w	#8,d5
	move.w	d5,$8e1(a4)	; insert track & sector in sector 8...
;
	clr.l	d3
	rol.w	#8,d4
	move.w	d4,d3		; file	lenght
;
	move.l	d7,d1
	CALLDOS	Read		; read file into disk...
;
	lea	16(a3),a3	; reposition on next file....


	cmp.l	#DSKbuf,DrvDisp
	bne.s	.5
	st	Change_TRDA	; Information on disk A changed...
	bra.s	.6
.5:
	st	Change_TRDB	; Information on disk B changed...
.6:
	dbra	d6,.3
.1:
	move.l	d7,d1
	CALLDOS	Close
;
	bra	MenuLoop
.4:
	clr.l	(a3)+
	clr.l	(a3)+
	clr.l	(a3)+
	clr.l	(a3)+
	dbra	d6,.4
	bra.s	.1


;=============================================
;	Load TAP/TZX file...
;=============================================

tzxfname:
	dc.l	0

Get_TAP:
	bsr	FreeTAP
	MOVE.L	InsReqBase,A0
	LEA	InsLoadTapTags,A1
	MOVE.L	_AslBase,A6
	JSR	-$3C(A6)		; RequestFile.
	TST.L	D0
	BEQ	MenuLoop
	MOVE.L	InsReqBase,A2
	bsr	GenFName
	lea	TAP_dir(pc),a0
	bsr	StorePath
	move.l	#FileName,d1
	move.l	#1005,d2
	CALLDOS	Open
	move.l	d0,d7
	tst.l	d0
	beq	NoFile
;
	move.l	#".tzx",d1
	move.l	#".TZX",d2
	move.l	tzxfname,a0
.2:
	cmp.l	(a0),d1
	bne.s	.5
	move.l	#".tfi",(a0)
	bra.s	.4
.5:
	cmp.l	(a0),d2
	bne.s	.3
	move.l	#".TFI",(a0)
	bra.s	.4
.3:
	addq.l	#1,a0
	tst.b	(a0)
	bne.s	.2
.4:
;
	move.l	d7,d1
	moveq.l	#0,d2
	moveq.l	#1,d3
	CALLDOS	Seek
;
	move.l	d7,d1
	move.l	#0,d2
	moveq.l	#-1,d3
	CALLDOS	Seek
;d0-size
	move.l	d0,TAP_size
	addq.l	#1,d0
	movea.l	4.w,a6
	moveq	#4,d1
	jsr	-$C6(a6)		; Alloc mem
	tst.l	d0
	beq	NoFile
	move.l	d0,TAP_base
	move.l	d0,TapDisp
	move.l	d0,TZXfilepnt		; Fix for TZX file...
	add.l	#10,TZXfilepnt		;
	move.l	#Pulses,PulsePNT		;
	move.w	#$ff,CurrentPulse
	clr.w	StartStop
	move.l	#$c0000000,MICtimer
	clr.l	Pulses
	clr.l	Pulses+4
;
	move.l	d0,d2
	move.l	d7,d1
	move.l	TAP_size,d3
	CALLDOS	Read
	move.l	d7,d1
	CALLDOS	Close
	move.l	EmulNGads+GD_tapF*30,d0
	bsr.s	PrintFNAME
;
	bra	MenuLoop
;
FreeTAP:
	move.l	TAP_base,a1
	tst.l	a1
	beq.s	.1
	movea.l	4.w,a6			; Free mem
	move.l	TAP_size,d0
	addq.l	#1,d0
	jsr	-$D2(a6)
.1:
	clr.l	TAP_base
	rts
;
TAP_base:
	dc.l	0
TAP_size:
	dc.l	0
;
NoFile:
	move.l	_IntuitionBase,a6
	jsr	-96(a6)
	bra	MenuLoop
;
GadsOnOff:
	MOVE.L	EmulWnd,A1
	tst.w	d0
	bne.s	.1
	moveq.l	#1,d0
	bra.s	.2
.1:
	moveq.l	#0,d0
.2:
	MOVE.L	D0,OnOffTAGS+4
	MOVE.L	(A0),A0
	SUB.L	A2,A2
	LEA	OnOffTAGS(PC),A3
	MOVE.L	_GadToolsBase(PC),A6
	JSR	-$2A(A6)
	RTS
	CNOP	0,4
OnOffTAGS:
	DC.L    $8003000E,1
	DC.L	0,0
;
PrintFNAME:
	add.l	#$5000D,d0
	move.l	d0,XTextXY
	lea	FileName(pc),a0
	move.l	a0,a1
	moveq	#29,d0
.1:
	tst.b	(a0)+
	dbeq	d0,.1
	bne.s	.3
	tst.w	d0
	bmi.s	.2
	move.b	#" ",-1(a0)
.4
	move.b	#" ",(a0)+
	dbra	d0,.4
	clr.b	-1(a0)
	bra.s	.2
.3:
	tst.b	(a0)+
	bne.s	.3
	lea	-31(a0),a1
	move.w	#"..",(a1)
	move.b	#".",2(a1)
.2:
	move.l	a1,XText+12
	move.l  EmulWnd,a0
	move.b  54(a0),d0
	ext.w   d0
	move.b  55(a0),d1
	ext.w   d1
	move.l  50(a0),a0
	lea	XText,a1
	move.l  _IntuitionBase,a6
	jmp	PrintIText(a6)
;
XText:
	DC.B    1,0
	DC.B    1
	DC.B    0
XTextXY:
	DC.W    101,199
	DC.L    topaz8
	DC.L    FileName
	DC.L    0
;
StartSNA:
	MOVE.L	InsReqBase,A0
	LEA	InsLoadSNATags,A1
	MOVE.L	_AslBase,A6
	JSR	-$3C(A6)	; RequestFile.
	TST.L	D0
	BEQ	MenuLoop
	MOVE.L	InsReqBase,A2
	bsr	GenFName
	lea	SNA_dir(pc),a0
	bsr	StorePath
	move.l	a1,d6
	move.l	#FileName,d1
	move.l	#1005,d2
	CALLDOS	Open
	move.l	d0,d7
	tst.l	d0
	beq	NoFile
;
	move.l	d7,d1
	moveq.l	#0,d2
	moveq.l	#1,d3
	CALLDOS	Seek
;
	move.l	d7,d1
	move.l	#0,d2
	moveq.l	#-1,d3
	CALLDOS	Seek
;d0-size
	move.l	d0,SNA_size
	movea.l	4.w,a6
	move.l	#1,d1
	jsr	-$C6(a6)	; Alloc mem
	tst.l	d0
	beq	NoFile
	move.l	d0,SNA_base
;
	move.l	d0,d2
	move.l	d7,d1
	move.l	SNA_size,d3
	CALLDOS	Read
	move.l	d7,d1
	CALLDOS	Close
	lea	aoxtab,a6
	move.l	d6,a0
	cmp.l	#".Z80",-5(a0)
	beq.s	.1
	cmp.l	#".z80",-5(a0)
	beq.s	.1
	jsr	LoadSNA
	bra.s	.2
.1:
	jsr	LoadZ80
.2:
	move.l	SNA_base,a1
	movea.l	4.w,a6			; Free mem
	move.l	SNA_size,d0
	jsr	-$D2(a6)
	jsr	StartEmul
	bra	MenuLoop
SNA_base:
	dc.l	0
SNA_size:
	dc.l	0
;
SetRMODE:
	move.l	d1,a0
	move.w	$56(a0),RMODEflg
	bra	MenuLoop
RMODEflg:
	dc.w	0

;==============================================
;
;	Game Cheater
;
;==============================================

IniCheat:
;
	bsr	FreeCheat
;
	move.w	SizeCheat,d0
	tst.w	d0
	beq	Cheat_free
;
	mulu	#22,d0
	move.l	d0,ViewLen
	movea.l	4.w,a6
	move.l	#1,d1
	jsr	-$C6(a6)		; Alloc mem
	move.l	d0,ViewBuf
	tst.l	d0
	beq	Cheat_free
	move.l	d0,a0
	move.l	a0,VList
	move.l	#VList,a1
	move.w	SizeCheat,d7
	subq.w	#1,d7
	lea	HEXtab,a6
	move.l	#$3fff,d0
	lea	CheatBitMap(pc),a2
.1:
	addq	#1,d0
	bftst	(a2){d0:1}
	beq.s	.1
	move.l	a0,(a0)
	add.l	#22,(a0)
	move.l	a1,4(a0)
	move.l	a0,a1
	addq.l	#8,a0
	clr.w	(a0)+
	move.l	a0,(a0)
	add.l	#4,(a0)+
;
	moveq	#3,d6
.2:
	rol.w	#4,d0
	move.b	d0,d1
	and.w	#$000f,d1
	move.b	(a6,d1.w),(a0)+
	dbra	d6,.2
	clr.w	(a0)+
	move.w	d0,(a0)+
;
	dbra	d7,.1
;
	lea	-22(a0),a0
	move.l	#VList+4,(a0)
	move.l	a0,VList+8
;
	move.l	(EmulGadgets+(GD_ChView*4)),A0
	MOVE.L	EmulWnd,A1
	SUB.L	A2,A2
	LEA	ViewTAGS(PC),A3
	MOVE.L	_GadToolsBase(PC),A6
	JSR	-$2A(A6)
	rts
;
	CNOP	0,4
ViewTAGS:
	DC.L	GTLV_Labels,VList
	DC.L	0,0
VList:
	dc.l	0,0,0
;
FreeCheat:
	move.l	ViewBuf,a1
	tst.l	a1
	beq.s	.1
	move.l	ViewLen,d0
	movea.l	4.w,a6			; Free mem
	jsr	-$D2(a6)
	clr.l	ViewBuf
.1:
	rts
;
SetCheatPoke:
	tst.l	ViewBuf
	beq	MenuLoop
	move.l	d1,a0
	move.l	$60(a0),a0
	move.w	$6(a0),d0
	move.w	d0,PokeAdrTAGS+6
	move.w	d0,POKE_ADR_S
	move.l	(EmulGadgets+(GD_POKE_ADR*4)),A0
	MOVE.L	EmulWnd,A1
	SUB.L	A2,A2
	LEA	PokeAdrTAGS(PC),A3
	MOVE.L	_GadToolsBase(PC),A6
	JSR	-$2A(A6)
	bra	MenuLoop
;
	CNOP	0,4
PokeAdrTAGS:
	DC.L	GTIN_Number,0
	dc.l	0,0
;
ViewBuf:
	dc.l	0
ViewLen:
	dc.l	0
;
Cheat_free:
	move.l	(EmulGadgets+(GD_ChView*4)),A0
	MOVE.L	EmulWnd,A1
	SUB.L	A2,A2
	LEA	ViewfreeTAGS(PC),A3
	MOVE.L	_GadToolsBase(PC),A6
	JSR	-$2A(A6)
	rts
	CNOP	0,4
ViewfreeTAGS:
	DC.L	GTLV_Labels,VL_free
	DC.L	0,0
;
VL_free:
	dc.l	VL_free0,0,VL_free0
;
VL_free0:
	dc.l	VL_free+4
	dc.l	VL_free
	dc.w	0
	dc.l	VL_free0t
;
VL_free0t:
	dc.b	"none",0,0
;
CheatStart:
	move.l	d1,a0
	move.l	gg_SpecialInfo(a0),a0
	move.l	si_LongInt(a0),d0
	cmp.w	#256,d0
	bcs.s	.3
	move.l	EmulWnd,a1
	move.l	d1,a0
	sub.l	a2,a2
	move.l	_IntuitionBase,a6
	jsr	-$1ce(a6)
	bra	MenuLoop
.3:
	lea	CheatBitMap(pc),a0
	move.l	Pages,a1
	move.l	#$4000,d1
	moveq	#0,d7
.1:
	bfclr	(a0){d1:1}
	cmp.b	(a1,d1.l),d0
	bne.s	.2
	bfset	(a0){d1:1}
	addq	#1,d7
.2:
	addq.w	#1,d1
	bne.s	.1
	move.w	d7,SizeCheat
	bsr	IniCheat
	bra	MenuLoop
;
CheatNext:
	move.l	d1,a0
	move.l	gg_SpecialInfo(a0),a0
	move.l	si_LongInt(a0),d0
	cmp.w	#256,d0
	bcs.s	.3
	move.l	EmulWnd,a1
	move.l	d1,a0
	sub.l	a2,a2
	move.l	_IntuitionBase,a6
	jsr	-$1ce(a6)
	bra	MenuLoop
.3:
	tst.w	SizeCheat
	beq	MenuLoop
	lea	CheatBitMap(pc),a0
	move.l	Pages,a1
	move.l	#$4000,d1
	moveq	#0,d7
.1:
	bftst	(a0){d1:1}
	beq.s	.2
	bfclr	(a0){d1:1}
	cmp.b	(a1,d1.l),d0
	bne.s	.2
	bfset	(a0){d1:1}
	addq	#1,d7
.2:
	addq.w	#1,d1
	bne.s	.1
	move.w	d7,SizeCheat
	bsr	IniCheat
	bra	MenuLoop
;
SizeCheat:
	dc.w	0
CheatBitMap	equ	*-2048
	ds.b	6144

;==============================================
;
; Keyboard compiler
;
;==============================================

KeyConfFile:
	dc.b	"S:CBSpeccy.keyboard",0
KeyConfFile2:
	dc.b	"PROGDIR:CBSpeccy.keyboard",0
	even
NoKBDFmess:
	dc.b	"Not found keyboard config file!",10
	dc.b	"Please place it in S: or PROGDIR:",10
Len_NoKBDFmess	equ	*-NoKBDFmess
	even
;
;
CompileKBD:
	move.l	#KeyConfFile,d1
	move.l	#1005,d2
	CALLDOS	Open
	tst.l	d0
	bne.s	.0
	move.l	#KeyConfFile2,d1
	move.l	#1005,d2
	CALLDOS	Open
	tst.l	d0
	bne.s	.0
;
	CALLDOS	Output
	move.l	d0,d1
	move.l	#NoKBDFmess,d2
	move.l	#Len_NoKBDFmess,d3
	CALLDOS	Write
	moveq	#0,d0
	rts
.0:
	move.l	d0,d7
;
	move.l	#DSKbuf,d2
	move.l	d7,d1
	move.l	#10000,d3	
	CALLDOS	Read
	move.l	d7,d1
	CALLDOS	Close
;
	lea	DSKbuf,a0
	lea	Ami2ZXkeytab,a1
	lea	8*128(a1),a2
	moveq	#127,d6
	moveq.w	#0,d7
.1:
	cmp.b	#"n",(a0)
	beq.s	.4
	bsr	IsKey
	beq.s	.6
	move.w	d0,(a1)
	bsr	IsKey
	beq.s	.2
	move.w	d0,2(a1)
	bsr.s	IsKey
	beq.s	.2
	move.w	d0,4(a1)
	bsr.s	IsKey
	beq.s	.2
	move.w	d0,6(a1)
.2:
	bsr.s	SkipSPC
	bsr.s	IsKey
	beq.s	.5
	move.w	d0,(a2)
	bsr.s	IsKey
	beq.s	.5
	move.w	d0,2(a2)
	bsr.s	IsKey
	beq.s	.5
	move.w	d0,4(a2)
	bsr.s	IsKey
	beq.s	.5
	move.w	d0,6(a2)
.5:
	addq.l	#8,a1
	addq.l	#8,a2
	dbra	d6,.6
	bra	OBcompile
.4:
	addq.l	#1,a0
	bra.s	.5
.6:
	bsr.s	EOL?
	beq	ERRcompile
	addq.w	#1,d7
	bra	.1
;
EOL?:
	bsr.s	SkipSPC
	cmp.b	#";",(a0)
	beq.s	.1
	cmp.b	#10,(a0)+
	beq.s	.2
	moveq	#0,d0
	rts
.1:
	bsr.s	SkipSPC
	cmp.b	#" ",(a0)+
	bcc.s	.1
.2:
	tst.b	(a0)
	rts
;
SkipSPC:
	move.b	(a0),d0
	cmp.b	#" ",d0
	beq.s	.1
	cmp.b	#9,d0
	beq.s	.1
	rts
.1:
	addq.l	#1,a0
	bra.s	SkipSPC
;
IsKey:
	move.b	(a0),d0
	cmp.b	#"s",d0
	beq.s	.2
	cmp.b	#"c",d0
	beq.s	.2
	cmp.b	#"e",d0
	beq.s	.2
	cmp.b	#"b",d0
	beq.s	.2
	cmp.b	#"0",d0
	bcs.s	.1
	cmp.b	#"9"+1,d0
	bcs.s	.2
	cmp.b	#"A",d0
	bcs.s	.1
	cmp.b	#"Z"+1,d0
	bcc.s	.1
.2:	
	addq.l	#1,a0
	lea	KeyTab(pc),a3
.3:
	cmp.b	(a3)+,d0
	bne.s	.3
	sub.l	#KeyTab,a3
	move.l	a3,d0
	rts
.1:
	moveq	#0,d0
	rts
KeyTab:
	dc.b	"cAQ10Peb"
	dc.b	"ZSW29OLs"
	dc.b	"XDE38IKM"
	dc.b	"CFR47UJN"
	dc.b	"VGT56YHB"
;
OBcompile:
	moveq	#-1,d0
	rts
ERRcompile:
	CALLDOS	Output
	move.l	d0,d1
	move.l	#ErrKBDFmess,d2
	move.l	#Len_ErrKBDFmess,d3
	CALLDOS	Write
	moveq	#0,d0
	rts
ErrKBDFmess:
	dc.b	"Error in keyboard config file!",10
Len_ErrKBDFmess	equ	*-ErrKBDFmess
	even
	moveq	#0,d0
	rts

;-----------------------------------------------
;
;	Draw Logo
;
;-----------------------------------------------

DrawLogo:
	MOVEQ	#0,D0
	MOVEQ	#0,D1
	move.l  Scr,a0
	move.l  40(a0),a1
	move.w  4(a1),D1
	MOVE.L	EmulWnd,A0
	MOVE.L	50(A0),A0
	LEA	DatCBLogo(pc),A1
	MOVE.L	_IntuitionBase,A6
	JSR	-114(A6)
	rts
	cnop	0,8
DatCBLogo:
	dc.w	108,7
xsize:
	dc.w	422,48
	dc.w	4
	dc.l	CBLogo
	dc.b	15,0
	dc.l	0
	cnop	0,16
;-----------------------------------------------
setrom_basic:
	move.l	#$3d003dff,-$14(a6)
	move.l	#trdos_flg+1,a0
	clr.b	(a0)
	tst.l	CPU?
	beq.s	.1
	cinvl	ic,(a0)
	move.l	mb040,a0
	lea	4*64*8*2+3(a0),a0
	move.l	a0,([mmu_base_up])
	pflushan
	rts
.1:
	opt	p=68030
	move.l	tree_base,a0
	move.l	Rom_48,p0000-Tree(a0)
	pflush	#0,#0,$00000000
	movec	cacr,d0
	or.w	#$808,d0
	movec	d0,cacr
	rts
	opt	p=68040
;
setrom_trdos:
	move.l	#$4000ffff,-$14(a6)
	move.l	#trdos_flg+1,a0
	move.b	#4,(a0)
	tst.l	CPU?
	beq.s	.1
	cinvl	ic,(a0)
	move.b	#4,trdos_flg+1
	move.l	mb040,a0
	lea	4*64*10*2+3(a0),a0
	move.l	a0,([mmu_base_up])
	pflushan
	rts
.1:
	opt	p=68030
	move.l	tree_base,a0
	move.l	TR_DOS,p0000-Tree(a0)
	pflush	#0,#0,$00000000
	movec	cacr,d0
	or.w	#$808,d0
	movec	d0,cacr
	rts
	opt	p=68040
;-----------------------------------------------
;
;	Macros for base commands
;
;-----------------------------------------------
;

jmpnext:macro			; Goto next instruction
	sub.w	#\1,d6		; Command timing
	ble.s	.Next1
	move.b	(a5)+,d0
	lsl.w	#8,d0
	jmp	(a4,d0.w)
.Next1:
	jmp	(a1)
	cnop	0,16
	ds.w	7
	endm


jmpnextd1:	macro		; Goto next instruction
	sub.w	d1,d6		; Command timing
	ble.s	.Next11
	move.b	(a5)+,d0
	lsl.w	#8,d0
	jmp	(a4,d0.w)
.Next11:
	jmp	(a1)
	cnop	0,16
	ds.w	7
	endm


round:	macro
	ds.b	256-(*-roundlast)
roundlast	set	*
	endm


POKE:	macro			; LD	(NNNN),??
	move.w	(a5)+,d0
	rol.w	#8,d0
	move.w	d0,a0
	move.w	\1,d0
	rol.w	#8,d0
	move.w	d0,(a0)
	endm


PEEK:	macro			; LD	??,(NNNN)
	move.w	(a5)+,d0
	rol.w	#8,d0
	move.w	d0,a0
	move.w	1(a0),\1
	move.b	(a0),\1
	endm


RET_PR:	macro			; RET
	move.w	(a2)+,d0
	rol.w	#8,d0
	move.w	d0,a5
	move.w	a2,a2
	cmp2.w	-$14(a6),a5
	bcs.s	.3
.1:
	tst.b	trdos_flg+1
	beq.s	.2
	jsr	setrom_basic
	bra.s	.3
.2:
	btst.b	#4,Copy7FFD+1
	beq.s	.3
	jsr	setrom_trdos
.3:
	endm


PUSH:	macro			; PUSH	??
	move.w	\1,d0
	rol.w	#8,d0
	move.w	d0,-(a2)
	move.w	a2,a2
	endm


POP:	macro			; POP	??
	move.w	(a2)+,\1
	rol.w	#8,\1
	move.w	a2,a2
	endm


JP_PR:	macro			; JP ????
	move.w	1(a5),d0
	move.b	(a5),d0
	move.w	d0,a5
	cmp2.w	-$14(a6),a5
	bcs.s	.3
	tst.b	trdos_flg+1
	beq.s	.2
	jsr	setrom_basic
	bra.s	.3
.2:
	btst.b	#4,Copy7FFD+1
	beq.s	.3
	jsr	setrom_trdos
.3:
	endm


CALL_PR:macro			; CALL ????
	move.w	(a5)+,d1
	rol.w	#8,d1
	move.w	a5,d0
	rol.w	#8,d0
	move.w	d0,-(a2)
	move.w	d1,a5
	clr.l	d1
	move.w	a2,a2
	cmp2.w	-$14(a6),a5
	bcs.s	.3
	tst.b	trdos_flg+1
	beq.s	.2
	jsr	setrom_basic
	bra.s	.3
.2:
	btst.b	#4,Copy7FFD+1
	beq.s	.3
	jsr	setrom_trdos
.3:
	endm


RST:	macro			; RST ??
	move.w	a5,d0
	rol.w	#8,d0		
	move.w	d0,-(a2)	; PC -> (SP)
	move.w	a2,a2	
	move.w	#\1,a5
	endm


DI:	macro
	clr.w	-8(a6)			; 0 -> IFF1
	clr.w	-$a(a6)			; 0 -> IFF2
	endm


EI:	macro
	move.w	#$0004,-8(a6)		; 4 -> IFF1
	move.w	#$0004,-$a(a6)		; 4 -> IFF2
	endm


IM:	macro
	move.w	#\1,-$c(a6)
	jmpnext	8
	endm


;
;	Init Emulator...
;

HorizontalIntPos	equ	48
;
IniEmul:
	tst.w	FirstRun
	beq.s	FRun
	rts
FirstRun:
	dc.w	0
FRun:
	st	FirstRun
;
	moveq	#0,d5
	move.l	#Z2Ptab+4*$8000,a0
.1:
	move.l	d5,d7
	btst	#7+8,d7
	beq.s	.0
	move.w	d7,d0
	move.w	d7,d1
	and.w	#%0011100000000000,d0
	and.w	#%0000011100000000,d1
	lsr.w	#3,d0
	lsl.w	#3,d1
	and.w	#%1100000011111111,d7
	or.w	d0,d7
	or.w	d1,d7
.0:
	moveq	#0,d0
	moveq	#0,d1
	moveq	#0,d2
	moveq	#0,d3
;
	btst	#6+8,d7
	beq.s	.2
	moveq	#-1,d3
.2:
	btst	#0+8,d7
	beq.s	.3
	move.b	d7,d0
.3:
	btst	#1+8,d7
	beq.s	.4
	move.b	d7,d1
.4:
	btst	#2+8,d7
	beq.s	.5
	move.b	d7,d2
.5:
	move.b	d7,d6
	not.b	d6
;
	btst	#3+8,d7
	beq.s	.6
	or.b	d6,d0
.6:
	btst	#4+8,d7
	beq.s	.7
	or.b	d6,d1
.7:
	btst	#5+8,d7
	beq.s	.8
	or.b	d6,d2
.8:
;
	move.b	d0,0(a0,d5.w*4)
	move.b	d1,1(a0,d5.w*4)
	move.b	d2,2(a0,d5.w*4)
	move.b	d3,3(a0,d5.w*4)
	add.w	#1,d5
	bne.s	.1
;
	move.l	#cmd_buf,d0
	and.l	#$ffffff00,d0
	add.l	#$000000fe,d0
	move.l	d0,a0
	add.l	#$00008000,d0
	move.l	d0,cmd_base
	move.l	d0,cmd_base1
	lea	addab,a1
	moveq	#-1,d0
inicmd:
	move.b	(a1)+,(a0)+
	dbra	d0,inicmd
;
	addq.l	#2,a0
	move.l	a0,next_base
;
	lea	cbtab,a0
	moveq	#3,d7
.1:
	move.w	#$ff,d6
.2:
	move.l	(a0),$400(a0)
	add.l	#2,(a0)+
	dbra	d6,.2
	lea	$400(a0),a0
	dbra	d7,.1
;
	lea	outtab+131072,a0
	moveq	#0,d7
iniout:
	move.l	#out1F,d0
	cmp.b	#$1f,d7
	beq.s	iniout1
	move.l	#out3F,d0
	cmp.b	#$3f,d7
	beq.s	iniout1
	move.l	#out5F,d0
	cmp.b	#$5f,d7
	beq.s	iniout1
	move.l	#out7F,d0
	cmp.b	#$7f,d7
	beq.s	iniout1
	move.l	#outFF,d0
	cmp.b	#$ff,d7
	beq.s	iniout1
	move.l	#OutFE,d0
	cmp.b	#$fe,d7
	beq.s	iniout1
	move.l	#noout,d0
	btst	#1,d7
	bne.s	iniout1
	btst	#15,d7
	beq.s	iniout2
	move.l	#OutAYreg,d0
	btst	#14,d7
	bne.s	iniout1
	move.l	#OutAYdat,d0
	bra.s	iniout1
iniout2:
	move.l	#Out7FFD,d0
iniout1:
	move.l	d0,(a0,d7.w*4)
	addq.w	#1,d7
	bne.s	iniout
;
	lea	KeyRoutines,a0
	lea	KeyRpnt,a1
	moveq	#0,d7
.1:
	move.l	a0,(a1)+
;
	lea	GetMICproc,a2
	moveq	#LenGetMICproc-1,d6
.4:
	move.b	(a2)+,(a0)+
	dbra	d6,.4
	moveq	#7,d6
.2:
	btst	d6,d7
	bne.s	.3
	move.w	#$c039,(a0)+
	lea	(KeyBuf,d6.w),a2
	move.l	a2,(a0)+
.3:
	dbra	d6,.2
	move.l	#$122dffff,(a0)+
	move.l	#$4ef015b1,(a0)+
	move.l	#inrettab,(a0)+
	add.b	#1,d7
	bne.s	.1
;
	lea	intab+131072,a0
	moveq	#0,d7
iniin:
;
	move.l	#inFADF,d0
	cmp.w	#$FADF,d7
	beq	iniin1
	move.l	#inFBDF,d0
	cmp.w	#$FBDF,d7
	beq.s	iniin1
	move.l	#inFFDF,d0
	cmp.w	#$FFDF,d7
	beq.s	iniin1
;
	move.l	#in1F,d0
	cmp.b	#$1f,d7
	beq.s	iniin1
	move.l	#in3F,d0
	cmp.b	#$3f,d7
	beq.s	iniin1
	move.l	#in5F,d0
	cmp.b	#$5f,d7
	beq.s	iniin1
	move.l	#in7F,d0
	cmp.b	#$7f,d7
	beq.s	iniin1
	move.l	#inFF,d0
	cmp.b	#$ff,d7
	beq.s	iniin1
	move.w	d7,d0
	lsr.w	#8,d0
	move.l	(KeyRpnt,d0.w*4),d0
	btst	#0,d7
	beq.s	iniin1
	btst	#1,d7
	bne.s	iniin2
	btst	#15,d7
	beq.s	iniin2
	move.l	#AYin,d0
	btst	#14,d7
	bne.s	iniin1	
iniin2:
;
	move.l	#noin,d0
iniin1:
	move.l	d0,(a0,d7.w*4)
	addq.w	#1,d7
	bne	iniin
;==========================================================
	move.w	#$0000,d0
	move.l	next_base,a1
	move.w	#191,d7
inin1:
	move.w	d0,d1
	move.w	d1,d2
	rol.w	#8,d2
	lsr.b	#3,d2
	and.b	#7,d2
	or.b	#$18,d2
	rol.w	#8,d2
	moveq	#7,d6
inin2:
	lea	xNext0,a0
	move.w	d1,imod1(a0)
	move.w	d2,imod2(a0)
	move.w	#16,imod3(a0)
;
	move.w	#xLen-1,d5
inin3:
	move.b	(a0)+,(a1)+
	dbra	d5,inin3
;
	add.l	#16,imod4+xNext0
;
	addq.w	#4,d1
	addq.w	#4,d2
	dbra	d6,inin2
	move.w	#96+16,imod3-xLen(a1)
	add.l	#96,imod4+xNext0
;
	rol.w	#8,d0
	add.b	#1,d0
	move.b	d0,d1
	rol.w	#8,d0
	and.b	#7,d1
	bne.s	inin4
	add.b	#32,d0
	bcs.s	inin4
	sub.w	#$800,d0
inin4:
	dbra	d7,inin1
	move.l	imod4+xNext0,d0
	add.l	#48*224-HorizontalIntPos,d0
	lea	imod4(a1),a0
	move.l	d0,(a0)
	move.l	a0,ADR_DownFEticks
;
	move.w	#48*224+16+96-HorizontalIntPos,imod3-xLen(a1)
	lea	imod3-xLen(a1),a0
	move.l	a0,ADR_DownTicks
;
	move.w	#$4ef9,(a1)+
	move.l	#Next,(a1)+
;
	move.l	next_base,a0
	move.l	a0,a1
	add.l	#xLen*193*8,a1
	move.l	a1,next_base1
	move.w	#xLen*193*2-1,d7
.1:
	move.l	(a0)+,(a1)+
	dbra	d7,.1
;==========================================================
	lea	RRDit,a0
	lea	Flags4RxD,a1
	moveq	#0,d7	
iniRRD:
	move.w	d7,d0
	and	#$0fff,d0
	moveq	#3,d6
iniRRD1:
	lsr.w	#1,d0
	bcc.s	iniRRD2
	or.w	#$0800,d0
iniRRD2:
	dbra	d6,iniRRD1
	move.w	d7,d1
	and.w	#$f000,d1
	or.w	d1,d0
	move.w	d0,d1
	lsr.w	#8,d1
	ror.w	#8,d0
	lsl.l	#8,d0
	move.b	(a1,d1.w),d0
	move.l	d0,(a0)+
	addq.w	#1,d7
	bne.s	iniRRD
;
	lea	RLDit,a0
	moveq	#0,d7	
iniRLD:
	move.w	d7,d0
	and.w	#$0fff,d0
	lsl.w	#4,d0
	moveq	#3,d6
iniRLD1:
	lsl.w	#1,d0
	bcc.s	iniRLD2
	or.w	#$0010,d0
iniRLD2:
	dbra	d6,iniRLD1
	lsr.w	#4,d0
	move.w	d7,d1
	and.w	#$f000,d1
	or.w	d1,d0
	move.w	d0,d1
	lsr.w	#8,d1
	ror.w	#8,d0
	lsl.l	#8,d0
	move.b	(a1,d1.w),d0
	move.l	d0,(a0)+
	addq.w	#1,d7
	bne.s	iniRLD
;==========================================================
	lea	addtab,a0
	lea	DSKbuf,a1
	moveq	#-1,d7
.1:
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	dbra	d7,.1
	lea	DSKbuf,a0
	lea	DSKbuf+1*131072,a1
	lea	DSKbuf+2*131072,a2
	lea	DSKbuf+3*131072,a3
	lea	addsub,a6
	move.w	#-1,d7
initast:
	move.w	(a0)+,(a6)+
	move.w	(a1)+,(a6)+
	move.w	(a2)+,(a6)+
	move.w	(a3)+,(a6)+
	dbra	d7,initast
;==========================================================
	lea	aox_tab,a0
	lea	inc_tab,a1
	lea	dec_tab,a2
	move.l	a1,a3
	move.l	a2,a4
	lea	aoxtab,a6
	move.w	#-1,d7
inita1:
	move.w	(a0)+,(a6)+
	move.b	(a1)+,(a6)+
	move.b	(a2)+,(a6)+
	move.b	(a3),(a6)+
	move.b	(a4),(a6)+
;
	tst.b	d7
	bne.s	inita2
	addq.l	#1,a3
	addq.l	#1,a4
inita2:
;
	add.l	#2,a6
	dbra	d7,inita1
;==========================================================
	lea	xcopper,a0
	move.w	#191,d7
iniblt:
	moveq.l	#34,d0
	add.l	a0,d0
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)
	swap	d0
	sub.l	#4,d0
	move.w	d0,14(a0)
	swap	d0
	move.w	d0,10(a0)
	lea	160(a0),a0
	dbra	d7,iniblt
;
	jsr	Setpages		; SetUP MMU Pages...
;
	move.l	#Rom,a0			; Copy 48k Rom...
;
;	move.b	#$18,$08a1(a0)		; No start on LOAD""
;
;	move.w	#$edff,$2eba(a0)	; Set Break Point
;
	move.l	Pages,a1
	move.w	#$3fff,d0
rloop:
	move.b	(a0)+,(a1)+
	dbra	d0,rloop
;
	move.l	#Rom_128,a0		; Copy 128k Rom...
	add.l	#$20000,a1
	move.w	#$7fff,d0
rloop2:
	move.b	(a0)+,(a1)+
	dbra	d0,rloop2
;
	lea	BRDtab,a0
	move.w	#224*48+7-1,d7
.1:
	clr.w	(a0)+
	dbra	d7,.1
	moveq	#0,d0
;
	moveq	#31,d7
.2:
	moveq	#31,d6
.3:
	move.w	d0,(a0)+
	dbra	d6,.3
	move.w	#159,d6
.4:
	move.w	d0,(a0)+
	addq.w	#2,d0
	dbra	d6,.4
	moveq	#31,d6
.5:
	move.w	d0,(a0)+
	dbra	d6,.5
	dbra	d7,.2
;
	move.w	#191,d7
.6:
	moveq	#31,d6
.7:
	move.w	d0,(a0)+
	dbra	d6,.7
	moveq	#15,d6
.8:
	move.w	d0,(a0)+
	addq.w	#2,d0
	dbra	d6,.8
	move.w	#127,d6
.9:
	move.w	d0,(a0)+
	dbra	d6,.9
	moveq	#15,d6
.10:
	move.w	d0,(a0)+
	addq.w	#2,d0
	dbra	d6,.10
	moveq	#31,d6
.11:
	move.w	d0,(a0)+
	dbra	d6,.11
	dbra	d7,.6
;
	moveq	#31,d7
.12:
	moveq	#31,d6
.13:
	move.w	d0,(a0)+
	dbra	d6,.13
	move.w	#159,d6
.14:
	move.w	d0,(a0)+
	addq.w	#2,d0
	dbra	d6,.14
	moveq	#31,d6
.15:
	move.w	d0,(a0)+
	dbra	d6,.15
	dbra	d7,.12
;
	lea	-64(a0),a0
	subq.w	#2,d0
	move.w	#224*16+32-7-1,d7
.16:
	move.w	d0,(a0)+
	dbra	d7,.16
;
	rts
;
EScrColors:
    DC.W     $0,$00,$00,$00
    DC.W     $1,$00,$00,$0b
    DC.W     $2,$0b,$00,$00
    DC.W     $3,$0b,$00,$0b
    DC.W     $4,$00,$0b,$00
    DC.W     $5,$00,$0b,$0b
    DC.W     $6,$0b,$0b,$00
    DC.W     $7,$0b,$0b,$0b
    DC.W     $8,$00,$00,$00
    DC.W     $9,$00,$00,$0f
    DC.W     $A,$0f,$00,$00
    DC.W     $B,$0f,$00,$0f
    DC.W     $C,$00,$0f,$00
    DC.W     $D,$00,$0f,$0f
    DC.W     $E,$0f,$0f,$00
    DC.W     $F,$0f,$0f,$0f
    DC.W    $FFFF,$00,$00,$00
;
EScrTags:
    DC.L    SA_Left,0
    DC.L    SA_Top,0
    DC.L    SA_Width,320
    DC.L    SA_Height,256
    DC.L    SA_Depth,4
    DC.L    SA_Colors,EScrColors
    DC.L    SA_Font,topaz8
    DC.L    SA_Type,CUSTOMSCREEN
    DC.L    SA_DisplayID
x1ScrMode:
	dc.l	0
    DC.L    TAG_DONE
    CNOP    0,2
;
EScr:
	dc.l	0
;
Fast10?:
	dc.w	0
;===================================================================
StartEmul:
;
	move.l	Pages,a1
	move.l	#$dbfe1fe6,$0562(a1)	; Fix for TZX file....
	move.b	#$20,$0566(a1)
	move.l	TAP_base,a0		; TAP or TZX?
	tst.l	a0
	beq.s	.ff1
	cmp.l	#"ZXTa",(a0)
	bne.s	.ff2
	tst.w	Fast10?
	beq.s	.ff1
.ff2:
	move.l	#$edfeedfd,$0562(a1)	; Fix for TAP file....
	move.b	#$c9,$0566(a1)
.ff1:
;
	lea	JoyKeys,a0
	lea	JoyKeyTAB+30,a1
	bsr	IsKey
	move.w	d0,2(a1)
	bsr	IsKey
	move.w	d0,0(a1)
	bsr	IsKey
	move.w	d0,6(a1)
	bsr	IsKey
	move.w	d0,4(a1)
	bsr	IsKey
	move.w	d0,8(a1)
;
	clr.w	ExitFlag
	clr.l	EScr
	tst.w	RefreshMode
	beq	.1
	move.l	ScreenMode,x1ScrMode
	move.l	_IntuitionBase,a6
	suba.l  a0,a0
	lea.l   EScrTags,a1
	jsr     OpenScreenTagList(a6)
	move.l  d0,EScr
	tst.l   d0
	beq     SE_Error
;
	move.l	#$dff000,a5
	move.w	dmaconr(a5),SaveDMACON
	move.w	intenar(a5),SaveINTENA
	move.w	#%0111111111111111,dmacon(a5)
	move.w	#%0111111111111111,intena(a5)
;
	lea	AYsample1,a0
	move.l	a0,$a0(a5)
	move.l	a0,$b0(a5)
	move.l	a0,$c0(a5)
	move.l	a0,$d0(a5)
	moveq.w	#$0001,d0
	move.w	d0,$a4(a5)
	move.w	d0,$b4(a5)
	move.w	d0,$c4(a5)
	move.w	d0,$d4(a5)
	clr.w	$a8(a5)
	clr.w	$b8(a5)
	clr.w	$c8(a5)
	clr.w	$d8(a5)
;
	move.l	#$dff000,a5
	bsr.w	GetVBR
	move.l	a4,OLDVBR
	move.l	$6c(a4),OldInt
	move.l	$68(a4),OldInt2
	move.l	#IntPrg,$6c(a4)
	move.l	#IntPrg2,$68(a4)
	move.l	#MMUerr,$08(a4)
;
	move.w	#$838f,dmacon(a5)
	move.b	#$7f,$bfed01
	move.b	#$88,$bfed01
	clr.b	$bfd900
	clr.b	$bfd800
	move.w	#$c028,intena(a5)
	jmp	init
;----------------------------------------------------
.1:
        move.l  gfxbase,a6
        move.l  $22(a6),wbview		; store current view address
	sub.l   a1,a1                   ; clear a1
        jsr     _LVOLoadView(a6)        ; Flush View to nothing
        jsr     _LVOWaitTOF(a6)         ; Wait once
        jsr     _LVOWaitTOF(a6)         ; Wait again.
	jsr	_LVOOwnBlitter(a6)
	move.l	#$dff000,a5
	move.w	dmaconr(a5),SaveDMACON
	move.w	intenar(a5),SaveINTENA
	move.w	#%0111111111111111,dmacon(a5)
	move.w	#%0111111111111111,intena(a5)
;
	MOVE.W	#%0001101110000010,$1DC(A5)	;BEACON0
				;3 - COMPOSITE BLANK OUT TO CSY PIN
				;7 - VARIABLE BEAM COUNTER COMPARATOR ENABLED
				;8 - VARIABLE HORIZONTAL SYNC ENABLED
				;9 - VARIABLE VERTICAL SYNC ENABLED
				;11- DISABLE LONGLINE/SHORTLINE TOGGLE
				;12- VARIABLE VERTICAL BLANK ENABLED
	MOVE.W	#228,$1C0(A5)	;HTOTAL - HIGHEST NUMBER COUNT, HORIZ LINE
	MOVE.W	#8,$1C4(A5)	;HBSTRT - HORIZONTAL LINE POS FOR HBLANK START
	MOVE.W	#14,$1DE(A5)	;HORIZONTAL SYNC START
	MOVE.W	#$1C,$1C2(A5)	;HORIZONTAL LINE POSITION FOR HSYNC STOP
	MOVE.W	#$21,$1C6(A5)	;HORIZONTAL LINE POSITION FOR HBLANK STOP
	MOVE.W	#$46,$1E2(A5)	;HORIZONTAL POSITION FOR VSYNCH IN INTERLACE
;
	MOVE.W	saveVTOTAL,$1C8(A5)	;VTOTAL - HIGHEST NUMB VERTICAL LINE
	MOVE.W	#0,$1CC(A5)	;VERTICAL LINE FOR VBLANK START
	MOVE.W	#3,$1E0(A5)	;VERTICAL SYNC START
;	MOVE.W	#$200,$1E4(A5)
	MOVE.W	#$100,$1E4(A5)
	MOVE.W	#5,$1CA(A5)	;VERTICAL LINE POSITION FOR VSYNC STOP
	MOVE.W	#$1D,$1CE(A5)	;VERTICAL LINE FOR VBLANK STOP
	MOVE.W	#%00010010,$104(A5)	;
	MOVE.W	#%0000110000100001,$106(A5)	; 0 - external blank enable
						; 5 - BORDER BLANK
						; 10-11 AGA dual playfiled fix
;
	lea	AYsample1,a0
	move.l	a0,$a0(a5)
	move.l	a0,$b0(a5)
	move.l	a0,$c0(a5)
	move.l	a0,$d0(a5)
	moveq.w	#$0001,d0
	move.w	d0,$a4(a5)
	move.w	d0,$b4(a5)
	move.w	d0,$c4(a5)
	move.w	d0,$d4(a5)
	clr.w	$a8(a5)
	clr.w	$b8(a5)
	clr.w	$c8(a5)
	clr.w	$d8(a5)
	move.l	#@bpa,a0
	move.l	#ZXScreen,d0		; Set Bitplanes
	move.w	d0,4(a0)
	swap.w	d0
	move.w	d0,(a0)
;
	move.l	#@bpa_s,a0
	move.l	#StatusLine,d0		; Set Bitplanes
	moveq	#3,d1
inisbpa:
	move.w	d0,4(a0)
	swap.w	d0
	move.w	d0,(a0)
	swap.w	d0
	addq.l	#8,a0
	add.l	#768,d0		; 512
	dbra	d1,inisbpa
;
;
	lea	First16pal+2,a1
	move.l	#$0000,d1
	moveq	#0,d2
fill0:
	moveq	#31,d7
	lea	$180(a5),a0
fill1:	
	move.w	d1,$106(a5)
;
	moveq	#0,d3
	move.b	d2,d0
	lsr.b	#1,d0
	bcs.s	spal1
	lsr.b	#3,d0
spal1:
	lsr.b	#1,d0
	bcc.s	spal2
	or.w	#$00f,d3
spal2:
	lsr.b	#1,d0
	bcc.s	spal3
	or.w	#$f00,d3
spal3:
	lsr.b	#1,d0
	bcc.s	spal4
	or.w	#$0f0,d3
spal4:
	btst	#7,d2
	bne.s	spal5
	and.w	#$0bbb,d3
spal5:
	move.w	d3,(a0)+
	cmp.w	#16,d2
	bcc.s	.1
	move.w	d3,(a1)
	addq.l	#4,a1
.1:
	addq.w	#1,d2
	dbra	d7,fill1
	add.w	#$2000,d1
	bcc.s	fill0
;
;
	move.l	#$dff000,a5
	bsr.w	GetVBR
	move.l	a4,OLDVBR
	move.l	$6c(a4),OldInt
	move.l	$68(a4),OldInt2
	move.l	#IntPrg,$6c(a4)
	move.l	#IntPrg2,$68(a4)
	move.l	#MMUerr,$08(a4)
;
	move.w	#$1201,bplcon0(a5)	; 8 - bitplanes, color on
	move.w	#$4ca2,diwstrt(a5)	; $ec - $2c = $c0 = 192
	move.w	#$24a1,diwstop(a5)	; $c1 , $81 ( $10c - $4c = 192 )
	move.w	#$0042,ddfstrt(a5)	; $3c
	move.w	#$00b4,ddfstop(a5)	; $b0
;	MOVE.W	#%0001101110001000,$1DC(A5)	;BEACON0
;	move.w	#$320,$1c8(a5)
;
	move.w	#2,copcon(a5)
	move.l	#$00ff00ff,$44(a5)
	move.l	#$89f00000,$40(a5)
	move.w	#6,bltamod(a5)
	move.w	#6,bltdmod(a5)
;
	moveq	#4,d1
WaitForStart1:
	move.b	$bfe801,d0
WaitForStart:
	cmp.b	$bfe801,d0
	beq.s	WaitForStart
	dbra	d1,WaitForStart1
	move.l	#Copper,cop1lc(a5)	; Load Copper
	move.w	copjmp1(a5),d0		; Start Copper List...
	move.w	#$83cf,dmacon(a5)
	clr.b	$bfd900
	clr.b	$bfd800
	move.b	#$7f,$bfed01
	move.b	#$88,$bfed01
	move.w	#$c018,intena(a5)
;      
RunEmul:
	jmp	init
;
OLDVBR:
	dc.l	0
;
RestSys:
;
	move.l	#$dff000,a5
	move.w	#%0111111111111111,intena(a5)
	move.w	#%0111110110111111,dmacon(a5)
	move.l  gfxbase,a6
	jsr	_LVOWaitBlit(a6)
	move.l	#$dff000,a5
	move.w	#%0111111111111111,dmacon(a5)
	lea	$bfd000,a1
	move.b	#$7f,$d00(a1)
	clr.b	$e00(a1)
	clr.b	$f00(a1)
	move.b	#$7f,$bfed01
	move.b	#$8B,$bfed01
	bsr	GetVBR
;	move.l	OLDVBR,a4
;
;.xx	move.w	d0,$dff180
;	addq.w	#1,d0
;	bra	.xx
;
	move.l	OldInt,$6c(a4)
	move.l	OldInt2,$68(a4)
	tst.w	RefreshMode
	beq.s	.1
	move.w	SaveDMACON,d0
	or.w	#$8000,d0
	move.w	d0,dmacon(a5)
	move.w	SaveINTENA,d0
	move.w	#$7fff,intreq(a5)
	or.w	#$c000,d0
	move.w	d0,intena(a5)
	bra.s	.2
.1:
	clr.w	copcon(a5)
	move.l	gfxbase,a0
	move.l	$26(a0),cop1lc(a5)
	move.l	$32(a0),cop2lc(a5)
	move.w	copjmp1(a5),d0
	move.w	SaveDMACON,d0
	or.w	#$8000,d0
	move.w	d0,dmacon(a5)
	move.w	SaveINTENA,d0
	move.w	#$7fff,intreq(a5)
	or.w	#$c000,d0
	move.w	d0,intena(a5)
	move.l  wbview(pc),a1
	move.l  gfxbase,a6
	jsr	_LVODisownBlitter(a6)
	jsr     _LVOLoadView(a6)        ; Fix view
	jsr     _LVOWaitTOF(a6)
	jsr     _LVOWaitTOF(a6)         ; Wait for LoadView()
;
.2:

SE_Error:
	move.l  _IntuitionBase,a6
	move.l  EScr,a0
	tst.l	a0
	beq.s   .1
	jsr     CloseScreen(a6)
.1:
tst:
	clr.l	d0
	rts				; Exit 2 DOS
;
save_msp:	dc.l	0
save_isp:	dc.l	0
save_sr:	dc.l	0
;
GetVBR:
	move.l	a5,-(a7)
	move.l	4.w,a6
	lea	getvbr1(pc),a5
	jsr	-$1e(a6)
	move.l	(a7)+,a5
	rts
getvbr1:
	movec	vbr,a4
	rte
;
	cnop	0,16
;
MMUerr:
	and.w	#$FEFF,$0A(a7)
coderte:
	rte
;
OpenLibs:
_SysBase=4

	MOVEQ	#0,D0
	LEA	GadName(PC),A1
	MOVE.L	$4.W,A6
	JSR	-$228(A6)
	MOVE.L	D0,_GadToolsBase
	BEQ.s	LibsError
;
	MOVEQ	#0,D0
	LEA	IntName(PC),A1
	MOVE.L	$4.W,A6
	JSR	-$228(A6)
	MOVE.L	D0,_IntuitionBase
	BEQ.s	LibsError
;
	MOVEQ	#0,D0
	LEA	DosName(PC),A1
	MOVE.L	$4.W,A6
	JSR	-$228(A6)
	MOVE.L	D0,_DosBase
	BEQ.s	LibsError
;
	MOVEQ	#0,D0
	LEA	AslName(PC),A1
	MOVE.L	4.W,A6
	JSR	-$228(A6)
	MOVE.L	D0,_AslBase

LibsError:
	rts
CloseLibs:
;
LiberaLib:MACRO
	MOVE.L	\1,A1
	TST.L	A1
	BEQ.S	\@LibLib
	MOVE.L	$4.W,A6
	JSR	-$19E(A6)	; Libera Librera.
\@LibLib:
	ENDM

	LiberaLib _DosBase
	LiberaLib _IntuitionBase
	LiberaLib _GadToolsBase
	LiberaLib _AslBase
	LiberaLib gfxbase
	rts
	CNOP	0,8
GadName:		DC.B	"gadtools.library",0
IntName:		DC.B	"intuition.library",0
DosName:		DC.B	"dos.library",0

AslName:		DC.B	"asl.library",0
	cnop	0,8
_IntuitionBase:		dc.l	0
_GadToolsBase:		dc.l	0
_DOSBase:
_DosBase:		dc.l	0
_AslBase:		dc.l	0
;
; Some Data
;

wbview:
	dc.l	0
gfxname:
	dc.b	'graphics.library',0,0
gfxbase:
	dc.l	0
SaveDMACON:
	dc.w	0
SaveINTENA:
	dc.w	0
OldInt:
	dc.l	0
OldInt2:
	dc.l	0
OldInt3:
	dc.l	0
;
;-------------------------------------------------
;
;	Interrupt Program
;
;-------------------------------------------------
JoyKeyTAB:
	dc.w	12,4,28,20,36
	dc.w	29,37,21,13,5
	dc.w	21,36,37,29,5
	dc.w	0,0,0,0,0
OldJoy:
	dc.w	$1f
;
DWaitCNT:
	dc.w	1
Lock?:
	dc.w	0
RunSTS:
	dc.w	0
;
	cnop	0,16
IntPrg:
	movem.l	d0-d7/a0-a6,-(a7)
;
;	move.w	#$0000,$dff106
;	move.w	#$700,$dff180
	jsr	PlayAY
;
DoJoy:
	lea	JoyKeyTAB-20,a1
	move.w	JoyMode,d0
	tst.w	d0
	beq.s	.4
.2:
	lea	10(a1),a1
	dbra	d0,.2	
;
	jsr	GetJoy
	lea	KeyBuf,a0
;
;D0 bits:
;
; 0 - Left
; 1 - Right
; 2 - Up
; 3 - Down
; 4 - Fire
;
	cmp.w	OldJoy,d0
	beq.s	.4
	move.w	d0,OldJoy
	moveq	#4,d2
.3:
	move.w	(a1)+,d3
	tst.w	d3
	beq.s	.5
	subq.w	#1,d3
	move.w	d3,d1
	lsr.w	#3,d1
	and.w	#7,d3
	lsr.w	#1,d0
	bcs.s	.6
	bset.b	d1,(a0,d3.w)
	bra.s	.5
.6:
	bclr.b	d1,(a0,d3.w)
.5:
	dbra	d2,.3
;
.4:
;
Res?:
	tst.w	HardRes
	beq.s	Nores
	clr.l	AYreg0
	clr.l	AYreg0+4
	clr.l	AYreg0+8
	clr.l	AYreg0+12
;
	move.l	tree_base,a0
	tst.w	Lock?
	beq.s	.1
	move.w	#$10,Copy7FFD
	move.l	Rom_48,p0000-Tree(a0)
	bra.s	.2
.1:
	clr.w	Copy7FFD
	move.l	Rom128,p0000-Tree(a0)
.2:
	move.l	page_0,pC000-Tree(a0)
	move.b	#0,trdos_flg+1
;
	clr.w	ZXPC
	clr.w	HardRes
	clr.w	aoxtab-8			; 0 -> IFF1
	clr.w	aoxtab-$a			; 0 -> IFF2
Nores:
;
	move.l	a7,SaveSP
	move.l	#addtab,a7
	move.l	BRDqpnt0,BRDqpnt
;
	move.w	UpTicks,d0
;
	add.w	#HorizontalIntPos-3,SaveD6+2
	add.w	d0,SaveD6+2
	sub.w	#128*224+16+96-HorizontalIntPos,d0
	neg.w	d0
	move.l	ADR_DownTicks,a0
	move.w	d0,(a0)
	add.l	#xLen*193*8,a0
	move.w	d0,(a0)
;
	clr.l	d0
	move.w	UpTicks,d0
	sub.l	#(320+80)*224,d0
	neg.l	d0
	move.l	ADR_DownFEticks,a0
	move.l	d0,(a0)
	add.l	#xLen*193*8,a0
	move.l	d0,(a0)
;
; Start MMU
;
;	move.w	#$0000,$dff106
;	move.w	#$777,$dff180
	tst.l	CPU?
	beq	strt030
;
	move.l	mmu_base_up,a0
	move.l	#mmu_savebuf,a1
	move.l	(a0),(a1)+
	move.l	mmu_base_down,a0
	move.l	(a0),(a1)
;
	move.w	Copy7FFD,d0
	lea	(PageTab,d0.w*8),a0
	move.w	trdos_flg,d0
	move.l	(a0,d0.w),([mmu_base_up])
	move.l	(a0)+,([mmu_base_down])
	move.l	(a0),a3
	cpusha	bc
	pflusha
;	moveq	#5,d0
;	movec	d0,DFC    ;
;
	movec	DTT0,d0
	move.l	d0,saveDTT0
	movec	ITT0,d0
	move.l	d0,saveITT0
	movec	DTT1,d0
	move.l	d0,saveDTT1
	movec	ITT1,d0
	move.l	d0,saveITT1
;                 31      23      15      7      0
;	move.l	#%01000000001111111110000000000000,a0
	move.l	MemoryMask2,a0
	movec	a0,DTT0
	movec	a0,ITT0
	move.l	MemoryMask,a0
;	move.l	#%00001000000001111110000000000000,a0
	movec	a0,DTT1
	movec	a0,ITT1
;
	bra.s	strtgl
strt030:
	opt	p=68030
	lea	SaveMMUbuf(pc),a0
	pmove.l	TC,0(a0)
	pmove.d	CRP,4(a0)
	pmove.l	TT0,12(a0)
	pmove.l	TT1,16(a0)
	lea	CodeForStop(pc),a0
	pmove.l	(a0),TC
	pmove.l	(a0),TT0
	pmove.l	(a0),TT1
	lea	CodeForCRP,a0
	pmove.d	(a0),CRP
	addq.l	#8,a0
	pmove.l	(a0),TC
	addq.l	#4,a0
	pmove.l	(a0),TT0
	movec	cacr,d0
	or.w	#$808,d0
	movec	d0,cacr
	opt	p=68040
strtgl:
;
;	move.w	#$0000,$dff106
;	move.w	#$007,$dff180
	tst.w	FPoke?
	beq.s	nofpoke
	move.w	POKE_ADR_S,a0
	move.b	POKE_dat,(a0)
nofpoke:
;
	move.w	Copy7FFD,d0
	move.l	page_5a,a3
	btst	#3,d0
	beq.s	iprg1
	move.l	page_7a,a3
iprg1:
	subq.l	#1,a3
	lea	aoxtab,a6		; many tab table
	move.l	cmd_base1,a4			; jumptab
	move.l	next_base,a1
	movem.l	ZXR_save,d2-d7
;
;	lea	addsub,a2		; add , adc , sub , sbc tab...
	move.w	ZXPC,a5
;
	move.w	ZXSP,a2
;
	clr.l	d1			; jump & temp
	clr.l	d0			; temp use...
;
	tst.w	RunSTS
	beq.w	nosts
	clr.w	RunSTS
	move.w	#$1F,d0
	move.w	d0,Copy7FFD
	tst.l	CPU?
	beq.s	.1
	lea	(PageTab,d0.w*8),a0
	move.w	trdos_flg,d0
	move.l	(a0,d0.w),([mmu_base_up])
	move.l	(a0)+,([mmu_base_down])
	move.l	(a0),a3
	cinva	dc
	pflushan
	bra.s	.2
.1:
	opt	p=68030
	move.l	tree_base,a3
	lea	(PageTab,d0.w*8),a0
	move.l	(a0)+,pC000-Tree(a3)
	move.l	(a0),a3
	pflush	#0,#0,$ffffc000
	movec	cacr,d0
	or.w	#$800,d0
	movec	d0,cacr
	opt	p=68040
.2:
	move.w	a5,d0
	move.b	d0,$FFFFFEE4
	rol.w	#8,d0
	move.b	d0,$FFFFFEE5
	move.b	#6,$FFFFE02F
	move.w	#$DB00,a5
nosts:
;
	tst.w	MagicFlg
	beq.s	NoMagic
	jsr	setrom_trdos
	PUSH	a5
	move.w	#$0066,a5
	clr.w	MagicFlg
	move.w	-$8(a6),-$a(a6)
	clr.w	-$8(a6)
NoMagic:
;
	tst.w	-8(a6)			; DI or not DI ?
	beq.w	Go
	cmp.b	#$76,(a5)
	bne.s	Next5
	addq.w	#1,a5
	move.w	a5,a5
Next5:
	cmp.w	#$ed5f,-2(a5)
	beq.s	.1
	cmp.w	#$ed57,-2(a5)
	bne.s	.2
.1:
	and.b	#$fb,d5
.2:
	DI
	move.w	-$c(a6),d0		; Int number 0,1 or 2
	and.w	#$FFFE,d0
	bne.s	Next4
;	move.w	#$0000,$dff106
;	move.w	#$070,$dff180
	RST	56
	jmpnext	11,1
Next4:
	addq.w	#2,d7
	move.w	a5,d0
	rol.w	#8,d0
	move.w	d0,-(a2)			; PC -> (SP)
	move.w	a2,a2
	move.w	-$e(a6),a0
	move.w	(a0),d0
	rol.w	#8,d0
	move.w	d0,a5
	cmp2.w	-$14(a6),a5
	bcs.s	.3
	tst.b	trdos_flg+1
	beq.s	.2
	jsr	setrom_basic
	bra.s	.3
.2:
	btst.b	#4,Copy7FFD+1
	beq.s	.3
	jsr	setrom_trdos
.3:
;
Go:
;	move.w	#$0000,$dff106
;	move.w	#$070,$dff180
	move.b	(a5)+,d0		; Go! Get 1st byte...
	lsl.w	#8,d0
	jmp	(a4,d0.w)
SaveSP:
	dc.l	0
;
Copy7FFD:
	dc.w	0
ZXR_save:
	dc.l	0
	dc.l	0
	dc.l	0
	dc.l	0
SaveD6:
	dc.l	0
	dc.l	0
ZXPC:
	dc.w	$0000
ZXSP:
	dc.w	$6200
;
cmd_base:
	dc.l	0
cmd_base1:
	dc.l	0
ADR_DownTicks:
	dc.l	0
ADR_DownFEticks:
	dc.l	0
;
SaveMMUbuf:
	dc.l	0
	dc.l	0,0
	dc.l	0
	dc.l	0
;
saveITT0:	dc.l	0
saveDTT0:	dc.l	0
saveITT1:	dc.l	0
saveDTT1:	dc.l	0
;
CodeForStop:
	dc.l	0
;
mmu_savebuf:
	ds.l	24
;
Upor:
	nop
	st	ExitFlag
Next:
;	move.w	#$0000,$dff106
;	move.w	#$770,$dff180
	movem.l	d2-d7,ZXR_save
	move.w	a5,ZXPC
	move.w	a2,ZXSP
;
;StopMMU
;
	tst.l	CPU?
	beq.s	stop030
stop040:
	move.l	mmu_base_up,a1
	move.l	#mmu_savebuf,a0
	move.l	(a0)+,(a1)
	move.l	mmu_base_down,a1
	move.l	(a0),(a1)
	pflusha
	move.l	saveDTT0,d0
	movec	d0,DTT0
	move.l	saveITT0,d0
	movec	d0,ITT0
	move.l	saveDTT1,d0
	movec	d0,DTT1
	move.l	saveITT1,d0
	movec	d0,ITT1
;
	bra.s	stopgl
stop030:
	opt	p=68030
	lea	CodeForStop(pc),a0
	pmove.l	(a0),TC
	pmove.l	(a0),TT0
	pmove.l	(a0),TT1
	lea	SaveMMUbuf(pc),a0
	tst.l	(a0)
	bpl.s	.0
	pmove.d	4(a0),CRP
	pmove.l	12(a0),TT0
	pmove.l	16(a0),TT1
	pmove.l	0(a0),TC
.0:
	movec	cacr,d0
	or.w	#$808,d0
	movec	d0,cacr
	opt	p=68040
stopgl:
;
;	move.w	#$0000,$dff106
;	move.w	#$077,$dff180
	move.l	SaveSP,a7
;
	move.w	NewBRD,OldBRD
;
	move.l	BRDqpnt,a0
	cmp.l	BRDqpnt0,a0
	beq.s	.20
	move.w	-6(a0),NewBRD
.20:
;
	tst.w	StartStop
	beq.s	.30
	add.l	#71680,MICtimer
	bra.s	.40
.30:
	move.l	#$c0000000,MICtimer
.40:
;
	move.l	FlashCNT,d0
	rol.l	#1,d0
	move.l	d0,FlashCNT
	movem.l	(a7)+,d0-d7/a0-a6
	st	IntFlg			; Int Complete
;	move.w	#$0000,$dff106
;	move.w	#$000,$dff180
	move.w	#$0030,$dff09c
	clr.w	$dff1FE
	rte

;
;SaveICR:
;	dc.w	0
;        

UpTicks:
	dc.w	80*224
	cnop	0,16


IntPrg2:				; Keyboard
	movem.l	d0-d7/a0-a6,-(a7)
	move.b	$bfed01,d0
	btst	#3,d0
	beq.s	.1
	bsr.s	kbdcheck
.1:
	movem.l	(a7)+,d0-d7/a0-a6
	move.w	#$0008,$dff09c
	clr.w	$dff1FE
	rte
KeyClick:
	dc.w	0
kbdcheck:
	moveq	#0,d0
	move.b	$bfec01,d0
	not.b	d0
	ror.b	#1,d0
	sf	$bfec01
	move.w	#4,d2
	or.b	#$40,$bfee01
kbd_chk:
	move.b	$dff006,d1
flushkbd:
	cmp.b	$dff006,d1
	beq.s	flushkbd
	dbra	d2,kbd_chk
	and.b	#$bf,$bfee01
;
	cmp.b	#$62,d0
	beq.s	.1
	cmp.b	#$e2,d0
	bne.s	CheckShift
;
	move.l	#-1,KeyBuf
	move.l	#-1,KeyBuf+4
	clr.w	SPMODEflg
	bra.s	CheckShift
.1:
	st	SPMODEflg
	bra.s	CheckShift
SPMODEflg:
	dc.w	0
CheckShift:
	cmp.b	#$60,d0
	beq.s	.1
	cmp.b	#$61,d0
	beq.s	.1
	cmp.b	#$e0,d0
	beq.s	.2
	cmp.b	#$e1,d0
	beq.s	.2
	bra.s	.3
.1:
	st	ShiftFLG
	st	KeyClick
	bra.s	.3
.2:
	move.l	#-1,KeyBuf
	move.l	#-1,KeyBuf+4
	clr.w	ShiftFLG
.3:
	moveq.l	#0,d3
	tst.b	d0
	bpl	kbdc0
	not.l	d3
	and.b	#$7f,d0
	cmp.b	#$58,d0			; #$58 - F9  Hard Reset
	bne.s	kbdc01
	st	HardRes
kbdc01:
	cmp.b	#$59,d0			; #$59 - F10 Exit 
	bne.s	kbdc02
	st	ExitFlag
kbdc02:
	cmp.b	#$57,d0			; #$57 - F8  Magic Button (NMI)
	bne.s	kbdc03
	st	MagicFlg
kbdc03:
	cmp.b	#$56,d0			; #$56 - F7  Lock port #$7FFD
	bne.s	.1
	not.w	Lock?
	tst.w	Lock?
	beq.s	.2
	move.l	#noout,d1
	bsr	change7ffd
	bra.s	.1
.2:
	move.l	#Out7FFD,d1
	bsr	change7ffd
.1:
	cmp.b	#$50,d0			; #$50 - F1  Ticks Up
	bne.s	.3
	cmp.w	#1*224,UpTicks
	beq.s	.3
	sub.w	#224,UpTicks
.3:
	cmp.b	#$51,d0			; #$51 - F2  Ticks Down
	bne.s	.4
	cmp.w	#127*224,UpTicks
	beq.s	.4
	add.w	#224,UpTicks
.4:
	cmp.b	#$53,d0
	bne.s	.40
	st	RunSTS
.40:
	cmp.b	#$55,d0			; #$55 - F6  Play/Stop Tape
	bne.s	.5
	not.w	StartStop
	tst.w	StartStop
	beq.s	.5
	clr.l	MICtimer
.5:
	cmp.b	#$54,d0			; #$54 - F5  Rewind Tape
	bne.s	.6
	move.l	TAP_base,d0
	move.l	d0,TapDisp		; Rewind TAP file...
	move.l	d0,TZXfilepnt		; Rewind TZX file....
	add.l	#10,TZXfilepnt		;
	move.l	#Pulses,PulsePNT		;
	move.w	#$ff,CurrentPulse
	clr.l	MICtimer
	clr.l	Pulses
	clr.l	Pulses+4
.6:
;----------------------------------------------
kbdc0:
	lea	KeyBuf,a0
	lea	Ami2ZXkeytab(pc,d0.w*8),a1
	tst.w	ShiftFLG
	beq.s	.1
	lea	8*128(a1),a1
.1:
	moveq	#3,d2
	moveq	#0,d1
kbdc1:
	move.w	(a1)+,d0
	tst.w	d0
	beq.s	kbdcexit
	subq.w	#1,d0
	move.w	d0,d1
	lsr.w	#3,d1
	and.w	#7,d0
	tst.l	d3
	beq.s	kbdcon
	tst.w	SPMODEflg
	bne.s	kbdc2
	bset.b	d1,(a0,d0.w)
	bra.s	kbdc2
kbdcon:
	bclr.b	d1,(a0,d0.w)
kbdc2:
	dbra	d2,kbdc1
kbdcexit:
	rts
ShiftFLG:
	dc.w	0
;
Ami2ZXkeytab:			;SCAN	AMIGA	ZX
	ds.w	4*256
;
change7ffd:
	lea	outtab+131072,a0
	moveq	#0,d7
.1:
	btst	#1,d7
	bne.s	.2
	btst	#15,d7
	bne.s	.2
	move.l	d1,(a0,d7.w*4)
.2:
	addq.w	#1,d7
	bne.s	.1
	rts
;
ExitFlag:
	dc.w	0
IntFlg:
	dc.w	0
BrdClr:
	dc.w	0

next_base:
	dc.l	0
next_base1:
	dc.l	0
;
xNext0:
	lea	xNext1-xNext0(a1),a1
	move.l	$5800(a3),(a1)+
imod2	equ	*-2-xNext0
	move.l	$4000(a3),(a1)+
imod1	equ	*-2-xNext0
	add.w	#16,d6
imod3	equ	*-2-xNext0
	ble.s	xNext1+8
	move.b	(a5)+,d0		; Go! Get 1st byte...
	lsl.w	#8,d0
	jmp	(a4,d0.w)
	ds.w	5
imod4	equ	*-xNext0
	dc.l	80*224+HorizontalIntPos
xNext1:
	dc.l	0
	dc.l	0
	list
xLen	equ	*-xNext0
	nolist
;
;-------------------------------------------
;
;	Init All & Start Emualtion...
;
;-------------------------------------------
HardRes:
	dc.w	0
MagicFlg:
	dc.w	0
FlashCNT:
	dc.l	$ffff0000
;
init:
;
Next3:
	tst.w	IntFlg			; Wait Int...
	beq.s	Next3
	clr.w	IntFlg
;
	tst.w	Lock?
	bne.s	.3
	move.w	#000,pal_lock+2
	bra.s	.4
.3:
	move.w	#$f00,pal_lock+2
.4:
	tst.w	StartStop
	bne.s	.30
	move.w	#000,pal_tape+2
	bra.s	.40
.30:
	move.w	#$0ff,pal_tape+2
.40:
	tst.w	DWaitCNT
	bne.s	.0
	clr.w	pal_disk_a+2
	clr.w	pal_disk_a+6
	clr.w	pal_disk_a+10
	clr.w	pal_disk_a+14
	clr.w	pal_disk_b+2
	clr.w	pal_disk_b+6
	clr.w	pal_disk_b+10
	clr.w	pal_disk_b+14
	bra.s	.2
.0:
	subq.w	#1,DWaitCNT
	btst.b	#0,FF93+1
	beq.s	.1
	move.w	#$f00,pal_disk_b+2
	move.w	#$ff0,pal_disk_b+6
	move.w	#$fff,pal_disk_b+10
	move.w	#$88d,pal_disk_b+14
	bra.s	.2
.1:
	move.w	#$f00,pal_disk_a+2
	move.w	#$ff0,pal_disk_a+6
	move.w	#$fff,pal_disk_a+10
	move.w	#$88d,pal_disk_a+14
.2:
;
	tst.w	ExitFlag
	beq.s	Next2
	jmp	RestSys
Next2:
	tst.w	RefreshMode
	bne.s	MakeScr
.1:
	move.w	$dff01e,d0
	and.w	#$4,d0
	beq.s	.1
;	move.w	#$0000,$dff106
;	move.w	#$007,$dff180
	bsr	CopySCR			; Copy Screen & Attr -> Chip RAM...
;	move.w	#$0000,$dff106
;	move.w	#$000,$dff180
	move.w	#$0004,$dff09c
	jmp	Next3
;
BRDqpnt0:
	dc.l	BRDquene0
BRDqpnt1:
	dc.l	BRDquene1
;
NewBRD:
	dc.w	0
OldBRD:
	dc.w	0
;
MakeScr:
	tst.w	BRD?
	beq	NoBRD1
;
	move.w	#$7fff,intena+$dff000
	move.l	next_base,d0
	move.l	next_base1,d1
	move.l	d1,next_base
	move.l	d0,next_base1
	move.l	BRDqpnt,d7
	move.l	BRDqpnt0,d0
	sub.l	d0,d7
	move.l	BRDqpnt1,d1
	move.l	d1,BRDqpnt0
	move.l	d0,BRDqpnt1
	move.l	d0,a0
;
	lea	BRDscr,a1
	lea	4096(a1),a2
	lea	8192(a1),a3
	lea	BRDtab,a4
	move.w	OldBRD,d2
;
	move.w	#$c028,intena+$dff000
;
	addq.l	#6,d7
	lsl.w	#6,d2
	subx.l	d5,d5
	lsl.w	#1,d2
	subx.l	d4,d4
	lsl.w	#1,d2
	subx.l	d3,d3
	moveq	#0,d2
	bra.s	.1
;
.2:
	move.w	(a0)+,d0
	move.l	(a0)+,d1
	neg.l	d1
	bpl.s	.tb1
	moveq	#0,d1
.tb1:
	cmp.l	#71680,d1
	bcc.s	.tb2
;
	move.w	(a4,d1.l*2),d6
;
	move.w	d6,d1
	sub.w	d2,d6
	bcc.s	.222
	clr.w	d6
	move.w	d2,d1
.222:
	move.w	d1,d2
;
	sub.w	#32,d6
	bcs.s	.7
	move.l	d3,(a1)+
	move.l	d4,(a2)+
	move.l	d5,(a3)+
	lsr.b	#1,d3
	subx.l	d3,d3
	lsr.b	#1,d4
	subx.l	d4,d4
	lsr.b	#1,d5
	subx.l	d5,d5
	sub.w	#32,d6
	bcs.s	.7
.3:
	move.l	d3,(a1)+
	move.l	d4,(a2)+
	move.l	d5,(a3)+
	sub.w	#32,d6
	bcc.s	.3
.7:
	move.w	d2,d6
	neg.w	d6
	lsl.w	#6,d0
	subx.l	d1,d1
	bfins	d1,d5{d2:d6}
	lsl.w	#1,d0
	subx.l	d1,d1
	bfins	d1,d4{d2:d6}
	lsl.w	#1,d0
	subx.l	d1,d1
	bfins	d1,d3{d2:d6}
	and.w	#$FFE0,d2
.1:
	subq.l	#6,d7
	bne.s	.2
;
.tb2:
	cmp.l	#BRDscr+4096,a1
	beq.s	.5
	move.l	d3,(a1)+
	move.l	d4,(a2)+
	move.l	d5,(a3)+
	lsr.b	#1,d3
	subx.l	d3,d3
	lsr.b	#1,d4
	subx.l	d4,d4
	lsr.b	#1,d5
	subx.l	d5,d5
.4:
	cmp.l	#BRDscr+4096,a1
	beq.s	.5
	move.l	d3,(a1)+
	move.l	d4,(a2)+
	move.l	d5,(a3)+
	bra.s	.4
.5:
;
	move.l	a7,mscr_sp
	move.l	EScr,a1
	lea	sc_BitMap+bm_Planes(a1),a1
	move.l	0(a1),a2
	move.l	4(a1),a3
	move.l	8(a1),a4
	move.l	12(a1),a5
	lea	BRDscr,a7	
	move.w	#32*10-1,d7
.6:
	move.l	4096(a7),(a3)+
	move.l	8192(a7),(a4)+
	move.l	(a7)+,(a2)+
	dbra	d7,.6
	lea	32*40+4(a5),a5
	move.l	#Z2Ptab+4*$8000,a1
	move.l	next_base1,a0
	lea	xLen-8(a0),a0
	move.l	#xLen,a6
	move.l	#$00ff00ff,d6
	move.w	#191,d7
	move.w	#$7fff,d0
	tst.l	FlashCNT
	bpl.s	.01
	moveq.w	#-1,d0
.01:
.21:
	swap	d7
	move.l	4096(a7),(a3)+
	move.l	8192(a7),(a4)+
	move.l	(a7)+,(a2)+
	move.w	#7,d7
.11:
;
	move.w	0(a0),d1
	move.b	4(a0),d1
	and.w	d0,d1
	move.l	(a1,d1.w*4),d1
	move.w	2(a0),d3
	move.b	6(a0),d3
	and.w	d0,d3
	move.l	(a1,d3.w*4),d3
;
	move.w	d3,d5
	move.w	d1,d3
	swap	d3
	move.w	d3,d1
	move.w	d5,d3
;
	move.w	1(a0),d2
	move.b	5(a0),d2
	and.w	d0,d2
	move.l	(a1,d2.w*4),d2
	move.w	3(a0),d4
	move.b	7(a0),d4
	and.w	d0,d4
	move.l	(a1,d4.w*4),d4
;
	move.w	d4,d5
	move.w	d2,d4
	swap	d4
	move.w	d4,d2
	move.w	d5,d4
;
	move.l	d2,d5
	lsr.l	#8,d5
	eor.l	d1,d5
	and.l	d6,d5
	eor.l	d5,d1
	lsl.l	#8,d5
	eor.l 	d5,d2
;
	move.l	d1,(a2)+
	move.l	d4,d5
	lsr.l	#8,d5
	eor.l	d3,d5
	move.l	d2,(a3)+
	and.l	d6,d5
	eor.l	d5,d3
	move.l	d3,(a4)+
	lsl.l	#8,d5
	eor.l	d5,d4
;
	move.l	d4,(a5)+
;
	add.l	a6,a0
	dbra	d7,.11
	swap	d7
	move.l	4096(a7),(a3)+
	move.l	8192(a7),(a4)+
	move.l	(a7)+,(a2)+
	lea	8(a5),a5
	dbra	d7,.21
	move.w	#32*10-1,d7
.16:
	move.l	4096(a7),(a3)+
	move.l	8192(a7),(a4)+
	move.l	(a7)+,(a2)+
	dbra	d7,.16
	move.l	mscr_sp,a7
	jmp	Next3
mscr_sp:
	dc.l	0
;
NoBRD1:
;
	move.l	EScr,a1
	lea	sc_BitMap+bm_Planes(a1),a1
	move.l	0(a1),a2
	move.l	4(a1),a3
	move.l	8(a1),a4
	move.l	12(a1),a5
	lea	32*40+4(a2),a2
	lea	32*40+4(a3),a3
	lea	32*40+4(a4),a4
	lea	32*40+4(a5),a5
	move.l	#Z2Ptab+4*$8000,a1
	move.l	next_base,a0
	lea	xLen-8(a0),a0
	move.l	#xLen,a6
	move.l	#$00ff00ff,d6
	move.w	#191,d7
	move.w	#$7fff,d0
	tst.l	FlashCNT
	bpl.s	.0
	moveq.w	#-1,d0
.0:
.2:
	swap	d7
	move.w	#7,d7
.1:
;
	move.w	0(a0),d1
	move.b	4(a0),d1
	and.w	d0,d1
	move.l	(a1,d1.w*4),d1
	move.w	2(a0),d3
	move.b	6(a0),d3
	and.w	d0,d3
	move.l	(a1,d3.w*4),d3
;
	move.w	d3,d5
	move.w	d1,d3
	swap	d3
	move.w	d3,d1
	move.w	d5,d3
;
	move.w	1(a0),d2
	move.b	5(a0),d2
	and.w	d0,d2
	move.l	(a1,d2.w*4),d2
	move.w	3(a0),d4
	move.b	7(a0),d4
	and.w	d0,d4
	move.l	(a1,d4.w*4),d4
;
	move.w	d4,d5
	move.w	d2,d4
	swap	d4
	move.w	d4,d2
	move.w	d5,d4
;
	move.l	d2,d5
	lsr.l	#8,d5
	eor.l	d1,d5
	and.l	d6,d5
	eor.l	d5,d1
	lsl.l	#8,d5
	eor.l 	d5,d2
;
	move.l	d1,(a2)+
	move.l	d4,d5
	lsr.l	#8,d5
	eor.l	d3,d5
	move.l	d2,(a3)+
	and.l	d6,d5
	eor.l	d5,d3
	move.l	d3,(a4)+
	lsl.l	#8,d5
	eor.l	d5,d4
;
	move.l	d4,(a5)+
;
	add.l	a6,a0
	dbra	d7,.1
	swap	d7
	lea	8(a2),a2
	lea	8(a3),a3
	lea	8(a4),a4
	lea	8(a5),a5
	dbra	d7,.2
	jmp	Next3
;
CopySCR:
	move.l	next_base,a0
	lea	xLen-8(a0),a0
	lea	ZXScreen,a1
	lea	xcopper+34,a2
	move.l	#16,d4
	move.l	#$fefefefe,d3
	moveq	#0,d6
	tst.l	FlashCNT
	bpl.s	.1
	move.l	#$01010101,d6
.1:
	move.w	#191,d2
	move.l	#xLen-4,d0
iloop3:
	rept	8
	move.l	(a0)+,d1
	move.l	(a0),(a1)+
	move.l	d1,d7
	lsr.l	#7,d7
	and.l	d6,d7
	lsl.l	#1,d1
	and.l	d3,d1
	or.l	d7,d1
	move.w	d1,8(a2)
	swap	d1
	move.w	d1,(a2)
	add.l	d4,a2
	add.l	d0,a0
	endr
	list
CopyScrLen	equ	*-iloop3
	nolist
	lea	32(a2),a2
	dbra	d2,iloop3
;
	rts
;
;-----------------------------------------
;
;	Z80 Emulator code
;
;-----------------------------------------
;
	section	Emulator,code_f
;
tEMULATOR:
;
; D0 - temp use		A0 - temp use
;
; D1 - jmp & temp use	A1 - Next Base
;       
; D2 - HL' - HL		A2 - ZX SP
;
; D3 - DE' - DE		A3 - Screen pointer
;
; D4 - BC' - BC		A4 - Jump TAB
;
; D5 - AF' - AF		A5 - ZX pseudo PC
;
; D6 - Int Period	A6 - Many TAB table
;
; D7 - R          	A7 - ADD , ADC , SUB , SBC table
;

HL	EQUR	D2
DE	EQUR	D3
BC	EQUR	D4
AF	EQUR	D5

H	EQUR	D2
L	EQUR	D2
D	EQUR	D3
E	EQUR	D3
B	EQUR	D4
C	EQUR	D4
A	EQUR	D5
F	EQUR	D5
	dc.l	0
			; -$1c
	dc.l	2
			; -$18
	dc.l	0
			; -$14
	dc.w	$3d00,$3dff
			; -$10
	dc.w	0
I:			; -e(a6)	Register I
	dc.w	$3FFF
INTNUM:			; -c(a6)	Int Number 0,1 or 2
	dc.w	0
IFF2:			; -a(a6)
        dc.w	0
IFF1:			; -8(a6)
	dc.w	0
iy:			; -6(a6)
	dc.w	0
ix:			; -4(a6)
	dc.w	0
zxsp:			; -2(a6)
	dc.w	0
aoxtab:					; A6
	ds.b	65536*8

rlctab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/rlc.tab"
rrctab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/rrc.tab"
slatab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/sla.tab"
sratab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/sra.tab"
slitab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/sli.tab"
srltab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/srl.tab"
rltab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/rl.tab"
rrtab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/rr.tab"
bittab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/bit.tab"
negtab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/neg.tab"
ldaitab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/ldai.tab"
ldartab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/ldar.tab"
cptab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/cp.tab"
daatab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/daa.tab"
cpitab	equ	*-aoxtab
	incbin	"zx-emul/z80_tables/cpi.tab"

aox_tab:
	incbin	"zx-emul/z80_tables/and_or_xor.tab"
inc_tab:
	incbin	"zx-emul/z80_tables/inc.tab"
dec_tab:
	incbin	"zx-emul/z80_tables/dec.tab"
;
	ds.l	256
astab	equ	*-aoxtab
;
addsub:
addtab:
	incbin	"zx-emul/z80_tables/add.tab"
adctab:
	incbin	"zx-emul/z80_tables/adc.tab"
subtab:
	incbin	"zx-emul/z80_tables/sub.tab"
sbctab:
	incbin	"zx-emul/z80_tables/sbc.tab"
;
rrdtab	equ	*-aoxtab
RRDit:	ds.l	65536

rldtab	equ	*-aoxtab
RLDit:	ds.l	65536

Flags4RxD:
	incbin	"zx-emul/z80_tables/rrd_rld.tab"
;
	ds.w	7


;==================================================
;	z80 OpCodes from #$80 - #$FF , #$00 - #$7f
;==================================================

roundlast	set	*
;
addab:				; ADD	A,B	++	100%
	addq.l	#2,d7
	move.w	d4,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.w	d5,d0
	move.w	(a7,d0.l*8),d5
	jmpnext	4
	round
addac:				; ADD	A,C	++	100%
	addq.l	#2,d7
	move.w	d5,d0
	move.b	d4,d0
	move.w	(a7,d0.l*8),d5
	jmpnext	4
	round
addad:				; ADD	A,D	++	100%
	addq.l	#2,d7
	move.w	d3,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.w	d5,d0
	move.w	(a7,d0.l*8),d5
	jmpnext	4
	round
addae:				; ADD	A,E	++	100%
	addq.l	#2,d7
	move.w	d5,d0
	move.b	d3,d0
	move.w	(a7,d0.l*8),d5
	jmpnext	4
	round
addah:				; ADD	A,H	++	100%
	addq.l	#2,d7
	move.w	d2,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.w	d5,d0
	move.w	(a7,d0.l*8),d5
	jmpnext	4
	round
addal:				; ADD	A,L	++	100%
	addq.l	#2,d7
	move.w	d5,d0
	move.b	d2,d0
	move.w	(a7,d0.l*8),d5
	jmpnext	4
	round
addaphl:			; ADD	A,(HL)	++	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.b	(a0),d5
	move.w	d5,d0
	move.w	(a7,d0.l*8),d5
	jmpnext	7
	round
addaa:				; ADD	A,A	++	100%
	addq.l	#2,d7
	move.w	d5,d0
	lsr.w	#8,d5
	move.b	d5,d0
	move.w	(a7,d0.l*8),d5
	jmpnext	4
	round
adcab:				; ADC	A,B	++	100%
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	addab+2
	move.w	d4,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.w	d5,d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	4
	round
adcac:				; ADC	A,C	++	100%
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	addac+2
	move.w	d5,d0
	move.b	d4,d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	4
	round
adcad:				; ADC	A,D	++	100%
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	addad+2
	move.w	d3,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.w	d5,d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	4
	round
adcae:				; ADC	A,E	++	100%
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	addae+2
	move.w	d5,d0
	move.b	d3,d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	4
	round
adcah:				; ADC	A,H	++	100%
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	addah+2
	move.w	d2,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.w	d5,d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	4
	round
adcal:				; ADC	A,L	++	100%
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	addal+2
	move.w	d5,d0
	move.b	d2,d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	4
	round
adcaphl:			; ADC	A,(HL)	++	100%
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	addaphl+2
	move.w	d2,a0
	move.b	(a0),d5
	move.w	d5,d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	7
	round
adcaa:				; ADC	A,A	++	100%
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	addaa+2
	move.w	d5,d0
	lsr.w	#8,d5
	move.b	d5,d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	4
	round
subb:				; SUB	B	++
	addq.l	#2,d7
	move.w	d4,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.w	d5,d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	4
	round
subc:				; SUB	C	++
	addq.l	#2,d7
	move.w	d5,d0
	move.b	d4,d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	4
	round
subd:				; SUB	D	++
	addq.l	#2,d7
	move.w	d3,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.w	d5,d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	4
	round
sube:				; SUB	E	++
	addq.l	#2,d7
	move.w	d5,d0
	move.b	d3,d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	4
	round
subh:				; SUB	H	++
	addq.l	#2,d7
	move.w	d2,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.w	d5,d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	4
	round
subl:				; SUB	L	++
	addq.l	#2,d7
	move.w	d5,d0
	move.b	d2,d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	4
	round
subphl:				; SUB	(HL)	++
	addq.l	#2,d7
	move.w	d2,a0
	move.b	(a0),d5
	move.w	d5,d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	7
	round
suba:				; SUB	A	++
	addq.l	#2,d7
	move.w	d5,d0
	lsr.w	#8,d5
	move.b	d5,d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	4
	round
sbcab:				; SBC	A,B	++
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	subb+2
	move.w	d4,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.w	d5,d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	4
	round
sbcac:				; SBC	A,C	++
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	subc+2
	move.w	d5,d0
	move.b	d4,d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	4
	round
sbcad:				; SBC	A,D	++
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	subd+2
	move.w	d3,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.w	d5,d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	4
	round
sbcae:				; SBC	A,E	++
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	sube+2
	move.w	d5,d0
	move.b	d3,d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	4
	round
sbcah:				; SBC	A,H	++
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	subh+2
	move.w	d2,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.w	d5,d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	4
	round
sbcal:				; SBC	A,L	++
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	subl+2
	move.w	d5,d0
	move.b	d2,d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	4
	round
sbcaphl:			; SBC	A,(HL)	++
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	subphl+2
	move.w	d2,a0
	move.b	(a0),d5
	move.w	d5,d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	4
	round
sbcaa:				; SBC	A,A	++
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	suba+2
	move.w	d5,d0
	lsr.w	#8,d5
	move.b	d5,d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	4
	round
andb:				; AND	B	++
	addq.l	#2,d7
	and.w	d4,d5
	lsr.w	#8,d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	4
	round
andc:				; AND	C	++
	addq.l	#2,d7
	lsr.w	#8,d5
	and.b	d4,d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	4
	round
andd:				; AND	D	++
	addq.l	#2,d7
	and.w	d3,d5
	lsr.w	#8,d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	4
	round
ande:				; AND	E	++
	addq.l	#2,d7
	lsr.w	#8,d5
	and.b	d3,d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	4
	round
andh:				; AND	H	++
	addq.l	#2,d7
	and.w	d2,d5
	lsr.w	#8,d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	4
	round
andl:				; AND	L	++
	addq.l	#2,d7
	lsr.w	#8,d5
	and.b	d2,d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	4
	round
andphl:				; AND	(HL)	++
	addq.l	#2,d7
	move.w	d2,a0
	and.w	(a0),d5
	lsr.w	#8,d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	7
	round
anda:				; AND	A	++
	addq.l	#2,d7
	lsr.w	#8,d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	4
	round
xorb:				; XOR	B	++
	addq.l	#2,d7
	eor.w	d4,d5
	lsr.w	#8,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	4
	round
xorc:				; XOR	C	++
	addq.l	#2,d7
	lsr.w	#8,d5
	eor.b	d4,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	4
	round
xord:				; XOR	D	++
	addq.l	#2,d7
	eor.w	d3,d5
	lsr.w	#8,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	4
	round
xore:				; XOR	E	++
	addq.l	#2,d7
	lsr.w	#8,d5
	eor.b	d3,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	4
	round
xorh:				; XOR	H	++
	addq.l	#2,d7
	eor.w	d2,d5
	lsr.w	#8,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	4
	round
xorl:				; XOR	L	++
	addq.l	#2,d7
	lsr.w	#8,d5
	eor.b	d2,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	4
	round
xorphl:				; XOR	(HL)	++
	addq.l	#2,d7
	move.w	d2,a0
	move.w	(a0),d0
	eor.w	d0,d5
	lsr.w	#8,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	7
	round
xora:				; XOR	A	++
	addq.l	#2,d7
	move.w	(a6),d5
	jmpnext	4
	round
orb:				; OR	B	++
	addq.l	#2,d7
	or.w	d4,d5
	lsr.w	#8,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	4
	round
orc:				; OR	C	++
	addq.l	#2,d7
	lsr.w	#8,d5
	or.b	d4,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	4
	round
ord:				; OR	D	++
	addq.l	#2,d7
	or.w	d3,d5
	lsr.w	#8,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	4
	round
ore:				; OR	E	++
	addq.l	#2,d7
	lsr.w	#8,d5
	or.b	d3,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	4
	round
orh:				; OR	H	++
	addq.l	#2,d7
	or.w	d2,d5
	lsr.w	#8,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	4
	round
orl:				; OR	L	++
	addq.l	#2,d7
	lsr.w	#8,d5
	or.b	d2,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	4
	round
orphl:				; OR	(HL)	++
	addq.l	#2,d7
	move.w	d2,a0
	or.w	(a0),d5
	lsr.w	#8,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	7
	round
ora:				; OR	A	++
	addq.l	#2,d7
	lsr.w	#8,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	4
	round
cpb:				; CP	B	++
	addq.l	#2,d7
	move.w	d4,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	4
	round
cpc:				; CP	C	++
	addq.l	#2,d7
	move.b	d4,d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	4
	round
cpd:				; CP	D	++
	addq.l	#2,d7
	move.w	d3,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	4
	round
cpe:				; CP	E	++
	addq.l	#2,d7
	move.b	d3,d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	4
	round
cph:				; CP	H	++
	addq.l	#2,d7
	move.w	d2,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	4
	round
cp_l:				; CP	L	++
	addq.l	#2,d7
	move.b	d2,d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	4
	round
cpphl:				; CP	(HL)	++
	addq.l	#2,d7
	move.w	d2,a0
	move.b	(a0),d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	7
	round
cpa:				; CP	A	++
	addq.l	#2,d7
	move.w	d5,d0
	lsr.w	#8,d0
	move.b	d0,d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	4
	round
retnz:				; RET	NZ	+N
	addq.l	#2,d7
	btst	#6,d5
	bne.s	retnz2
	RET_PR
	jmpnext	11
	cnop	0,16
retnz2:
	jmpnext	5
	round
popbc:				; POP	BC	+N
	addq.l	#2,d7
	POP	BC
	jmpnext	10
	round
jpnz:				; JP	NZ,NNNN	+N
	addq.l	#2,d7
	btst	#6,d5
	bne.s	jpnz2
	JP_PR
	jmpnext	10
	cnop	0,16
jpnz2:
	addq.w	#2,a5
	jmpnext	10
	round
jp:				; JP	NNNN	+N
	addq.l	#2,d7
	JP_PR
	jmpnext	10
	round
callnz:				; CALL	NZ,NNNN	+N
	addq.l	#2,d7
	btst	#6,d5
	bne.s	callnz2
	CALL_PR
	jmpnext	17
	cnop	0,16
callnz2:
	addq.w	#$2,a5
	jmpnext	10
	round
pushbc:				; PUSH	BC	+N
	addq.l	#2,d7
	PUSH	BC
	jmpnext	11
	round
addan:				; ADD	A,NN	++
	addq.l	#2,d7
	move.w	d5,d0
	move.b	(a5)+,d0
	move.w	(a7,d0.l*8),d5
	jmpnext	7
	round
rst0:				; RST	0	+N
	addq.l	#2,d7
	RST	0
	jmpnext	11
	round
retz:				; RET	Z	+N
	addq.l	#2,d7
	btst	#6,d5
	beq.s	retz2
	RET_PR
	jmpnext	11
	cnop	0,16
retz2:
	jmpnext	5
	round
ret:				; RET		+N
	addq.l	#2,d7
	RET_PR
	jmpnext	10
	round
jpz:				; JP	Z,NNNN	+N
	addq.l	#2,d7
	btst	#6,d5
	beq.s	jpz2
	JP_PR
	jmpnext	10
	cnop	0,16
jpz2:
	addq.w	#2,a5
	jmpnext	10
	round
cb:				; prefics CB	+N
	nop
	move.b	(a5)+,d1
cb_jumper	equ	*+4
	jmp	([cbtab,d1*4])
	round
callz:				; CALL	Z,NNNN	+N
	addq.l	#2,d7
	btst	#6,d5
	beq.s	callz2
	CALL_PR
	jmpnext	17
	cnop	0,16
callz2:
	addq.w	#$2,a5
	jmpnext	10
	round
call:				; CALL	NNNN	+N
	addq.l	#2,d7
	CALL_PR
	jmpnext	17
	round
adcan:				; ADC	A,NN	++
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	addan+2
	move.w	d5,d0
	move.b	(a5)+,d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	7
	round
rst8:				; RST	8	+N
	addq.l	#2,d7
	RST	8
	jmpnext	11
	round
retnc:				; RET	NC	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bcs.s	retnc2
	RET_PR
	jmpnext	11
	cnop	0,16
retnc2:
	jmpnext	5
	round
popde:				; POP	DE	+N
	addq.l	#2,d7
	POP	DE
	jmpnext	10
	round
jpnc:				; JP	NC,NNNN	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bcs.s	jpnc2
	JP_PR
	jmpnext	10
	cnop	0,16
jpnc2:
	addq.w	#2,a5
	jmpnext	10
	round
outpna:				; OUT	(NN),A	-N
	addq.l	#2,d7
	move.w	d5,d0
	move.b	(a5)+,d0
	moveq	#11,d1
	jmp	([outtab+131072,d0.w*4])
	round
callnc:				; CALL	NC,NNNN	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bcs.s	callnc2
	CALL_PR
	jmpnext	17
	cnop	0,16
callnc2:
	addq.w	#$2,a5
	jmpnext	10
	round
pushde:				; PUSH	DE	+N
	addq.l	#2,d7
	PUSH	DE
	jmpnext	11
	round
subn:				; SUB	N	++
	addq.l	#2,d7
	move.w	d5,d0
	move.b	(a5)+,d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	7
	round
rst16:				; RST	16	+N
	addq.l	#2,d7
	RST	16
	jmpnext	11
	round
retc:				; RET	C	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.s	retc2
	RET_PR
	jmpnext	11
	cnop	0,16
retc2:
	jmpnext	5
	round
exx:				; EXX		+N
	addq.l	#2,d7
	swap.w	HL
	swap.w	DE
	swap.w	BC
	jmpnext	4
	round
jpc:				; JP	C,NNNN	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.s	jpc2
	JP_PR
	jmpnext	10
	cnop	0,16
jpc2:
	addq.w	#2,a5
	move.w	a5,a5
	jmpnext	10
	round
inapn:				; IN	A,(NN)	-N
	addq.l	#2,d7
	move.w	d5,d0
	move.b	(a5),d0
	jmp	([intab+131072,d0.w*4])
	cnop	0,16
inapn_ret:
	move.b	d5,d1
	move.b	d0,d5
	lsl.w	#8,d5	
	move.b	d1,d5
	addq.w	#1,a5
	jmpnext	11
	round
callc:				; CALL	C,NNNN	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.s	callc2
	CALL_PR
	jmpnext	17
	cnop	0,16
callc2:
	addq.w	#$2,a5
	jmpnext	10
	round
dd:				; prefics DD	+N
	addq.w	#1*2,d7		; R=R+1
	subq.l	#4,d6		; t=t-4
	move.b	(a5)+,d1
dd_jumper	equ	*+4
	jmp	([ddtab,d1*4])
	round
sbcan:				; SBC	A,NN	+N	
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	subn+2
	move.w	d5,d0
	move.b	(a5)+,d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	7
	round
rst24:				; RST	24	+N
	addq.l	#2,d7
	RST	24
	jmpnext	11
	round
retpo:				; RET	PO	+N
	addq.l	#2,d7
	move.b	d5,ccr
	beq.s	retpo2
	RET_PR
	jmpnext	11
	cnop	0,16
retpo2:
	jmpnext	5
	round
pophl:				; POP	HL	+N
	addq.l	#2,d7
	POP	HL
	jmpnext	10
	round
jppo:				; JP	PO,NNNN	+N
	addq.l	#2,d7
	move.b	d5,ccr
	beq.s	jppo2
	JP_PR
	jmpnext	10
	cnop	0,16
jppo2:
	addq.w	#2,a5
	jmpnext	10
	round
expsphl:			; EX	(SP),HL	+N
	addq.l	#2,d7
	move.w	1(a2),d0
	move.b	(a2),d0
	rol.w	#8,d2
	move.w	d2,(a2)
	move.w	d0,d2
	jmpnext	19
	round
callpo:				; CALL	PO,NNNN	+N
	addq.l	#2,d7
	move.b	d5,ccr
	beq.s	callpo2
	CALL_PR
	jmpnext	17
	cnop	0,16
callpo2:
	addq.w	#$2,a5
	jmpnext	10
	round
pushhl:				; PUSH	HL	+N
	addq.l	#2,d7
	PUSH	HL
	jmpnext	11
	round
andn:				; AND	NN	++
	addq.l	#2,d7
	lsr.w	#8,d5
	and.b	(a5)+,d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	7
	round
rst32:				; RST	32	+N
	addq.l	#2,d7
	RST	32
	jmpnext	11
	round
retpe:				; RET	PE	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bne.s	retpe2
	RET_PR
	jmpnext	11
	cnop	0,16
retpe2:
	jmpnext	5
	round
jpphl:				; JP	(HL)	+N
	addq.l	#2,d7
	move.w	d2,a5
jump_rp:
	cmp2.w	-$14(a6),a5
	bcc.s	jpp1
	jmpnext	4
	cnop	0,16
jpp1:
	move.l	tree_base,a0
	tst.b	trdos_flg+1
	beq.s	jpp2
	jsr	setrom_basic
	jmpnext	4
	cnop	0,16
jpp2:
	btst.b	#4,Copy7FFD+1
	beq.s	jpp3
	jsr	setrom_trdos
jpp3:
	jmpnext	4
	round
jppe:				; JP	PE,NNNN	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bne.s	jppe2
	JP_PR
	jmpnext	10
	cnop	0,16
jppe2:
	addq.w	#2,a5
	jmpnext	10
	round
exdehl:				; EX	DE,HL	+N
	addq.l	#2,d7
	move.w	d2,d0
	move.w	d3,d2
	move.w	d0,d3
	jmpnext	4
	round
callpe:				; CALL	PE,NNNN	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bne.s	callpe2
	CALL_PR
	jmpnext	17
	cnop	0,16
callpe2:
	addq.w	#$2,a5
	jmpnext	10
	round
ed:				; prefics ED	+N
	nop
	move.b	(a5)+,d1
ed_jumper	equ	*+4
	jmp	([edtab,d1*4])
	round
xorn:				; XOR	NN	++
	addq.l	#2,d7
	lsr.w	#8,d5
	move.b	(a5)+,d0
	eor.b	d0,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	7
	round
rst40:				; RST	40	+N
	addq.l	#2,d7
	RST	40
	jmpnext	11
	round
retp:				; RET	P	+N
	addq.l	#2,d7
	btst	#7,d5
	bne.s	retp2
	RET_PR
	jmpnext	11
	cnop	0,16
retp2:
	jmpnext	5
	round
popaf:				; POP	AF	+N
	addq.l	#2,d7
	POP	AF
	jmpnext	10
	round
jpp:				; JP	P,NNNN	+N
	addq.l	#2,d7
	btst	#7,d5
	bne.s	jpp2x
	JP_PR
	jmpnext	10
	cnop	0,16
jpp2x:
	addq.w	#2,a5
	jmpnext	10
	round
di:				; DI		+N
	addq.l	#2,d7
	DI
	jmpnext	4
	round
callp:				; CALL	P,NNNN	+N
	addq.l	#2,d7
	btst	#7,d5
	bne.s	callp2
	CALL_PR
	jmpnext	17
	cnop	0,16
callp2:
	addq.w	#$2,a5
	jmpnext	10
	round
pushaf:				; PUSH	AF	+N
	addq.l	#2,d7
	PUSH	AF
	jmpnext	11
	round
orn:				; OR	NN	++
	addq.l	#2,d7
	lsr.w	#8,d5
	or.b	(a5)+,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	7
	round
rst48:				; RST	48	+N
	addq.l	#2,d7
	RST	48
	jmpnext	11
	round
retm:				; RET	M	+N
	addq.l	#2,d7
	btst	#7,d5
	beq.s	retm2
	RET_PR
	jmpnext	11
	cnop	0,16
retm2:
	jmpnext	5
	round
ldsphl:				; LD	SP,HL	+N
	addq.l	#2,d7
	move.w	d2,a2
	jmpnext	6
	round
jpm:				; JP	M,NNNN	+N
	addq.l	#2,d7
	btst	#7,d5
	beq.s	jpm2
	JP_PR
	jmpnext	10
	cnop	0,16
jpm2:
	addq.w	#2,a5
	jmpnext	10
	round
ei:				; EI		+N
	addq.l	#2,d7
	move.l	cmd_base,a4
	tst.w	RMODEflg
	beq.s	.1
	move.l	#cbtab+1024,cb_jumper
	move.l	#ddtab+1024,dd_jumper
	move.l	#edtab+1024,ed_jumper
	move.l	#fdtab+1024,fd_jumper
	move.l	#cbtab+1024,cb_jumper-addab-$8000(a4)
	move.l	#ddtab+1024,dd_jumper-addab-$8000(a4)
	move.l	#edtab+1024,ed_jumper-addab-$8000(a4)
	move.l	#fdtab+1024,fd_jumper-addab-$8000(a4)
	bra.s	.2
.1:
	move.l	#cbtab,cb_jumper
	move.l	#ddtab,dd_jumper
	move.l	#edtab,ed_jumper
	move.l	#fdtab,fd_jumper
	move.l	#cbtab,cb_jumper-addab-$8000(a4)
	move.l	#ddtab,dd_jumper-addab-$8000(a4)
	move.l	#edtab,ed_jumper-addab-$8000(a4)
	move.l	#fdtab,fd_jumper-addab-$8000(a4)
	addq.l	#2,a4
.2:
	tst.l	CPU?
	bne.s	.10
	opt	p=68030
	movec	cacr,d0
	or.w	#$008,d0
	movec	d0,cacr
	opt	p=68040
	bra.s	.11
.10:
	cinva	ic
.11:
	move.l	a4,cmd_base1
	EI
	jmpnext	4
	round
callm:				; CALL	M,NNNN	+N
	addq.l	#2,d7
	btst	#7,d5
	beq.s	callm2
	CALL_PR
	jmpnext	17
	cnop	0,16
callm2:
	addq.w	#$2,a5
	jmpnext	10
	round
fd:				; prefics FD	+N
	addq.w	#1*2,d7		; R=R+1
	subq.l	#4,d6		; t=t-4
	move.b	(a5)+,d1
fd_jumper	equ	*+4
	jmp	([fdtab,d1*4])
	round
cpn:				; CP	NN	++
	addq.l	#2,d7
	move.b	(a5)+,d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	7
	round
rst56:				; RST	56	+N
	addq.l	#2,d7
	RST	56
	jmpnext	11
	round

;
;
;

nop:				; NOP		+N	100%
	addq.l	#2,d7
	jmpnext 4
	round
ldbcnn:				; LD	BC,NNNN	+N	100%
	addq.l	#2,d7
	move.w	(a5)+,d4
	rol.w	#8,d4
	jmpnext 10
	round
ldbca:				; LD	(BC),A	+N	100%
	addq.l	#2,d7
	move.w	d4,a0
	move.w	d5,d0
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	7
	round
incbc:				; INC	BC	+N	100%
	addq.l	#2,d7
	addq.w	#1,d4
	jmpnext	6
	round
incb:				; INC	B	++	100%
	addq.l	#2,d7
	add.w	#$0100,d4
	move.w	d4,d0
	and.w	#$FF01,d5
	or.b	4(a6,d0.l*8),d5
	jmpnext	4
	round
decb:				; DEC	B	++	100%
	addq.l	#2,d7
	sub.w	#$0100,d4
	move.w	d4,d0
	and.w	#$FF01,d5
	or.b	5(a6,d0.l*8),d5
	jmpnext	4
	round
ldbn:				; LD	B,NN	+N	100%
	addq.l	#2,d7
	move.b	d4,d0
	move.w	(a5),d4
	move.b	d0,d4
	addq.w	#1,a5
	jmpnext	7
	round
rlca:				; RLCA		++	100%
	addq.l	#2,d7
	rol.w	#8,d5
	rol.b	d5
	bcc.s	rlca2		
	rol.w	#8,d5
	or.b	#$01,d5	; CY - ON
last_next	set	*
	jmpnext	4
rlca2:
	rol.w	#8,d5
	and.b	#$FE,d5	; CY - OFF
	jmpnext	4
	round
exafaf:				; EX	AF,AF'	+N	100%
	addq.l	#2,d7
	swap.w	d5
	jmpnext	4
	round
addhlbc:			; ADD	HL,BC	+-	100%
	addq.l	#2,d7
	lsr.w	#1,d5
	add.w	d4,d2
	roxl.w	#1,d5
	jmpnext	11
	round
ldabc:				; LD	A,(BC)	+N	100%
	addq.l	#2,d7
	move.w	d4,a0
	move.w	d5,d0
	move.w	(a0),d5
	move.b	d0,d5
	jmpnext	7
	round
decbc:				; DEC	BC	+N	100%
	addq.l	#2,d7
	subq.w	#1,d4
	jmpnext	6
	round
incc:				; INC	C	++	100%
	addq.l	#2,d7
	addq.b	#1,d4
	move.b	d4,d1
	and.w	#$FF01,d5
	or.b	2(a6,d1.w*8),d5
	jmpnext	4
	round
decc:				; DEC 	C	++	100%
	addq.l	#2,d7
	subq.b	#1,d4
	move.b	d4,d1
	and.w	#$FF01,d5
	or.b	3(a6,d1.w*8),d5
	jmpnext	4
	round
ldcn:				; LD	C,NN	+N	100%
	addq.l	#2,d7
	move.b	(a5)+,d4
	jmpnext	7
	round
rrca:				; RRCA		++	100%
	addq.l	#2,d7
	ror.w	#8,d5
	ror.b	d5
	bcc.s	rrca2		
	ror.w	#8,d5
	or.b	#$01,d5	; CY - ON
	jmpnext	4
rrca2:
	ror.w	#8,d5
	and.b	#$FE,d5	; CY - OFF
	jmpnext	4
	round
djnz:				; DJNZ	$+e	+N	100%
	addq.l	#2,d7
	rol.w	#8,d4
	subq.b	#1,d4
	beq.s	djnz2
	move.b	(a5)+,d0
	ext.w	d0
	add.w	a5,d0
	move.w	d0,a5
	rol.w	#8,d4
	jmpnext	13
	cnop	0,16
djnz2:			; b=0
	addq.w	#1,a5
	move.w	a5,a5
	rol.w	#8,d4
	jmpnext	8
	round
lddenn:				; LD	DE,NNNN	+N	100%
	addq.l	#2,d7
	move.w	(a5)+,d3
	rol.w	#8,d3
	jmpnext	10
	round
lddea:				; LD	(DE),A	+N	100%
	addq.l	#2,d7
	move.w	d3,a0
	move.w	d5,d0
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	7
	round
incde:				; INC	DE	+N	100%
	addq.l	#2,d7
	addq.w	#1,d3
	jmpnext	6
	round
incd:				; INC	D	++	100%
	addq.l	#2,d7
	add.w	#$0100,d3
	move.w	d3,d0
	and.w	#$FF01,d5
	or.b	4(a6,d0.l*8),d5
	jmpnext	4
	round
decd:				; DEC	D	++	100%
	addq.l	#2,d7
	sub.w	#$0100,d3
	move.w	d3,d0
	and.w	#$FF01,d5
	or.b	5(a6,d0.l*8),d5
	jmpnext	4
	round
lddn:				; LD	D,NN	+N	100%
	addq.l	#2,d7
	move.b	d3,d0
	move.w	(a5),d3
	move.b	d0,d3
	addq.w	#1,a5
	jmpnext	7
	round
rla:				; RLA		++	100%
	addq.l	#2,d7
	lsr.b	d5
	rol.w	#8,d5
	roxl.w	d5
	rol.w	#8,d5
	jmpnext	4
	round
jr:				; JR	$+e	+N	100%
	addq.l	#2,d7
	move.b	(a5)+,d0
	ext.w	d0
	add.w	a5,d0
	move.w	d0,a5
	jmpnext	12
	round
addhlde:			; ADD	HL,DE	+-	100%
	addq.l	#2,d7
	lsr.w	#1,d5
	add.w	d3,d2
	roxl.w	#1,d5
	jmpnext	11
	round
ldade:				; LD	A,(DE)	+N	100%
	addq.l	#2,d7
	move.w	d3,a0
	move.w	d5,d0
	move.w	(a0),d5
	move.b	d0,d5
	jmpnext	7
	round
decde:				; DEC	DE	+N	100%
	addq.l	#2,d7
	subq.w	#1,d3
	jmpnext	6
	round
ince:				; INC	E	++	100%
	addq.l	#2,d7
	addq.b	#1,d3
	move.b	d3,d1
	and.w	#$FF01,d5
	or.b	2(a6,d1.w*8),d5
	jmpnext	4
	round
dece:				; DEC 	E	++	100%
	addq.l	#2,d7
	subq.b	#1,d3
	move.b	d3,d1
	and.w	#$FF01,d5
	or.b	3(a6,d1.w*8),d5
	jmpnext	4
	round
lden:				; LD	E,NN	+N	100%
	addq.l	#2,d7
	move.b	(a5)+,d3
	jmpnext	7
	round
rra:				; RRA		++	100%
	addq.l	#2,d7
	lsr.b	d5
	rol.w	#8,d5
	roxr.b	d5
	rol.w	#8,d5
	roxl.b	d5
	jmpnext	4
	round
jrnz:				; JR	NZ,$+e	+N	100%
	addq.l	#2,d7
	btst	#6,d5
	bne.s	jrnz2
	move.b	(a5)+,d0
	ext.w	d0
	add.w	a5,d0
	move.w	d0,a5
	jmpnext	12
	cnop	0,16
jrnz2:
	addq.w	#1,a5
	move.w	a5,a5
	jmpnext	7
	round
ldhlnn:				; LD	HL,NNNN	+N	100%
	addq.l	#2,d7
	move.w	(a5)+,d2
	rol.w	#8,d2
	jmpnext	10
	round
ldpnnhl:			; LD  (NNNN),HL +N
	addq.l	#2,d7
	POKE	HL
	jmpnext	16
	round
inchl:				; INC	HL	+N	100%
	addq.l	#2,d7
	addq.w	#1,d2
	jmpnext	6
	round
inch:				; INC	H	++	100%
	addq.l	#2,d7
	add.w	#$0100,d2
	move.w	d2,d0
	and.w	#$FF01,d5
	or.b	4(a6,d0.l*8),d5
	jmpnext	4
	round
dech:				; DEC	H	++	100%
	addq.l	#2,d7
	sub.w	#$0100,d2
	move.w	d2,d0
	and.w	#$FF01,d5
	or.b	5(a6,d0.l*8),d5
	jmpnext	4
	round
ldhn:				; LD	H,NN	++	100%
	addq.l	#2,d7
	move.b	d2,d0
	move.w	(a5),d2
	move.b	d0,d2
	addq.w	#1,a5
	jmpnext	7
	round
daa:				; DAA		++
	addq.l	#2,d7
	rol.w	#8,d5
	and.w	#$1FFF,d5
	move.w	d5,d0
	move.w	(daatab,a6,d0.w*2),d5
	jmpnext	4
	round
jrz:				; JR	Z,$+e	+N	100%
	addq.l	#2,d7
	btst	#6,d5
	beq.s	jrz2
	move.b	(a5)+,d0
	ext.w	d0
	add.w	a5,d0
	move.w	d0,a5
	jmpnext	12
	cnop	0,16
jrz2:
	addq.w	#1,a5
	move.w	a5,a5
	jmpnext	7
	round
addhlhl:			; ADD	HL,HL	++	100%
	addq.l	#2,d7
	lsr.w	#1,d5
	add.w	d2,d2
	roxl.w	#1,d5
	jmpnext	11
	round
ldhlpnn:			; LD  HL,(NNNN)	+N	100%
	addq.l	#2,d7
	PEEK	HL
	jmpnext	16
	round
dechl:				; DEC	HL	+N	100%
	addq.l	#2,d7
	subq.w	#1,d2
	jmpnext	6
	round
incl:				; INC	L	++	100%
	addq.l	#2,d7
	addq.b	#1,d2
	move.b	d2,d1
	and.w	#$FF01,d5
	or.b	2(a6,d1.w*8),d5
	jmpnext	4
	round
decl:				; DEC	L	++	100%
	addq.l	#2,d7
	subq.b	#1,d2
	move.b	d2,d1
	and.w	#$FF01,d5
	or.b	3(a6,d1.w*8),d5
	jmpnext	4
	round
ldln:				; LD	L,NN	+N	100%
	addq.l	#2,d7
	move.b	(a5)+,d2
	jmpnext	7
	round
cpl:				; CPL		++	100%
	addq.l	#2,d7
	move.b	d5,d0
	not.w	d5
	move.b	d0,d5
	or.b	#$12,d5
	jmpnext	4
	round
jrnc:				; JR	NC,$+e	+N	100%
	addq.l	#2,d7
	move.w	d5,ccr
	bcs.s	jrnc2
	move.b	(a5)+,d0
	ext.w	d0
	add.w	a5,d0
	move.w	d0,a5
	jmpnext	12
	cnop	0,16
jrnc2:
	addq.w	#1,a5
	move.w	a5,a5
	jmpnext	7
	round
ldspnn:				; LD	SP,NNNN	+N	100%
	addq.l	#2,d7
	move.w	(a5)+,d0
	rol.w	#8,d0
	move.w	d0,a2
	jmpnext	10
	round
ldpnna:				; LD   (NNNN),A +N	100%
	addq.l	#2,d7
	move.w	(a5)+,d0
	rol.w	#8,d0
	move.w	d0,a0
	move.w	d5,d0
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	13
	round
incsp:				; INC	SP	+N	100%
	addq.l	#2,d7
	addq.w	#1,a2
	jmpnext	6
	round
incphl:				; INC	(HL)	++	100%
	addq.l	#2,d7
	move.w	d2,a0
	addq.b	#1,(a0)
	move.b	(a0),d1
	and.w	#$FF01,d5
	or.b	2(a6,d1.w*8),d5
	jmpnext	11
	round
decphl:				; DEC	(HL)	++
	addq.l	#2,d7
	move.w	d2,a0
	subq.b	#1,(a0)
	move.b	(a0),d1
	and.w	#$FF01,d5
	or.b	3(a6,d1.w*8),d5
	jmpnext	11
	round
ldphln:				; LD	(HL),N	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.b	(a5)+,(a0)
	jmpnext	10
	round
scf:				; SCF		++	100%
	addq.l	#2,d7
	and.b	#$ED,d5
	or.b	#$01,d5
	jmpnext	4
	round
jrc:				; JR	C,$+e	+N	100%
	addq.l	#2,d7
	move.w	d5,ccr
	bcc.s	jrc2
	move.b	(a5)+,d0
	ext.w	d0
	add.w	a5,d0
	move.w	d0,a5
	jmpnext	12
	cnop	0,16
jrc2:
	addq.w	#1,a5
	move.w	a5,a5
	jmpnext	7
	round
addhlsp:			; ADD	HL,SP	+-	100%
	addq.l	#2,d7
	lsr.w	#1,d5
	add.w	a2,d2
	roxl.w	#1,d5
	jmpnext	11
	round
ldapnn:				; LD   A,(NNNN) ++	100%
	addq.l	#2,d7
	move.w	(a5)+,d0
	rol.w	#8,d0
	move.w	d0,a0
	move.w	d5,d0
	move.w	(a0),d5
	move.b	d0,d5
	jmpnext	13
	round
decsp:				; DEC	SP	+N	100%
	addq.l	#2,d7
	subq.w	#1,a2
	jmpnext	6
	round
inca:				; INC	A	++	100%
	addq.l	#2,d7
	add.w	#$0100,d5
	move.w	d5,d0
	and.w	#$FF01,d5
	or.b	4(a6,d0.l*8),d5
	jmpnext	4
	round
deca:				; DEC	A	++	100%
	addq.l	#2,d7
	sub.w	#$0100,d5
	move.w	d5,d0
	and.w	#$FF01,d5
	or.b	5(a6,d0.l*8),d5
	jmpnext	4
	round
ldan:				; LD	A,NN	+N	100%
	addq.l	#2,d7
	move.b	d5,d0
	move.w	(a5),d5
	move.b	d0,d5
	addq.w	#1,a5
	jmpnext	7
	round
ccf:				; CCF		++	100%
	addq.l	#2,d7
	and.b	#$ED,d5
	eor.b	#1,d5
	beq.s	ccf2
	or.b	#$10,d5
ccf2:
	jmpnext	4
	round
ldbb:				; LD	B,B	+N	100%
	addq.l	#2,d7
	jmpnext	4
	round
ldbc:				; LD	B,C	+N	100%
	addq.l	#2,d7
	move.w	d4,d0
	lsl.w	#8,d4
	move.b	d0,d4
	jmpnext	4
	round
ldbd:				; LD	B,D	+N	100%
	addq.l	#2,d7
	move.w	d4,d0
	move.w	d3,d4
	move.b	d0,d4
	jmpnext	4
	round
ldbe:				; LD	B,E	+N	100%
	addq.l	#2,d7
	move.w	d4,d0
	move.w	d3,d4
	lsl.w	#8,d4
	move.b	d0,d4
	jmpnext	4
	round
ldbh:				; LD	B,H	+N	100%
	addq.l	#2,d7
	move.w	d4,d0
	move.w	d2,d4
	move.b	d0,d4
	jmpnext	4
	round
ldbl:				; LD	B,L	+N	100%
	addq.l	#2,d7
	move.w	d4,d0
	move.w	d2,d4
	lsl.w	#8,d4
	move.b	d0,d4
	jmpnext	4
	round
ldbphl:				; LD	B,(HL)	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.w	d4,d0
	move.w	(a0),d4
	move.b	d0,d4
	jmpnext	7
	round
ldba:				; LD	B,A	+N	100%
	addq.l	#2,d7
	move.w	d4,d0
	move.w	d5,d4
	move.b	d0,d4
	jmpnext	4
	round
ldcb:				; LD	C,B	+N	100%
	addq.l	#2,d7
	move.w	d4,d0
	lsr.w	#8,d0
	move.b	d0,d4
	jmpnext	4
	round
ldcc:				; LD	C,C	+N	100%
	addq.l	#2,d7
	jmpnext	4
	round
ldcd:				; LD	C,D	+N	100%
	addq.l	#2,d7
	move.w	d3,d0
	lsr.w	#8,d0
	move.b	d0,d4
	jmpnext	4
	round
ldce:				; LD	C,E	+N	100%
	addq.l	#2,d7
	move.b	d3,d4
	jmpnext	4
	round
ldch:				; LD	C,H	+N	100%
	addq.l	#2,d7
	move.w	d2,d0
	lsr.w	#8,d0
	move.b	d0,d4
	jmpnext	4
	round
ldcl:				; LD	C,L	+N	100%
	addq.l	#2,d7
	move.b	d2,d4
	jmpnext	4
	round
ldcphl:				; LD	C,(HL)	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.b	(a0),d4
	jmpnext	7
	round
ldca:				; LD	C,A	+N	100%
	addq.l	#2,d7
	move.w	d5,d0
	lsr.w	#8,d0
	move.b	d0,d4
	jmpnext	4
	round
lddb:				; LD	D,B	+N	100%
	addq.l	#2,d7
	move.w	d3,d0
	move.w	d4,d3
	move.b	d0,d3
	jmpnext	4
	round
lddc:				; LD	D,C	+N	100%
	addq.l	#2,d7
	move.w	d3,d0
	move.w	d4,d3
	lsl.w	#8,d3
	move.b	d0,d3
	jmpnext	4
	round
lddd:				; LD	D,D	+N	100%
	addq.l	#2,d7
	jmpnext	4
	round
ldde:				; LD	D,E	+N	100%
	addq.l	#2,d7
	move.w	d3,d0
	lsl.w	#8,d3
	move.b	d0,d3
	jmpnext	4
	round
lddh:				; LD	D,H	+N	100%
	addq.l	#2,d7
	move.w	d3,d0
	move.w	d2,d3
	move.b	d0,d3
	jmpnext	4
	round
lddl:				; LD	D,L	+N	100%
	addq.l	#2,d7
	move.w	d3,d0
	move.w	d2,d3
	lsl.w	#8,d3
	move.b	d0,d3
	jmpnext	4
	round
lddphl:				; LD	D,(HL)	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.w	d3,d0
	move.w	(a0),d3
	move.b	d0,d3
	jmpnext	7
	round
ldda:				; LD	D,A	+N	100%
	addq.l	#2,d7
	move.w	d3,d0
	move.w	d5,d3
	move.b	d0,d3
	jmpnext	4
	round
ldeb:				; LD	E,B	+N	100%
	addq.l	#2,d7
	move.w	d4,d0
	lsr.w	#8,d0
	move.b	d0,d3
	jmpnext	4
	round
ldec:				; LD	E,C	+N	100%
	addq.l	#2,d7
	move.b	d4,d3
	jmpnext	4
	round
lded:				; LD	E,D	+N	100%
	addq.l	#2,d7
	move.w	d3,d0
	lsr.w	#8,d0
	move.b	d0,d3
	jmpnext	4
	round
ldee:				; LD	E,E	+N	100%
	addq.l	#2,d7
	jmpnext	4
	round
ldeh:				; LD	E,H	+N	100%
	addq.l	#2,d7
	move.w	d2,d0
	lsr.w	#8,d0
	move.b	d0,d3
	jmpnext	4
	round
ldel:				; LD	E,L	+N	100%
	addq.l	#2,d7
	move.b	d2,d3
	jmpnext	4
	round
ldephl:				; LD	E,(HL)	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.b	(a0),d3
	jmpnext	7
	round
ldea:				; LD	E,A	+N	100%
	addq.l	#2,d7
	move.w	d5,d0
	lsr.w	#8,d0
	move.b	d0,d3
	jmpnext	4
	round
ldhb:				; LD	H,B	+N	100%
	addq.l	#2,d7
	move.w	d2,d0
	move.w	d4,d2
	move.b	d0,d2
	jmpnext	4
	round
ldhc:				; LD	H,C	+N	100%
	addq.l	#2,d7
	move.w	d2,d0
	move.w	d4,d2
	lsl.w	#8,d2
	move.b	d0,d2
	jmpnext	4
	round
ldhd:				; LD	H,D	+N	100%
	addq.l	#2,d7
	move.w	d2,d0
	move.w	d3,d2
	move.b	d0,d2
	jmpnext	4
	round
ldhe:				; LD	H,E	+N	100%
	addq.l	#2,d7
	move.w	d2,d0
	move.w	d3,d2
	lsl.w	#8,d2
	move.b	d0,d2
	jmpnext	4
	round
ldhh:				; LD	H,H	+N	100%
	addq.l	#2,d7
	jmpnext	4
	round
ldhl:				; LD	H,L	+N	100%
	addq.l	#2,d7
	move.w	d2,d0
	lsl.w	#8,d2
	move.b	d0,d2
	jmpnext	4
	round
ldhphl:				; LD	H,(HL)	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.w	d2,d0
	move.w	(a0),d2
	move.b	d0,d2
	jmpnext	7
	round
ldha:				; LD	H,A	+N	100%
	addq.l	#2,d7
	move.w	d2,d0
	move.w	d5,d2
	move.b	d0,d2
	jmpnext	4
	round
ldlb:				; LD	L,B	+N	100%
	addq.l	#2,d7
	move.w	d4,d0
	lsr.w	#8,d0
	move.b	d0,d2
	jmpnext	4
	round
ldlc:				; LD	L,C	+N	100%
	addq.l	#2,d7
	move.b	d4,d2
	jmpnext	4
	round
ldld:				; LD	L,D	+N	100%
	addq.l	#2,d7
	move.w	d3,d0
	lsr.w	#8,d0
	move.b	d0,d2
	jmpnext	4
	round
ldle:				; LD	L,E	+N	100%
	addq.l	#2,d7
	move.b	d3,d2
	jmpnext	4
	round
ldlh:				; LD	L,H	+N	100%
	addq.l	#2,d7
	move.w	d2,d0
	lsr.w	#8,d0
	move.b	d0,d2
	jmpnext	4
	round
ldll:				; LD	L,L	+N	100%
	addq.l	#2,d7
	jmpnext	4
	round
ldlphl:				; LD	L,(HL)	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.b	(a0),d2
	jmpnext	7
	round
ldla:				; LD	L,A	+N	100%
	addq.l	#2,d7
	move.w	d5,d0
	lsr.w	#8,d0
	move.b	d0,d2
	jmpnext	4
	round
ldphlb:				; LD	(HL),B	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.w	d4,d0
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	7
	round
ldphlc:				; LD	(HL),C	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.b	d4,(a0)
	jmpnext	7
	round
ldphld:				; LD	(HL),D	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.w	d3,d0
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	7
	round
ldphle:				; LD	(HL),E	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.b	d3,(a0)
	jmpnext	7
	round
ldphlh:				; LD	(HL),H	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.w	d2,d0
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	7
	round
ldphll:				; LD	(HL),L	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.b	d2,(a0)
	jmpnext	7
	round
halt:				; HALT		+N
	addq.l	#2,d7
	subq.w	#1,a5
	move.w	a5,a5
	jmpnext	4
	round
ldphla:				; LD	(HL),A	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.w	d5,d0
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	7
	round
ldab:				; LD	A,B	+N	100%
	addq.l	#2,d7
	move.w	d5,d0
	move.w	d4,d5
	move.b	d0,d5
	jmpnext	4
	round
ldac:				; LD	A,C	+N	100%
	addq.l	#2,d7
	move.w	d5,d0
	move.w	d4,d5
	lsl.w	#8,d5
	move.b	d0,d5
	jmpnext	4
	round
ldad:				; LD	A,D	+N	100%
	addq.l	#2,d7
	move.w	d5,d0
	move.w	d3,d5
	move.b	d0,d5
	jmpnext	4
	round
ldae:				; LD	A,E	+N	100%
	addq.l	#2,d7
	move.w	d5,d0
	move.w	d3,d5
	lsl.w	#8,d5
	move.b	d0,d5
	jmpnext	4
	round
ldah:				; LD	A,H	+N	100%
	addq.l	#2,d7
	move.w	d5,d0
	move.w	d2,d5
	move.b	d0,d5
	jmpnext	4
	round
ldal:				; LD	A,L	+N	100%
	addq.l	#2,d7
	move.w	d5,d0
	move.w	d2,d5
	lsl.w	#8,d5
	move.b	d0,d5
	jmpnext	4
	round
ldaphl:				; LD	A,(HL)	+N	100%
	addq.l	#2,d7
	move.w	d2,a0
	move.b	d5,d0
	move.w	(a0),d5
	move.b	d0,d5
	jmpnext	7
	round
ldaa:				; LD	A,A	+N	100%
	addq.l	#2,d7
	jmpnext	4
	round
;
	cnop	0,16
cbtab:
	dc.l	rlc_b,rlc_c,rlc_d,rlc_e,rlc_h,rlc_l,rlc_hl,rlc_a
	dc.l	rrc_b,rrc_c,rrc_d,rrc_e,rrc_h,rrc_l,rrc_hl,rrc_a
	dc.l	rl_b,rl_c,rl_d,rl_e,rl_h,rl_l,rl_hl,rl_a
	dc.l	rr_b,rr_c,rr_d,rr_e,rr_h,rr_l,rr_hl,rr_a
	dc.l	sla_b,sla_c,sla_d,sla_e,sla_h,sla_l,sla_hl,sla_a
	dc.l	sra_b,sra_c,sra_d,sra_e,sra_h,sra_l,sra_hl,sra_a
	dc.l	sli_b,sli_c,sli_d,sli_e,sli_h,sli_l,sli_hl,sli_a
	dc.l	srl_b,srl_c,srl_d,srl_e,srl_h,srl_l,srl_hl,srl_a
	dc.l	bit0b,bit0c,bit0d,bit0e,bit0h,bit0l,bit0hl,bit0a
	dc.l	bit1b,bit1c,bit1d,bit1e,bit1h,bit1l,bit1hl,bit1a
	dc.l	bit2b,bit2c,bit2d,bit2e,bit2h,bit2l,bit2hl,bit2a
	dc.l	bit3b,bit3c,bit3d,bit3e,bit3h,bit3l,bit3hl,bit3a
	dc.l	bit4b,bit4c,bit4d,bit4e,bit4h,bit4l,bit4hl,bit4a
	dc.l	bit5b,bit5c,bit5d,bit5e,bit5h,bit5l,bit5hl,bit5a
	dc.l	bit6b,bit6c,bit6d,bit6e,bit6h,bit6l,bit6hl,bit6a
	dc.l	bit7b,bit7c,bit7d,bit7e,bit7h,bit7l,bit7hl,bit7a
	dc.l	res0b,res0c,res0d,res0e,res0h,res0l,res0hl,res0a
	dc.l	res1b,res1c,res1d,res1e,res1h,res1l,res1hl,res1a
	dc.l	res2b,res2c,res2d,res2e,res2h,res2l,res2hl,res2a
	dc.l	res3b,res3c,res3d,res3e,res3h,res3l,res3hl,res3a
	dc.l	res4b,res4c,res4d,res4e,res4h,res4l,res4hl,res4a
	dc.l	res5b,res5c,res5d,res5e,res5h,res5l,res5hl,res5a
	dc.l	res6b,res6c,res6d,res6e,res6h,res6l,res6hl,res6a
	dc.l	res7b,res7c,res7d,res7e,res7h,res7l,res7hl,res7a
	dc.l	set0b,set0c,set0d,set0e,set0h,set0l,set0hl,set0a
	dc.l	set1b,set1c,set1d,set1e,set1h,set1l,set1hl,set1a
	dc.l	set2b,set2c,set2d,set2e,set2h,set2l,set2hl,set2a
	dc.l	set3b,set3c,set3d,set3e,set3h,set3l,set3hl,set3a
	dc.l	set4b,set4c,set4d,set4e,set4h,set4l,set4hl,set4a
	dc.l	set5b,set5c,set5d,set5e,set5h,set5l,set5hl,set5a
	dc.l	set6b,set6c,set6d,set6e,set6h,set6l,set6hl,set6a
	dc.l	set7b,set7c,set7d,set7e,set7h,set7l,set7hl,set7a
	ds.l	256
ddtab:
	dc.l	nop,ldbcnn,ldbca,incbc,incb,decb,ldbn,rlca
	dc.l	exafaf,addixbc,ldabc,decbc,incc,decc,ldcn,rrca
	dc.l	djnz,lddenn,lddea,incde,incd,decd,lddn,rla
	dc.l	jr,addixde,ldade,decde,ince,dece,lden,rra
	dc.l	jrnz,ldixnn,ldpnnix,incix,inchx,dechx,ldhxn,daa
	dc.l	jrz,addixix,ldixpnn,decix,inclx,declx,ldlxn,cpl
	dc.l	jrnc,ldspnn,ldpnna,incsp,incpix,decpix,ldpixn,scf
	dc.l	jrc,addixsp,ldapnn,decsp,inca,deca,ldan,ccf
	dc.l	ldbb,ldbc,ldbd,ldbe,ldbhx,ldblx,ldbpix,ldba
	dc.l	ldcb,ldcc,ldcd,ldce,ldchx,ldclx,ldcpix,ldca
	dc.l	lddb,lddc,lddd,ldde,lddhx,lddlx,lddpix,ldda
	dc.l	ldeb,ldec,lded,ldee,ldehx,ldelx,ldepix,ldea
	dc.l	ldhxb,ldhxc,ldhxd,ldhxe,ldhxhx,ldhxlx,ldhpix,ldhxa
	dc.l	ldlxb,ldlxc,ldlxd,ldlxe,ldlxhx,ldlxlx,ldlpix,ldlxa
	dc.l	ldpixb,ldpixc,ldpixd,ldpixe,ldpixh,ldpixl,halt,ldpixa
	dc.l	ldab,ldac,ldad,ldae,ldahx,ldalx,ldapix,ldaa
	dc.l	addab,addac,addad,addae,addahx,addalx,addapix,addaa
	dc.l	adcab,adcac,adcad,adcae,adcahx,adcalx,adcapix,adcaa
	dc.l	subb,subc,subd,sube,subhx,sublx,subpix,suba
	dc.l	sbcab,sbcac,sbcad,sbcae,sbcahx,sbcalx,sbcapix,sbcaa
	dc.l	andb,andc,andd,ande,andhx,andlx,andpix,anda
	dc.l	xorb,xorc,xord,xore,xorhx,xorlx,xorpix,xora
	dc.l	orb,orc,ord,ore,orhx,orlx,orpix,ora
	dc.l	cpb,cpc,cpd,cpe,cphx,cp_lx,cppix,cpa
	dc.l	retnz,popbc,jpnz,jp,callnz,pushbc,addan,rst0
	dc.l	retz,ret,jpz,ddcb,callz,call,adcan,rst8
	dc.l	retnc,popde,jpnc,outpna,callnc,pushde,subn,rst16
	dc.l	retc,exx,jpc,inapn,callc,dd,sbcan,rst24
	dc.l	retpo,popix,jppo,expspix,callpo,pushix,andn,rst32
	dc.l	retpe,jppix,jppe,exdehl,callpe,ed,xorn,rst40
	dc.l	retp,popaf,jpp,di,callp,pushaf,orn,rst48
	dc.l	retm,ldspix,jpm,ei,callm,fd,cpn,rst56
	ds.l	256
edtab:
	rept	64
	dc.l	ednop
	endr
	dc.l	inbpc,outpcb,sbchlbc,ldpnnbc,neg,retn,im0,ldia
	dc.l	incpc,outpcc,adchlbc,ldbcpnn,neg,reti,im0,ldra
	dc.l	indpc,outpcd,sbchlde,ldpnnde,neg,retn,im1,ldai
	dc.l	inepc,outpce,adchlde,lddepnn,neg,reti,im2,ldar
	dc.l	inhpc,outpch,sbchlhl,ldpnhl2,neg,retn,im0,rrd
	dc.l	inlpc,outpcl,adchlhl,ldhlpn2,neg,reti,im0,rld
	dc.l	inhlc,outpc0,sbchlsp,ldpnnsp,neg,retn,im1,ednop
	dc.l	inapc,outpca,adchlsp,ldsppnn,neg,reti,im2,ednop
	rept	32
	dc.l	ednop
	endr
	dc.l	ldi,cpi,ini,outi,ednop,ednop,ednop,ednop
	dc.l	ldd,cp_d,ind,outd,ednop,ednop,ednop,ednop
	dc.l	ldir,cpir,inir,otir,ednop,ednop,ednop,ednop
	dc.l	lddr,cpdr,indr,otdr,ednop,ednop,ednop,ednop
	rept	61
	dc.l	ednop
	endr
	dc.l	WaitKBD
	dc.l	LoadTap	; $ed $fe
	dc.l	Upor	; $ed $ff - Stop Emulation...
	ds.l	256
fdtab:
	dc.l	nop,ldbcnn,ldbca,incbc,incb,decb,ldbn,rlca
	dc.l	exafaf,addiybc,ldabc,decbc,incc,decc,ldcn,rrca
	dc.l	djnz,lddenn,lddea,incde,incd,decd,lddn,rla
	dc.l	jr,addiyde,ldade,decde,ince,dece,lden,rra
	dc.l	jrnz,ldiynn,ldpnniy,inciy,inchy,dechy,ldhyn,daa
	dc.l	jrz,addiyiy,ldiypnn,deciy,incly,decly,ldlyn,cpl
	dc.l	jrnc,ldspnn,ldpnna,incsp,incpiy,decpiy,ldpiyn,scf
	dc.l	jrc,addiysp,ldapnn,decsp,inca,deca,ldan,ccf
	dc.l	ldbb,ldbc,ldbd,ldbe,ldbhy,ldbly,ldbpiy,ldba
	dc.l	ldcb,ldcc,ldcd,ldce,ldchy,ldcly,ldcpiy,ldca
	dc.l	lddb,lddc,lddd,ldde,lddhy,lddly,lddpiy,ldda
	dc.l	ldeb,ldec,lded,ldee,ldehy,ldely,ldepiy,ldea
	dc.l	ldhyb,ldhyc,ldhyd,ldhye,ldhyhy,ldhyly,ldhpiy,ldhya
	dc.l	ldlyb,ldlyc,ldlyd,ldlye,ldlyhy,ldlyly,ldlpiy,ldlya
	dc.l	ldpiyb,ldpiyc,ldpiyd,ldpiye,ldpiyh,ldpiyl,halt,ldpiya
	dc.l	ldab,ldac,ldad,ldae,ldahy,ldaly,ldapiy,ldaa
	dc.l	addab,addac,addad,addae,addahy,addaly,addapiy,addaa
	dc.l	adcab,adcac,adcad,adcae,adcahy,adcaly,adcapiy,adcaa
	dc.l	subb,subc,subd,sube,subhy,subly,subpiy,suba
	dc.l	sbcab,sbcac,sbcad,sbcae,sbcahy,sbcaly,sbcapiy,sbcaa
	dc.l	andb,andc,andd,ande,andhy,andly,andpiy,anda
	dc.l	xorb,xorc,xord,xore,xorhy,xorly,xorpiy,xora
	dc.l	orb,orc,ord,ore,orhy,orly,orpiy,ora
	dc.l	cpb,cpc,cpd,cpe,cphy,cp_ly,cppiy,cpa
	dc.l	retnz,popbc,jpnz,jp,callnz,pushbc,addan,rst0
	dc.l	retz,ret,jpz,fdcb,callz,call,adcan,rst8
	dc.l	retnc,popde,jpnc,outpna,callnc,pushde,subn,rst16
	dc.l	retc,exx,jpc,inapn,callc,dd,sbcan,rst24
	dc.l	retpo,popiy,jppo,expspiy,callpo,pushiy,andn,rst32
	dc.l	retpe,jppiy,jppe,exdehl,callpe,ed,xorn,rst40
	dc.l	retp,popaf,jpp,di,callp,pushaf,orn,rst48
	dc.l	retm,ldspiy,jpm,ei,callm,fd,cpn,rst56
	ds.l	256

;-------------------------------------------------
;
;	prefics CB commands...
;
;-------------------------------------------------

;
;	RLC , RRC , SLA , SRA , SLI , SRL   $00 - $0F , $20 - $3F
;

ROL_HI:	macro
	addq.l	#4,d7
	move.w	\1,d0
	lsr.w	#8,d0
	move.w	(\2,a6,d0.w*2),d0
	move.b	d0,d5
	move.b	\1,d0
	move.w	d0,\1
	jmpnext	8
	endm

ROL_LO:	macro
	addq.l	#4,d7
	move.b	\1,d1
	move.w	(\2,a6,d1.w*2),d0
	move.b	d0,d5
	lsr.w	#8,d0
	move.b	d0,\1
	jmpnext	8
	endm

ROL_HL:	macro
	addq.l	#4,d7
	move.w	d2,a0
	move.b	(a0),d1
	move.w	(\1,a6,d1.w*2),d0
	move.b	d0,d5
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	15
	endm

ROL_A:	macro
	addq.l	#4,d7
	lsr.w	#8,d5
	move.w	(\1,a6,d5.w*2),d5
	jmpnext	8
	endm

;
;	RL , RR			CB + code from $10 - $1F
;

RL_HI:	macro
	addq.l	#4,d7
	move.w	\1,d0
	move.b	d5,d0
	rol.w	#8,d0
	and.w	#$01FF,d0
	move.w	(\2,a6,d0.w*2),d0
	move.b	d0,d5
	move.b	\1,d0
	move.w	d0,\1
	jmpnext	8
	endm

RL_LO:	macro
	addq.l	#4,d7
	move.b	d5,d0
	lsl.w	#8,d0
	move.b	\1,d0	
	and.w	#$01FF,d0
	move.w	(\2,a6,d0.w*2),d0
	move.b	d0,d5
	lsr.w	#8,d0
	move.b	d0,\1
	jmpnext	8
	endm

RL_HL:	macro
	addq.l	#4,d7
	move.w	d2,a0
	move.b	d5,d0
	lsl.w	#8,d0
	move.b	(a0),d0
	and.w	#$01FF,d0
	move.w	(\1,a6,d0.w*2),d0
	move.b	d0,d5
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	15
	endm

RL_A:	macro
	addq.l	#4,d7
	rol.w	#8,d5
	and.w	#$01FF,d5
	move.w	(\1,a6,d5.w*2),d5
	jmpnext	8
	endm

	cnop	0,16
	ds.w	7

rlc_b:	ROL_HI	B,rlctab
rlc_c:	ROL_LO	C,rlctab
rlc_d:	ROL_HI	D,rlctab
rlc_e:	ROL_LO	E,rlctab
rlc_h:	ROL_HI	H,rlctab
rlc_l:	ROL_LO	L,rlctab
rlc_hl:	ROL_HL	rlctab
rlc_a:	ROL_A	rlctab
rrc_b:	ROL_HI	B,rrctab
rrc_c:	ROL_LO	C,rrctab
rrc_d:	ROL_HI	D,rrctab
rrc_e:	ROL_LO	E,rrctab
rrc_h:	ROL_HI	H,rrctab
rrc_l:	ROL_LO	L,rrctab
rrc_hl:	ROL_HL	rrctab
rrc_a:	ROL_A	rrctab
rl_b:	RL_HI	B,rltab
rl_c:	RL_LO	C,rltab
rl_d:	RL_HI	D,rltab
rl_e:	RL_LO	E,rltab
rl_h:	RL_HI	H,rltab
rl_l:	RL_LO	L,rltab
rl_hl:	RL_HL	rltab
rl_a:	RL_A	rltab
rr_b:	RL_HI	B,rrtab
rr_c:	RL_LO	C,rrtab
rr_d:	RL_HI	D,rrtab
rr_e:	RL_LO	E,rrtab
rr_h:	RL_HI	H,rrtab
rr_l:	RL_LO	L,rrtab
rr_hl:	RL_HL	rrtab
rr_a:	RL_A	rrtab
sla_b:	ROL_HI	B,slatab
sla_c:	ROL_LO	C,slatab
sla_d:	ROL_HI	D,slatab
sla_e:	ROL_LO	E,slatab
sla_h:	ROL_HI	H,slatab
sla_l:	ROL_LO	L,slatab
sla_hl:	ROL_HL	slatab
sla_a:	ROL_A	slatab
sra_b:	ROL_HI	B,sratab
sra_c:	ROL_LO	C,sratab
sra_d:	ROL_HI	D,sratab
sra_e:	ROL_LO	E,sratab
sra_h:	ROL_HI	H,sratab
sra_l:	ROL_LO	L,sratab
sra_hl:	ROL_HL	sratab
sra_a:	ROL_A	sratab
sli_b:	ROL_HI	B,slitab
sli_c:	ROL_LO	C,slitab
sli_d:	ROL_HI	D,slitab
sli_e:	ROL_LO	E,slitab
sli_h:	ROL_HI	H,slitab
sli_l:	ROL_LO	L,slitab
sli_hl:	ROL_HL	slitab
sli_a:	ROL_A	slitab
srl_b:	ROL_HI	B,srltab
srl_c:	ROL_LO	C,srltab
srl_d:	ROL_HI	D,srltab
srl_e:	ROL_LO	E,srltab
srl_h:	ROL_HI	H,srltab
srl_l:	ROL_LO	L,srltab
srl_hl:	ROL_HL	srltab
srl_a:	ROL_A	srltab


;
;	BIT (0..7),r			$CB + code from $40 to 7F
;

BIT_HI:	macro
	addq.l	#4,d7
	move.w	\2,d1
	lsr.w	#8,d1
	and.b	#$01,d5
	or.b	(bittab+256*\1,a6,d1),d5
	jmpnext	8
	endm

BIT_LO:	macro
	addq.l	#4,d7
	move.b	\2,d1
	and.b	#$01,d5
	or.b	(bittab+256*\1,a6,d1),d5
	jmpnext	8
	endm

BIT_HL:	macro
	addq.l	#4,d7
	move.w	d2,a0
	move.b	(a0),d1
	and.b	#$01,d5
	or.b	(bittab+256*\1,a6,d1),d5
	jmpnext	12
	endm
	
bit0b:	BIT_HI	0,B
bit0c:	BIT_LO	0,C
bit0d:	BIT_HI	0,D
bit0e:	BIT_LO	0,E
bit0h:	BIT_HI	0,H
bit0l:	BIT_LO	0,L
bit0hl:	BIT_HL	0
bit0a:	BIT_HI	0,A
bit1b:	BIT_HI	1,B
bit1c:	BIT_LO	1,C
bit1d:	BIT_HI	1,D
bit1e:	BIT_LO	1,E
bit1h:	BIT_HI	1,H
bit1l:	BIT_LO	1,L
bit1hl:	BIT_HL	1
bit1a:	BIT_HI	1,A
bit2b:	BIT_HI	2,B
bit2c:	BIT_LO	2,C
bit2d:	BIT_HI	2,D
bit2e:	BIT_LO	2,E
bit2h:	BIT_HI	2,H
bit2l:	BIT_LO	2,L
bit2hl:	BIT_HL	2
bit2a:	BIT_HI	2,A
bit3b:	BIT_HI	3,B
bit3c:	BIT_LO	3,C
bit3d:	BIT_HI	3,D
bit3e:	BIT_LO	3,E
bit3h:	BIT_HI	3,H
bit3l:	BIT_LO	3,L
bit3hl:	BIT_HL	3
bit3a:	BIT_HI	3,A
bit4b:	BIT_HI	4,B
bit4c:	BIT_LO	4,C
bit4d:	BIT_HI	4,D
bit4e:	BIT_LO	4,E
bit4h:	BIT_HI	4,H
bit4l:	BIT_LO	4,L
bit4hl:	BIT_HL	4
bit4a:	BIT_HI	4,A
bit5b:	BIT_HI	5,B
bit5c:	BIT_LO	5,C
bit5d:	BIT_HI	5,D
bit5e:	BIT_LO	5,E
bit5h:	BIT_HI	5,H
bit5l:	BIT_LO	5,L
bit5hl:	BIT_HL	5
bit5a:	BIT_HI	5,A
bit6b:	BIT_HI	6,B
bit6c:	BIT_LO	6,C
bit6d:	BIT_HI	6,D
bit6e:	BIT_LO	6,E
bit6h:	BIT_HI	6,H
bit6l:	BIT_LO	6,L
bit6hl:	BIT_HL	6
bit6a:	BIT_HI	6,A
bit7b:	BIT_HI	7,B
bit7c:	BIT_LO	7,C
bit7d:	BIT_HI	7,D
bit7e:	BIT_LO	7,E
bit7h:	BIT_HI	7,H
bit7l:	BIT_LO	7,L
bit7hl:	BIT_HL	7
bit7a:	BIT_HI	7,A


;
;	RES (0..7),r , SET (0..7),r	$CB + code from $80 to $FF
;

RES:	macro
	addq.l	#4,d7
	and.w	#$\1,\2
	jmpnext	8
	endm

RES_HL:	macro
	addq.l	#4,d7
	move.w	d2,a0
	and.b	#$\1,(a0)
	jmpnext	15
	endm

SET_RR:	macro
	addq.l	#4,d7
	or.w	#$\1,\2
	jmpnext	8
	endm

SET_HL:	macro
	addq.l	#4,d7
	move.w	d2,a0
	or.b	#$\1,(a0)
	jmpnext	15
	endm


res0b:	RES	FEFF,B
res0c:	RES	FFFE,C
res0d:	RES	FEFF,D
res0e:	RES	FFFE,E
res0h:	RES	FEFF,H
res0l:	RES	FFFE,L
res0hl:	RES_HL	FE
res0a:	RES	FEFF,A
res1b:	RES	FDFF,B
res1c:	RES	FFFD,C
res1d:	RES	FDFF,D
res1e:	RES	FFFD,E
res1h:	RES	FDFF,H
res1l:	RES	FFFD,L
res1hl:	RES_HL	FD
res1a:	RES	FDFF,A
res2b:	RES	FBFF,B
res2c:	RES	FFFB,C
res2d:	RES	FBFF,D
res2e:	RES	FFFB,E
res2h:	RES	FBFF,H
res2l:	RES	FFFB,L
res2hl:	RES_HL	FB
res2a:	RES	FBFF,A
res3b:	RES	F7FF,B
res3c:	RES	FFF7,C
res3d:	RES	F7FF,D
res3e:	RES	FFF7,E
res3h:	RES	F7FF,H
res3l:	RES	FFF7,L
res3hl:	RES_HL	F7
res3a:	RES	F7FF,A
res4b:	RES	EFFF,B
res4c:	RES	FFEF,C
res4d:	RES	EFFF,D
res4e:	RES	FFEF,E
res4h:	RES	EFFF,H
res4l:	RES	FFEF,L
res4hl:	RES_HL	EF
res4a:	RES	EFFF,A
res5b:	RES	DFFF,B
res5c:	RES	FFDF,C
res5d:	RES	DFFF,D
res5e:	RES	FFDF,E
res5h:	RES	DFFF,H
res5l:	RES	FFDF,L
res5hl:	RES_HL	DF
res5a:	RES	DFFF,A
res6b:	RES	BFFF,B
res6c:	RES	FFBF,C
res6d:	RES	BFFF,D
res6e:	RES	FFBF,E
res6h:	RES	BFFF,H
res6l:	RES	FFBF,L
res6hl:	RES_HL	BF
res6a:	RES	BFFF,A
res7b:	RES	7FFF,B
res7c:	RES	FF7F,C
res7d:	RES	7FFF,D
res7e:	RES	FF7F,E
res7h:	RES	7FFF,H
res7l:	RES	FF7F,L
res7hl:	RES_HL	7F
res7a:	RES	7FFF,A

set0b:	SET_RR	0100,B
set0c:	SET_RR	0001,C
set0d:	SET_RR	0100,D
set0e:	SET_RR	0001,E
set0h:	SET_RR	0100,H
set0l:	SET_RR	0001,L
set0hl:	SET_HL	01
set0a:	SET_RR	0100,A
set1b:	SET_RR	0200,B
set1c:	SET_RR	0002,C
set1d:	SET_RR	0200,D
set1e:	SET_RR	0002,E
set1h:	SET_RR	0200,H
set1l:	SET_RR	0002,L
set1hl:	SET_HL	02
set1a:	SET_RR	0200,A
set2b:	SET_RR	0400,B
set2c:	SET_RR	0004,C
set2d:	SET_RR	0400,D
set2e:	SET_RR	0004,E
set2h:	SET_RR	0400,H
set2l:	SET_RR	0004,L
set2hl:	SET_HL	04
set2a:	SET_RR	0400,A
set3b:	SET_RR	0800,B
set3c:	SET_RR	0008,C
set3d:	SET_RR	0800,D
set3e:	SET_RR	0008,E
set3h:	SET_RR	0800,H
set3l:	SET_RR	0008,L
set3hl:	SET_HL	08
set3a:	SET_RR	0800,A
set4b:	SET_RR	1000,B
set4c:	SET_RR	0010,C
set4d:	SET_RR	1000,D
set4e:	SET_RR	0010,E
set4h:	SET_RR	1000,H
set4l:	SET_RR	0010,L
set4hl:	SET_HL	10
set4a:	SET_RR	1000,A
set5b:	SET_RR	2000,B
set5c:	SET_RR	0020,C
set5d:	SET_RR	2000,D
set5e:	SET_RR	0020,E
set5h:	SET_RR	2000,H
set5l:	SET_RR	0020,L
set5hl:	SET_HL	20
set5a:	SET_RR	2000,A
set6b:	SET_RR	4000,B
set6c:	SET_RR	0040,C
set6d:	SET_RR	4000,D
set6e:	SET_RR	0040,E
set6h:	SET_RR	4000,H
set6l:	SET_RR	0040,L
set6hl:	SET_HL	40
set6a:	SET_RR	4000,A
set7b:	SET_RR	8000,B
set7c:	SET_RR	0080,C
set7d:	SET_RR	8000,D
set7e:	SET_RR	0080,E
set7h:	SET_RR	8000,H
set7l:	SET_RR	0080,L
set7hl:	SET_HL	80
set7a:	SET_RR	8000,A


;-------------------------------------------------
;
;	prefics DD, FD commands... IX , IY
;
;-------------------------------------------------

GET_IX:	macro
	move.b	(a5)+,d0
	ext.w	d0
	add.w	-4(a6),d0
	move.w	d0,a0
	endm

GET_IY:	macro
	move.b	(a5)+,d0
	ext.w	d0
	add.w	-6(a6),d0
	move.w	d0,a0
	endm

LDHIPIN:macro
	move.b	(a5)+,d0
	ext.w	d0
	add.w	\2,d0
	move.w	d0,a0
	move.w	\1,d0
	move.w	(a0),\1
	move.b	d0,\1
	jmpnext	19-4
	endm

LDLOPIN:macro
	move.b	(a5)+,d0
	ext.w	d0
	add.w	\2,d0
	move.w	d0,a0
	move.b	(a0),\1
	jmpnext	19-4
	endm

LD:	macro
	move.\3	\2,\1
	jmpnext	\4
	endm

LDPINHI:macro
	move.b	(a5)+,d0
	ext.w	d0
	add.w	\1,d0
	move.w	d0,a0
	move.w	\2,d0
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	19-4
	endm

LDPINLO:macro
	move.b	(a5)+,d0
	ext.w	d0
	add.w	\1,d0
	move.w	d0,a0
	move.b	\2,(a0)
;	move.w	\2,d0
;	move.b	d0,(a0)
	jmpnext	19-4
	endm

LDHXLX:	macro
        move.w	\2,d0
	lsr.w	#8,d0
	move.b	d0,\1
	jmpnext	8-4
	endm

;--------------------------------------------
;	IX commands
;--------------------------------------------

addixbc:			; ADD	IX,BC	+-	100%
	addq.l	#2,d7
	lsr.b	#1,d5
	add.w	d4,-4(a6)
	roxl.b	#1,d5
	jmpnext	15-4
addixde:			; ADD	IX,DE	+-	100%
	addq.l	#2,d7
	lsr.b	#1,d5
	add.w	d3,-4(a6)
	roxl.b	#1,d5
	jmpnext	15-4
ldixnn:				; LD	IX,NNNN	+N	100%
	addq.l	#2,d7
	move.w	(a5)+,d0
	rol.w	#8,d0
	move.w	d0,-4(a6)
	jmpnext	14-4
ldpnnix:			; LD  (NNNN),IX	+N	100%
	addq.l	#2,d7
	move.w	(a5)+,d0
	rol.w	#8,d0
	move.w	d0,a0
	move.w	-4(a6),d0
	rol.w	#8,d0
	move.w	d0,(a0)
	jmpnext	20-4
incix:				; INC	IX	+N	100%
	addq.l	#2,d7
	addq.w	#1,-4(a6)
	jmpnext	10-4
inchx:				; INC	HX
	addq.l	#2,d7
	addq.b	#$01,-4(a6)
	move.b	-4(a6),d1
	and.w	#$FF01,d5
	or.b	2(a6,d1.w*8),d5
	jmpnext	8-4
dechx:				; DEC	HX
	addq.l	#2,d7
	subq.b	#$01,-4(a6)
	move.b	-4(a6),d1
	and.w	#$FF01,d5
	or.b	3(a6,d1.w*8),d5
	jmpnext	8-4
ldhxn:				; LD	HX,NN	+N	100%
	addq.l	#2,d7
	move.b	(a5)+,-4(a6)
	jmpnext	11-4
addixix:			; ADD	IX,IX	+-	100%
	addq.l	#2,d7
	move.w	-4(a6),d0
	lsr.b	#1,d5
	add.w	d0,d0
	roxl.b	#1,d5
	move.w	d0,-4(a6)
	jmpnext	15-4
ldixpnn:			; LD  IX,(NNNN) +N	100%
	addq.l	#2,d7
	move.w	(a5)+,d0
	rol.w	#8,d0
	move.w	d0,a0
	move.w	(a0),d0
	rol.w	#8,d0
	move.w	d0,-4(a6)
	jmpnext	20-4
decix:				; DEC	IX	+N	100%
	addq.l	#2,d7
	subq.w	#1,-4(a6)
	jmpnext	10-4
inclx:				; INC	LX
	addq.l	#2,d7
	addq.b	#1,-3(a6)
	move.b	-3(a6),d1
	and.w	#$FF01,d5
	or.b	2(a6,d1.w*8),d5
	jmpnext	8-4
declx:				; DEC	LX
	addq.l	#2,d7
	subq.b	#1,-3(a6)
	move.b	-3(a6),d1
	and.w	#$FF01,d5
	or.b	3(a6,d1.w*8),d5
	jmpnext	8-4
ldlxn:				; LD	LX,NN
	addq.l	#2,d7
	move.b	(a5)+,-3(a6)
	jmpnext	11-4
incpix:				; INC	(IX+NN)	++	100%
	addq.l	#2,d7
	GET_IX
	addq.b	#1,(a0)
	move.b	(a0),d1
	and.w	#$FF01,d5
	or.b	2(a6,d1.w*8),d5
	jmpnext	23-4
decpix:				; DEC	(IX+NN)	++	100%
	addq.l	#2,d7
	GET_IX
	subq.b	#1,(a0)
	move.b	(a0),d1
	and.w	#$FF01,d5
	or.b	3(a6,d1.w*8),d5
	jmpnext	23-4
ldpixn:				; LD (IX+NN),NN +N	100%
	addq.l	#2,d7
	GET_IX
	move.b	(a5)+,d0
	move.b	d0,(a0)
	jmpnext	19-4
addixsp:			; ADD	IX,SP	+-	100%
	addq.l	#2,d7
	move.w	-4(a6),d0
	lsr.w	#1,d5
	add.w	a2,d0
	roxl.w	#1,d5
	move.w	d0,-4(a6)
	jmpnext	15-4
ldbhx:				; LD	B,HX
	addq.l	#2,d7
	move.w	B,d0
	move.w	-4(a6),B
	move.b	d0,B
	jmpnext	8-4
ldblx:				; LD	B,LX
	addq.l	#2,d7
	move.w	B,d0
	move.w	-3(a6),B
	move.b	d0,B
	jmpnext	8-4
ldbpix:				; LD	B,(IX+NN)
	addq.l	#2,d7
	LDHIPIN	B,-4(a6)	
ldchx:				; LD	C,HX
	addq.l	#2,d7
	LD	C,-4(a6),b,8-4
ldclx:				; LD	C,LX
	addq.l	#2,d7
	LD	C,-3(a6),b,8-4
ldcpix:				; LD	C,(IX+NN)
	addq.l	#2,d7
	LDLOPIN	C,-4(a6)
lddhx:				; LD	D,HX
	addq.l	#2,d7
	move.w	D,d0
	move.w	-4(a6),D
	move.b	d0,D
	jmpnext	8-4
lddlx:				; LD	D,LX
	addq.l	#2,d7
	move.w	DE,d0
	move.w	-3(a6),DE
	move.b	d0,DE
	jmpnext	8-4
lddpix:				; LD	D,(IX+NN)
	addq.l	#2,d7
	LDHIPIN	D,-4(a6)
ldehx:				; LD	E,HX
	addq.l	#2,d7
	LD	E,-4(a6),b,8-4
ldelx:				; LD	E,LX
	addq.l	#2,d7
	LD	E,-3(a6),b,8-4
ldepix:				; LD	E,(IX+NN)
	addq.l	#2,d7
	LDLOPIN	E,-4(a6)
ldhxb:				; LD	HX,B
	addq.l	#2,d7
	LDHXLX	-4(a6),B
ldhxc:				; LD	HX,C
	addq.l	#2,d7
	LD	-4(a6),C,b,8-4
ldhxd:				; LD	HX,D
	addq.l	#2,d7
	LDHXLX	-4(a6),D
ldhxe:				; LD	HX,E
	addq.l	#2,d7
	LD	-4(a6),E,b,8-4
ldhxhx:				; LD	HX,HX
	addq.l	#2,d7
	jmpnext	8-4
ldhxlx:				; LD	HX,LX
	addq.l	#2,d7
	LD	-4(a6),-3(a6),b,8-4
ldhpix:				; LD	H,(IX+NN)
	addq.l	#2,d7
	LDHIPIN	H,-4(a6)
ldhxa:				; LD	HX,A
	addq.l	#2,d7
	LDHXLX	-4(a6),A
ldlxb:				; LD	LX,B
	addq.l	#2,d7
	LDHXLX	-3(a6),B
ldlxc:				; LD	LX,C
	addq.l	#2,d7
	LD	-3(a6),C,b,8-4
ldlxd:				; LD	LX,D
	addq.l	#2,d7
	LDHXLX	-3(a6),D
ldlxe:				; LD	LX,E
	addq.l	#2,d7
	LD	-3(a6),E,b,8-4
ldlxhx:				; LD	LX,HX
	addq.l	#2,d7
	LD	-3(a6),-4(a6),b,8-4
ldlxlx:				; LD	LX,LX
	addq.l	#2,d7
	jmpnext	8-4
ldlpix:				; LD	L,(IX+NN)
	addq.l	#2,d7
	LDLOPIN	L,-4(a6)
ldlxa:				; LD	LX,A	+N
	addq.l	#2,d7
	LDHXLX	-3(a6),A
ldpixb:				; LD  (IX+NN),B +N
	addq.l	#2,d7
	LDPINHI	-4(a6),B
ldpixc:				; LD  (IX+NN),C +N
	addq.l	#2,d7
	LDPINLO	-4(a6),C
ldpixd:				; LD  (IX+NN),D +N
	addq.l	#2,d7
	LDPINHI	-4(a6),D
ldpixe:				; LD  (IX+NN),E +N
	addq.l	#2,d7
	LDPINLO	-4(a6),E
ldpixh:				; LD  (IX+NN),H +N
	addq.l	#2,d7
	LDPINHI	-4(a6),H
ldpixl:				; LD  (IX+NN),L +N
	addq.l	#2,d7
	LDPINLO	-4(a6),L
ldpixa:				; LD  (IX+NN),A +N
	addq.l	#2,d7
	LDPINHI	-4(a6),A
ldahx:				; LD	A,HX	+N
	addq.l	#2,d7
	move.w	A,d0
	move.w	-4(a6),A
	move.b	d0,A
	jmpnext	8-4
ldalx:				; LD	A,LX	+N
	addq.l	#2,d7
	move.w	A,d0
	move.w	-3(a6),A
	move.b	d0,A
	jmpnext	8-4
ldapix:				; LD  A,(IX+NN) +N	100%
	addq.l	#2,d7
	LDHIPIN	A,-4(a6)
addahx:				; ADD	A,HX	+N
	addq.l	#2,d7
	move.w	d5,d0
	move.b	-4(a6),d0
	move.w	(a7,d0.l*8),d5
	jmpnext	8-4
addalx:				; ADD	A,LX	+N
	addq.l	#2,d7
	move.w	d5,d0
	move.b	-3(a6),d0
	move.w	(a7,d0.l*8),d5
	jmpnext	8-4
addapix:			; ADD A,(IX+NN)	+N
	addq.l	#2,d7
	GET_IX
	move.w	d5,d0
	move.b	(a0),d0
	move.w	(a7,d0.l*8),d5
	jmpnext	19-4
adcahx:				; ADC	A,HX	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc	addahx+2
	move.w	d5,d0
	move.b	-4(a6),d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	8-4
adcalx:				; ADC	A,LX	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc	addalx+2
	move.w	d5,d0
	move.b	-3(a6),d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	8-4
adcapix:			; ADC A,(IX+NN) +N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	addapix+2
	GET_IX
	move.w	d5,d0
	move.b	(a0),d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	19-4
subhx:				; SUB	HX	+N
	addq.l	#2,d7
	move.w	d5,d0
	move.b	-4(a6),d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	8-4
sublx:				; SUB	LX	+N
	addq.l	#2,d7
	move.w	d5,d0
	move.b	-3(a6),d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	8-4
subpix:				; SUB	(IX+NN)	+N
	addq.l	#2,d7
	GET_IX
	move.w	d5,d0
	move.b	(a0),d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	19-4
sbcahx:				; SBC	A,HX	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc	subhx+2
	move.w	d5,d0
	move.b	-4(a6),d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	8-4
sbcalx:				; SBC	A,LX	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc	sublx+2
	move.w	d5,d0
	move.b	-3(a6),d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	8-4
sbcapix:			; SBC A,(IX+NN) +N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	subpix+2
	GET_IX
	move.w	d5,d0
	move.b	(a0),d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	19-4
andhx:				; AND	HX
	addq.l	#2,d7
	lsr.w	#8,d5
	and.b	-4(a6),d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	8-4
andlx:				; AND	LX
	addq.l	#2,d7
	lsr.w	#8,d5
	and.b	-3(a6),d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	8-4
andpix:				; AND	(IX+NN)
	addq.l	#2,d7
	GET_IX
	lsr.w	#8,d5
	and.b	(a0),d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	19-4
xorhx:				; XOR	HX
	addq.l	#2,d7
	lsr.w	#8,d5
	move.b	-4(a6),d0
	eor.b	d0,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	8-4
xorlx:				; XOR	LX
	addq.l	#2,d7
	lsr.w	#8,d5
	move.b	-3(a6),d0
	eor.b	d0,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	8-4
xorpix:				; XOR	(IX+NN)
	addq.l	#2,d7
	GET_IX
	lsr.w	#8,d5
	move.b	(a0),d0
	eor.b	d0,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	19-4
orhx:				; OR	HX
	addq.l	#2,d7
	lsr.w	#8,d5
	or.b	-4(a6),d5
	move.w	(a6,d5.w*8),d5
	jmpnext	8-4
orlx:				; OR	LX
	addq.l	#2,d7
	lsr.w	#8,d5
	or.b	-3(a6),d5
	move.w	(a6,d5.w*8),d5
	jmpnext	8-4
orpix:				; OR	(IX+NN)
	addq.l	#2,d7
	GET_IX
	lsr.w	#8,d5
	or.b	(a0),d5
	move.w	(a6,d5.w*8),d5
	jmpnext	19-4
cphx:				; CP	HX
	addq.l	#2,d7
	move.b	-4(a6),d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	8-4
cp_lx:				; CP	LX
	addq.l	#2,d7
	move.b	-3(a6),d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	8-4
cppix:				; CP	(IX+NN)
	addq.l	#2,d7
	GET_IX
	move.b	(a0),d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	19-4
popix:				; POP	IX	+N
	addq.l	#2,d7
	move.w	(a2)+,d0
	rol.w	#8,d0
	move.w	d0,-4(a6)
	move.w	a2,a2
	jmpnext 14-4
expspix:			; EX	(SP),IX	+N
	addq.l	#2,d7
	move.w	-4(a6),d0
	rol.w	#8,d0
	move.w	1(a2),d1
	move.b	(a2),d1
	move.w	d0,(a2)
	move.w	d1,-4(a6)
	moveq	#0,d1
	jmpnext	23-4
pushix:
	addq.l	#2,d7
	PUSH	-4(a6)
	jmpnext	15-4
jppix:				; JP	(IX)	+N
	addq.l	#2,d7
	move.w	-4(a6),a5
	jmp	jump_rp
	cnop	0,16
	ds.w	7
ldspix:				; LD	SP,IX	+N
	addq.l	#2,d7
	move.w	-4(a6),a2
	jmpnext	10-4

;-------------------------------------------------
;	IY commands
;-------------------------------------------------

addiybc:			; ADD	IY,BC
	addq.l	#2,d7
	lsr.w	#1,d5
	add.w	d4,-6(a6)
	roxl.w	#1,d5
	jmpnext	15-4
addiyde:			; ADD	IY,DE
	addq.l	#2,d7
	lsr.w	#1,d5
	add.w	d3,-6(a6)
	roxl.w	#1,d5
	jmpnext	15-4
ldiynn:				; LD	IY,NNNN
	addq.l	#2,d7
	move.w	(a5)+,d0
	rol.w	#8,d0
	move.w	d0,-6(a6)
	jmpnext	14-4
ldpnniy:			; LD	(NNNN),IY
	addq.l	#2,d7
	move.w	(a5)+,d0
	rol.w	#8,d0
	move.w	d0,a0
	move.w	-6(a6),d0
	rol.w	#8,d0
	move.w	d0,(a0)
	jmpnext	20-4
inciy:				; INC	IY
	addq.l	#2,d7
	addq.w	#1,-6(a6)
	jmpnext	10-4
inchy:				; INC	HY
	addq.l	#2,d7
	addq.b	#$01,-6(a6)
	move.b	-6(a6),d1
	and.w	#$FF01,d5
	or.b	2(a6,d1.w*8),d5
	jmpnext	8-4
dechy:				; DEC	HY
	addq.l	#2,d7
	subq.b	#$01,-6(a6)
	move.b	-6(a6),d1
	and.w	#$FF01,d5
	or.b	3(a6,d1.w*8),d5
	jmpnext	8-4
ldhyn:				; LD	HY,NN
	addq.l	#2,d7
	move.b	(a5)+,-6(a6)
	jmpnext	11-4
addiyiy:			; ADD	IY,IY
	addq.l	#2,d7
	move.w	-6(a6),d0
	lsr.w	#1,d5
	add.w	d0,d0
	roxl.w	#1,d5
	move.w	d0,-6(a6)
	jmpnext	15-4
ldiypnn:			; LD	IY,(NNNN)
	addq.l	#2,d7
	move.w	(a5)+,d0
	rol.w	#8,d0
	move.w	d0,a0
	move.w	1(a0),d0
	move.b	(a0),d0
	move.w	d0,-6(a6)
	jmpnext	20-4
deciy:				; DEC	IY
	addq.l	#2,d7
	subq.w	#1,-6(a6)
	jmpnext	10-4
incly:				; INC	LY
	addq.l	#2,d7
	addq.b	#1,-5(a6)
	move.b	-5(a6),d1
	and.w	#$FF01,d5
	or.b	2(a6,d1.w*8),d5
	jmpnext	8-4
decly:				; DEC	LY
	addq.l	#2,d7
	subq.b	#1,-5(a6)
	move.b	-5(a6),d1
	and.w	#$FF01,d5
	or.b	3(a6,d1.w*8),d5
	jmpnext	8-4
ldlyn:				; LD	LY,NN
	addq.l	#2,d7
	move.b	(a5)+,-5(a6)
	jmpnext	11-4
incpiy:				; INC	(IY+NN)
	addq.l	#2,d7
	GET_IY
	addq.b	#1,(a0)
	move.b	(a0),d1
	and.w	#$FF01,d5
	or.b	2(a6,d1.w*8),d5
	jmpnext	23-4
decpiy:				; DEC	(IY+NN)
	addq.l	#2,d7
	GET_IY
	subq.b	#1,(a0)
	move.b	(a0),d1
	and.w	#$FF01,d5
	or.b	3(a6,d1.w*8),d5
	jmpnext	23-4
ldpiyn:				; LD	(IY+NN),NN
	addq.l	#2,d7
	GET_IY
	move.b	(a5)+,d0
	move.b	d0,(a0)
	jmpnext	19-4
addiysp:			; ADD	IY,SP
	addq.l	#2,d7
	move.w	-6(a6),d0
	lsr.w	#1,d5
	add.w	a2,d0
	roxl.w	#1,d5
	move.w	d0,-6(a6)
	jmpnext	15-4
ldbhy:				; LD	B,HY
	addq.l	#2,d7
	move.w	B,d0
	move.w	-6(a6),B
	move.b	d0,B
	jmpnext	8-4
ldbly:				; LD	B,LY
	addq.l	#2,d7
	move.w	B,d0
	move.w	-5(a6),B
	move.b	d0,B
	jmpnext	8-4
ldbpiy:				; LD	B,(IY+NN)
	addq.l	#2,d7
	LDHIPIN	B,-6(a6)	
ldchy:				; LD	C,HY
	addq.l	#2,d7
	LD	C,-6(a6),b,8-4
ldcly:				; LD	C,LY
	addq.l	#2,d7
	LD	C,-5(a6),b,8-4
ldcpiy:				; LD	C,(IY+NN)
	addq.l	#2,d7
	LDLOPIN	C,-6(a6)
lddhy:				; LD	D,HY
	addq.l	#2,d7
	move.w	D,d0
	move.w	-6(a6),D
	move.b	d0,D
	jmpnext	8-4
lddly:				; LD	D,LY
	addq.l	#2,d7
	move.w	DE,d0
	move.w	-5(a6),DE
	move.b	d0,DE
	jmpnext	8-4
lddpiy:				; LD	D,(IY+NN)
	addq.l	#2,d7
	LDHIPIN	D,-6(a6)
ldehy:				; LD	E,HY
	addq.l	#2,d7
	LD	E,-6(a6),b,8-4
ldely:				; LD	E,LY
	addq.l	#2,d7
	LD	E,-5(a6),b,8-4
ldepiy:				; LD	E,(IY+NN)
	addq.l	#2,d7
	LDLOPIN	E,-6(a6)
ldhyb:				; LD	HY,B
	addq.l	#2,d7
	LDHXLX	-6(a6),B
ldhyc:				; LD	HY,C
	addq.l	#2,d7
	LD	-6(a6),C,b,8-4
ldhyd:				; LD	HY,D
	addq.l	#2,d7
	LDHXLX	-6(a6),D
ldhye:				; LD	HY,E
	addq.l	#2,d7
	LD	-6(a6),E,b,8-4
ldhyhy:				; LD	HY,HY
	addq.l	#2,d7
	jmpnext	8-4
ldhyly:				; LD	HY,LY
	addq.l	#2,d7
	LD	-6(a6),-5(a6),b,8-4
ldhpiy:				; LD	H,(IY+NN)
	addq.l	#2,d7
	LDHIPIN	H,-6(a6)
ldhya:				; LD	HY,A
	addq.l	#2,d7
	LDHXLX	-6(a6),A
ldlyb:				; LD	LY,B
	addq.l	#2,d7
	LDHXLX	-5(a6),B
ldlyc:				; LD	LY,C
	addq.l	#2,d7
	LD	-5(a6),C,b,8-4
ldlyd:				; LD	LY,D
	addq.l	#2,d7
	LDHXLX	-5(a6),D
ldlye:				; LD	LY,E
	addq.l	#2,d7
	LD	-5(a6),E,b,8-4
ldlyhy:				; LD	LY,HY
	addq.l	#2,d7
	LD	-5(a6),-6(a6),b,8-4
ldlyly:				; LD	LY,LY
	addq.l	#2,d7
	jmpnext	8-4
ldlpiy:				; LD	L,(IY+NN)
	addq.l	#2,d7
	LDLOPIN	L,-6(a6)
ldlya:				; LD	LY,A	+N
	addq.l	#2,d7
	LDHXLX	-5(a6),A
ldpiyb:				; LD  (IY+NN),B +N
	addq.l	#2,d7
	LDPINHI	-6(a6),B
ldpiyc:				; LD  (IY+NN),C +N
	addq.l	#2,d7
	LDPINLO	-6(a6),C
ldpiyd:				; LD  (IY+NN),D +N
	addq.l	#2,d7
	LDPINHI	-6(a6),D
ldpiye:				; LD  (IY+NN),E +N
	addq.l	#2,d7
	LDPINLO	-6(a6),E
ldpiyh:				; LD  (IY+NN),H +N
	addq.l	#2,d7
	LDPINHI	-6(a6),H
ldpiyl:				; LD  (IY+NN),L +N
	addq.l	#2,d7
	LDPINLO	-6(a6),L
ldpiya:				; LD  (IY+NN),A +N
	addq.l	#2,d7
	LDPINHI	-6(a6),A
ldahy:				; LD	A,HY	+N
	addq.l	#2,d7
	move.w	A,d0
	move.w	-6(a6),A
	move.b	d0,A
	jmpnext	8-4
ldaly:				; LD	A,LY	+N
	addq.l	#2,d7
	move.w	A,d0
	move.w	-5(a6),A
	move.b	d0,A
	jmpnext	8-4
ldapiy:				; LD  A,(IY+NN) +N
	addq.l	#2,d7
	LDHIPIN	A,-6(a6)
addahy:				; ADD	A,HY	+N
	addq.l	#2,d7
	move.w	d5,d0
	move.b	-6(a6),d0
	move.w	(a7,d0.l*8),d5
	jmpnext	8-4
addaly:				; ADD	A,LY	+N
	addq.l	#2,d7
	move.w	d5,d0
	move.b	-5(a6),d0
	move.w	(a7,d0.l*8),d5
	jmpnext	8-4
addapiy:			; ADD A,(IY+NN)	+N
	addq.l	#2,d7
	GET_IY
	move.w	d5,d0
	move.b	(a0),d0
	move.w	(a7,d0.l*8),d5
	jmpnext	19-4
adcahy:				; ADC	A,HY	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc	addahy+2
	move.w	d5,d0
	move.b	-6(a6),d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	8-4
adcaly:				; ADC	A,LY	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc	addaly+2
	move.w	d5,d0
	move.b	-5(a6),d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	8-4
adcapiy:			; ADC A,(IY+NN) +N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	addapiy+2
	GET_IY
	move.w	d5,d0
	move.b	(a0),d0
	move.w	2(a7,d0.l*8),d5
	jmpnext	19-4
subhy:				; SUB	HY	+N
	addq.l	#2,d7
	move.w	d5,d0
	move.b	-6(a6),d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	8-4
subly:				; SUB	LY	+N
	addq.l	#2,d7
	move.w	d5,d0
	move.b	-5(a6),d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	8-4
subpiy:				; SUB	(IY+NN)	+N
	addq.l	#2,d7
	GET_IY
	move.w	d5,d0
	move.b	(a0),d0
	move.w	4(a7,d0.l*8),d5
	jmpnext	19-4
sbcahy:				; SBC	A,HY	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc	subhy+2
	move.w	d5,d0
	move.b	-6(a6),d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	8-4
sbcaly:				; SBC	A,LY	+N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc	subly+2
	move.w	d5,d0
	move.b	-5(a6),d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	8-4
sbcapiy:			; SBC A,(IY+NN) +N
	addq.l	#2,d7
	move.b	d5,ccr
	bcc.w	subpiy+2
	GET_IY
	move.w	d5,d0
	move.b	(a0),d0
	move.w	6(a7,d0.l*8),d5
	jmpnext	19-4
andhy:				; AND	HY
	addq.l	#2,d7
	lsr.w	#8,d5
	and.b	-6(a6),d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	8-4
andly:				; AND	LY
	addq.l	#2,d7
	lsr.w	#8,d5
	and.b	-5(a6),d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	8-4
andpiy:				; AND	(IY+NN)
	addq.l	#2,d7
	GET_IY
	lsr.w	#8,d5
	and.b	(a0),d5
	move.w	(a6,d5.w*8),d5
	or.b	#$10,d5
	jmpnext	19-4
xorhy:				; XOR	HY
	addq.l	#2,d7
	lsr.w	#8,d5
	move.b	-6(a6),d0
	eor.b	d0,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	8-4
xorly:				; XOR	LY
	addq.l	#2,d7
	lsr.w	#8,d5
	move.b	-5(a6),d0
	eor.b	d0,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	8-4
xorpiy:				; XOR	(IY+NN)
	addq.l	#2,d7
	GET_IY
	lsr.w	#8,d5
	move.b	(a0),d0
	eor.b	d0,d5
	move.w	(a6,d5.w*8),d5
	jmpnext	19-4
orhy:				; OR	HY
	addq.l	#2,d7
	lsr.w	#8,d5
	or.b	-6(a6),d5
	move.w	(a6,d5.w*8),d5
	jmpnext	8-4
orly:				; OR	LY
	addq.l	#2,d7
	lsr.w	#8,d5
	or.b	-5(a6),d5
	move.w	(a6,d5.w*8),d5
	jmpnext	8-4
orpiy:				; OR	(IY+NN)	++	100%
	addq.l	#2,d7
	GET_IY
	lsr.w	#8,d5
	or.b	(a0),d5
	move.w	(a6,d5.w*8),d5
	jmpnext	19-4
cphy:				; CP	HY
	addq.l	#2,d7
	move.b	-6(a6),d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	8-4
cp_ly:				; CP	LY
	addq.l	#2,d7
	move.b	-5(a6),d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	8-4
cppiy:				; CP	(IY+NN)
	addq.l	#2,d7
	GET_IY
	move.b	(a0),d5
	move.b	(cptab+32768,a6,d5.w),d5
	jmpnext	19-4
popiy:				; POP	IY	+N	100%
	addq.l	#2,d7
	move.w	(a2)+,d0
	rol.w	#8,d0
	move.w	d0,-6(a6)
	move.w	a2,a2
	jmpnext 14-4
expspiy:			; EX	(SP),IY	+N
	addq.l	#2,d7
	move.w	-6(a6),d0
	rol.w	#8,d0
	move.w	1(a2),d1
	move.b	(a2),d1
	move.w	d0,(a2)
	move.w	d1,-6(a6)
	moveq.l	#0,d1
	jmpnext	23-4
pushiy:				; PUSH	IY	+N	100%
	addq.l	#2,d7
	PUSH	-6(a6)
	jmpnext	15-4
jppiy:				; JP	(IY)	+N	100%
	addq.l	#2,d7
	move.w	-6(a6),a5
	jmp	jump_rp
	cnop	0,16
	ds.w	7
ldspiy:				; LD	SP,IY	+N	100%
	addq.l	#2,d7
	move.w	-6(a6),a2
	jmpnext	10-4

fdcb:				; $FD $CB XX XX
	nop
	move.b	(a5)+,d0
	ext.w	d0
	add.w	-6(a6),d0
	move.w	d0,a0		; a0 = iy + nn
	move.b	(a5)+,d1
	jmp	([fdcbtab,pc,d1*4])
	cnop	0,16
	ds.w	7

ddcb:				; $DD $CB XX XX
	nop
	move.b	(a5)+,d0
	ext.w	d0
	add.w	-4(a6),d0
	move.w	d0,a0		; a0 = ix + nn
	move.b	(a5)+,d1
	jmp	([fdcbtab,pc,d1*4])

	cnop	0,16
fdcbtab:
	dc.l rlcpiyb,rlcpiyc,rlcpiyd,rlcpiye,rlcpiyh,rlcpiyl,rlcpiy,rlcpiya
	dc.l rrcpiyb,rrcpiyc,rrcpiyd,rrcpiye,rrcpiyh,rrcpiyl,rrcpiy,rrcpiya
	dc.l rlpiyb,rlpiyc,rlpiyd,rlpiye,rlpiyh,rlpiyl,rlpiy,rlpiya
	dc.l rrpiyb,rrpiyc,rrpiyd,rrpiye,rrpiyh,rrpiyl,rrpiy,rrpiya
	dc.l slapiyb,slapiyc,slapiyd,slapiye,slapiyh,slapiyl,slapiy,slapiya
	dc.l srapiyb,srapiyc,srapiyd,srapiye,srapiyh,srapiyl,srapiy,srapiya
	dc.l slipiyb,slipiyc,slipiyd,slipiye,slipiyh,slipiyl,slipiy,slipiya
	dc.l srlpiyb,srlpiyc,srlpiyd,srlpiye,srlpiyh,srlpiyl,srlpiy,srlpiya
	dc.l bit0piy,bit0piy,bit0piy,bit0piy,bit0piy,bit0piy,bit0piy,bit0piy
	dc.l bit1piy,bit1piy,bit1piy,bit1piy,bit1piy,bit1piy,bit1piy,bit1piy
	dc.l bit2piy,bit2piy,bit2piy,bit2piy,bit2piy,bit2piy,bit2piy,bit2piy
	dc.l bit3piy,bit3piy,bit3piy,bit3piy,bit3piy,bit3piy,bit3piy,bit3piy
	dc.l bit4piy,bit4piy,bit4piy,bit4piy,bit4piy,bit4piy,bit4piy,bit4piy
	dc.l bit5piy,bit5piy,bit5piy,bit5piy,bit5piy,bit5piy,bit5piy,bit5piy
	dc.l bit6piy,bit6piy,bit6piy,bit6piy,bit6piy,bit6piy,bit6piy,bit6piy
	dc.l bit7piy,bit7piy,bit7piy,bit7piy,bit7piy,bit7piy,bit7piy,bit7piy
	dc.l res0iyb,res0iyc,res0iyd,res0iye,res0iyh,res0iyl,res0piy,res0iya
	dc.l res1iyb,res1iyc,res1iyd,res1iye,res1iyh,res1iyl,res1piy,res1iya
	dc.l res2iyb,res2iyc,res2iyd,res2iye,res2iyh,res2iyl,res2piy,res2iya
	dc.l res3iyb,res3iyc,res3iyd,res3iye,res3iyh,res3iyl,res3piy,res3iya
	dc.l res4iyb,res4iyc,res4iyd,res4iye,res4iyh,res4iyl,res4piy,res4iya
	dc.l res5iyb,res5iyc,res5iyd,res5iye,res5iyh,res5iyl,res5piy,res5iya
	dc.l res6iyb,res6iyc,res6iyd,res6iye,res6iyh,res6iyl,res6piy,res6iya
	dc.l res7iyb,res7iyc,res7iyd,res7iye,res7iyh,res7iyl,res7piy,res7iya
	dc.l set0iyb,set0iyc,set0iyd,set0iye,set0iyh,set0iyl,set0piy,set0iya
	dc.l set1iyb,set1iyc,set1iyd,set1iye,set1iyh,set1iyl,set1piy,set1iya
	dc.l set2iyb,set2iyc,set2iyd,set2iye,set2iyh,set2iyl,set2piy,set2iya
	dc.l set3iyb,set3iyc,set3iyd,set3iye,set3iyh,set3iyl,set3piy,set3iya
	dc.l set4iyb,set4iyc,set4iyd,set4iye,set4iyh,set4iyl,set4piy,set4iya
	dc.l set5iyb,set5iyc,set5iyd,set5iye,set5iyh,set5iyl,set5piy,set5iya
	dc.l set6iyb,set6iyc,set6iyd,set6iye,set6iyh,set6iyl,set6piy,set6iya
	dc.l set7iyb,set7iyc,set7iyd,set7iye,set7iyh,set7iyl,set7piy,set7iya
;
	cnop	0,16


ROL4_HI:macro
	addq.l	#2,d7
	move.b	(a0),d1
	move.w	(\1,a6,d1.w*2),d0
	move.b	d0,d5
	move.b	\2,d0
	move.w	d0,\2
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	23-4
	dc.w	0
	endm

ROL4_LO:macro
	addq.l	#2,d7
	move.b	(a0),d1
	move.w	(\1,a6,d1.w*2),d0
	move.b	d0,d5
	lsr.w	#8,d0
	move.b	d0,\2
	move.b	d0,(a0)
	jmpnext	23-4
	dc.w	0
	endm

ROL4_HL:macro
	addq.l	#2,d7
	move.b	(a0),d1
	move.w	(\1,a6,d1.w*2),d0
	move.b	d0,d5
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	23-4
	dc.w	0
	endm

ROL4_A:	macro
	addq.l	#2,d7
	move.b	(a0),d1
	move.w	(\1,a6,d1.w*2),d0
	move.w	d0,d5
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	23-4
	dc.w	0
	endm

rlcpiyb:ROL4_HI	rlctab,B
rlcpiyc:ROL4_LO	rlctab,C
rlcpiyd:ROL4_HI	rlctab,D
rlcpiye:ROL4_LO	rlctab,E
rlcpiyh:ROL4_HI	rlctab,H
rlcpiyl:ROL4_LO	rlctab,L
rlcpiy:	ROL4_HL	rlctab
rlcpiya:ROL4_A	rlctab
rrcpiyb:ROL4_HI	rrctab,B
rrcpiyc:ROL4_LO	rrctab,C
rrcpiyd:ROL4_HI	rrctab,D
rrcpiye:ROL4_LO	rrctab,E
rrcpiyh:ROL4_HI	rrctab,H
rrcpiyl:ROL4_LO	rrctab,L
rrcpiy:	ROL4_HL	rrctab
rrcpiya:ROL4_A	rrctab
slapiyb:ROL4_HI	slatab,B
slapiyc:ROL4_LO	slatab,C
slapiyd:ROL4_HI	slatab,D
slapiye:ROL4_LO	slatab,E
slapiyh:ROL4_HI	slatab,H
slapiyl:ROL4_LO	slatab,L
slapiy:	ROL4_HL	slatab
slapiya:ROL4_A	slatab
srapiyb:ROL4_HI	sratab,B
srapiyc:ROL4_LO	sratab,C
srapiyd:ROL4_HI	sratab,D
srapiye:ROL4_LO	sratab,E
srapiyh:ROL4_HI	sratab,H
srapiyl:ROL4_LO	sratab,L
srapiy:	ROL4_HL	sratab
srapiya:ROL4_A	sratab
slipiyb:ROL4_HI	slitab,B
slipiyc:ROL4_LO	slitab,C
slipiyd:ROL4_HI	slitab,D
slipiye:ROL4_LO	slitab,E
slipiyh:ROL4_HI	slitab,H
slipiyl:ROL4_LO	slitab,L
slipiy:	ROL4_HL	slitab
slipiya:ROL4_A	slitab
srlpiyb:ROL4_HI	srltab,B
srlpiyc:ROL4_LO	srltab,C
srlpiyd:ROL4_HI	srltab,D
srlpiye:ROL4_LO	srltab,E
srlpiyh:ROL4_HI	srltab,H
srlpiyl:ROL4_LO	srltab,L
srlpiy:	ROL4_HL	srltab
srlpiya:ROL4_A	srltab


RL3_HI:	macro
	addq.l	#2,d7
	move.b	d5,d0
	lsl.w	#8,d0
	move.b	(a0),d0
	and.w	#$01FF,d0
	move.w	(\1,a6,d0.w*2),d0
	move.b	d0,d5
	move.b	\2,d0
	move.w	d0,\2
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	23-4
	dc.w	0
	endm

RL3_LO:	macro
	addq.l	#2,d7
	move.b	d5,d0
	lsl.w	#8,d0
	move.b	(a0),d0
	and.w	#$01FF,d0
	move.w	(\1,a6,d0.w*2),d0
	move.b	d0,d5
	lsr.w	#8,d0
	move.b	d0,\2
	move.b	d0,(a0)
	jmpnext	23-4
	dc.w	0
	endm

RL3_HL:	macro
	addq.l	#2,d7
	move.b	d5,d0
	lsl.w	#8,d0
	move.b	(a0),d0
	and.w	#$01FF,d0
	move.w	(\1,a6,d0.w*2),d0
	move.b	d0,d5
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	23-4
	dc.w	0
	endm

RL3_A:	macro
	addq.l	#2,d7
	move.b	d5,d0
	lsl.w	#8,d0
	move.b	(a0),d0
	and.w	#$01FF,d0
	move.w	(\1,a6,d0.w*2),d0
	move.w	d0,d5
	lsr.w	#8,d0
	move.b	d0,(a0)
	jmpnext	23-4
	dc.w	0
	endm

rlpiyb:	RL3_HI	rltab,B
rlpiyc:	RL3_LO	rltab,C
rlpiyd:	RL3_HI	rltab,D
rlpiye:	RL3_LO	rltab,E
rlpiyh:	RL3_HI	rltab,H
rlpiyl:	RL3_LO	rltab,L
rlpiy:	RL3_HL	rltab
rlpiya:	RL3_A	rltab
rrpiyb:	RL3_HI	rrtab,B
rrpiyc:	RL3_LO	rrtab,C
rrpiyd:	RL3_HI	rrtab,D
rrpiye:	RL3_LO	rrtab,E
rrpiyh:	RL3_HI	rrtab,H
rrpiyl:	RL3_LO	rrtab,L
rrpiy:	RL3_HL	rrtab
rrpiya:	RL3_A	rrtab


BIT3:	macro
	addq.l	#2,d7
	move.b	(a0),d1
	and.b	#$01,d5
	or.b	(bittab+256*\1,a6,d1.w),d5
	jmpnext	20-4
	dc.w	0
	endm
	
bit0piy:BIT3	0
bit1piy:BIT3	1
bit2piy:BIT3	2
bit3piy:BIT3	3
bit4piy:BIT3	4
bit5piy:BIT3	5
bit6piy:BIT3	6
bit7piy:BIT3	7


RESPYHI:macro
	addq.l	#2,d7
	and.b	#$\1,(a0)
	move.b	\2,d0
	move.w	(a0),\2
	move.b	d0,\2
	jmpnext	23-4
	dc.w	0
	endm

RESPYLO:macro
	addq.l	#2,d7
	and.b	#$\1,(a0)
	move.b	(a0),\2
	jmpnext	23-4
	dc.w	0
	endm

RESPIY:	macro
	addq.l	#2,d7
	and.b	#$\1,(a0)
	jmpnext	23-4
	dc.w	0
	endm

res0iyb:RESPYHI	FE,B	; FE
res0iyc:RESPYLO	FE,C
res0iyd:RESPYHI	FE,D
res0iye:RESPYLO	FE,E
res0iyh:RESPYHI	FE,H
res0iyl:RESPYLO	FE,L
res0piy:RESPIY	FE
res0iya:RESPYHI	FE,A
res1iyb:RESPYHI	FD,B	; FD
res1iyc:RESPYLO	FD,C
res1iyd:RESPYHI	FD,D
res1iye:RESPYLO	FD,E
res1iyh:RESPYHI	FD,H
res1iyl:RESPYLO	FD,L
res1piy:RESPIY	FD
res1iya:RESPYHI	FD,A
res2iyb:RESPYHI	FB,B	; FB
res2iyc:RESPYLO	FB,C
res2iyd:RESPYHI	FB,D
res2iye:RESPYLO	FB,E
res2iyh:RESPYHI	FB,H
res2iyl:RESPYLO	FB,L
res2piy:RESPIY	FB
res2iya:RESPYHI	FB,A
res3iyb:RESPYHI	F7,B	; F7
res3iyc:RESPYLO	F7,C
res3iyd:RESPYHI	F7,D
res3iye:RESPYLO	F7,E
res3iyh:RESPYHI	F7,H
res3iyl:RESPYLO	F7,L
res3piy:RESPIY	F7
res3iya:RESPYHI	F7,A
res4iyb:RESPYHI	EF,B	; EF
res4iyc:RESPYLO	EF,C
res4iyd:RESPYHI	EF,D
res4iye:RESPYLO	EF,E
res4iyh:RESPYHI	EF,H
res4iyl:RESPYLO	EF,L
res4piy:RESPIY	EF
res4iya:RESPYHI	EF,A
res5iyb:RESPYHI	DF,B	; DF
res5iyc:RESPYLO	DF,C
res5iyd:RESPYHI	DF,D
res5iye:RESPYLO	DF,E
res5iyh:RESPYHI	DF,H
res5iyl:RESPYLO	DF,L
res5piy:RESPIY	DF
res5iya:RESPYHI	DF,A
res6iyb:RESPYHI	BF,B	; BF
res6iyc:RESPYLO	BF,C
res6iyd:RESPYHI	BF,D
res6iye:RESPYLO	BF,E
res6iyh:RESPYHI	BF,H
res6iyl:RESPYLO	BF,L
res6piy:RESPIY	BF
res6iya:RESPYHI	BF,A
res7iyb:RESPYHI	7F,B	; 7F
res7iyc:RESPYLO	7F,C
res7iyd:RESPYHI	7F,D
res7iye:RESPYLO	7F,E
res7iyh:RESPYHI	7F,H
res7iyl:RESPYLO	7F,L
res7piy:RESPIY	7F
res7iya:RESPYHI	7F,A


SETPYHI:macro
	addq.l	#2,d7
	or.b	#$\1,(a0)
	move.b	\2,d0
	move.w	(a0),\2
	move.b	d0,\2
	jmpnext	23-4
	dc.w	0
	endm

SETPYLO:macro
	addq.l	#2,d7
	or.b	#$\1,(a0)
	move.b	(a0),\2
	jmpnext	23-4
	dc.w	0
	endm


SETPIY:	macro
	addq.l	#2,d7
	or.b	#$\1,(a0)
	jmpnext	23-4
	dc.w	0
	endm

set0iyb:SETPYHI	01,B	; 01
set0iyc:SETPYLO	01,C
set0iyd:SETPYHI	01,D
set0iye:SETPYLO	01,E
set0iyh:SETPYHI	01,H
set0iyl:SETPYLO	01,L
set0piy:SETPIY	01
set0iya:SETPYHI	01,A
set1iyb:SETPYHI	02,B	; 02
set1iyc:SETPYLO	02,C
set1iyd:SETPYHI	02,D
set1iye:SETPYLO	02,E
set1iyh:SETPYHI	02,H
set1iyl:SETPYLO	02,L
set1piy:SETPIY	02
set1iya:SETPYHI	02,A
set2iyb:SETPYHI	04,B	; 04
set2iyc:SETPYLO	04,C
set2iyd:SETPYHI	04,D
set2iye:SETPYLO	04,E
set2iyh:SETPYHI	04,H
set2iyl:SETPYLO	04,L
set2piy:SETPIY	04
set2iya:SETPYHI	04,A
set3iyb:SETPYHI	08,B	; 08
set3iyc:SETPYLO	08,C
set3iyd:SETPYHI	08,D
set3iye:SETPYLO	08,E
set3iyh:SETPYHI	08,H
set3iyl:SETPYLO	08,L
set3piy:SETPIY	08
set3iya:SETPYHI	08,A
set4iyb:SETPYHI	10,B	; 10
set4iyc:SETPYLO	10,C
set4iyd:SETPYHI	10,D
set4iye:SETPYLO	10,E
set4iyh:SETPYHI	10,H
set4iyl:SETPYLO	10,L
set4piy:SETPIY	10
set4iya:SETPYHI	10,A
set5iyb:SETPYHI	20,B	; 20
set5iyc:SETPYLO	20,C
set5iyd:SETPYHI	20,D
set5iye:SETPYLO	20,E
set5iyh:SETPYHI	20,H
set5iyl:SETPYLO	20,L
set5piy:SETPIY	20
set5iya:SETPYHI	20,A
set6iyb:SETPYHI	40,B	; 40
set6iyc:SETPYLO	40,C
set6iyd:SETPYHI	40,D
set6iye:SETPYLO	40,E
set6iyh:SETPYHI	40,H
set6iyl:SETPYLO	40,L
set6piy:SETPIY	40
set6iya:SETPYHI	40,A
set7iyb:SETPYHI	80,B	; 80
set7iyc:SETPYLO	80,C
set7iyd:SETPYHI	80,D
set7iye:SETPYLO	80,E
set7iyh:SETPYHI	80,H
set7iyl:SETPYLO	80,L
set7piy:SETPIY	80
set7iya:SETPYHI	80,A


;
;-------------------------------------------------
;
;	prefics ED commands...
;
;-------------------------------------------------

INPC_LO:macro
	move.w	d4,d0
	jmp	([intab+131072,d4.w*4])
	cnop	0,16
inpcret_\1:
	move.b	d0,\1
	jmpnext	12
	endm

INPC_HI:macro
	move.w	d4,d0
	jmp	([intab+131072,d4.w*4])
	cnop	0,16
inpcret_\1:
	move.b	\1,d1
	move.b	d0,\1
	lsl.w	#8,\1
	move.b	d1,\1
	jmpnext	12
	endm

SBC:	macro
	move.b	L,d0
	lsl.w	#8,d0
	move.b	\2,d0
	move.b	d5,ccr
	bcc.s	.1
	move.w	6(a7,d0.l*8),d0
	bra.s	.2
.1
	move.w	4(a7,d0.l*8),d0
.2
	move.b	d0,d5
	lsr.w	#8,d0
	move.b	d0,L	; L ready
	move.w	\2,d1
	lsr.w	#8,d1
	move.w	HL,d0
	move.b	d1,d0
	move.b	d5,ccr
	bcc.s	.3
	move.w	6(a7,d0.l*8),d0
	bra.s	.4
.3
	move.w	4(a7,d0.l*8),d0
.4
	move.b	d0,d5
	move.b	L,d0
	move.w	d0,HL	; HL ready
	and.b	#$bf,d5	; Z=0
	tst.w	d2
	bne.s	.5	
	or.b	#$40,d5	; if HL=0, then Z=1
.5
	jmpnext	15
	endm

ADC:	macro
	move.b	L,d0
	lsl.w	#8,d0
	move.b	\2,d0
	move.b	d5,ccr
	bcc.s	.1
	move.w	2(a7,d0.l*8),d0
	bra.s	.2
.1
	move.w	(a7,d0.l*8),d0
.2
	move.b	d0,d5
	lsr.w	#8,d0
	move.b	d0,L	; L ready
	move.w	\2,d1
	lsr.w	#8,d1
	move.w	HL,d0
	move.b	d1,d0
	move.b	d5,ccr
	bcc.s	.3
	move.w	2(a7,d0.l*8),d0
	bra.s	.4
.3
	move.w	(a7,d0.l*8),d0
.4
	move.b	d0,d5
	move.b	L,d0
	move.w	d0,HL	; HL ready
	and.b	#$bf,d5	; Z=0
	tst.w	d2
	bne.s	.5	
	or.b	#$40,d5	; if HL=0, then Z=1
.5
	jmpnext	15
	endm
;
	cnop	0,16
	ds.w	7
ednop:				; NOP*		+N
	addq.l	#4,d7
	jmpnext	8
inbpc:				; IN	B,(C)	--
	addq.l	#4,d7
	INPC_HI	B
outpcb:				; OUT	(C),B	--
	addq.l	#4,d7
	move.w	BC,d0
	moveq	#12,d1
	jmp	([outtab+131072,BC.w*4])
	cnop	0,16
	ds.w	7
sbchlbc:			; SBC	HL,BC	++
	addq.l	#4,d7
	SBC	HL,BC
ldpnnbc:			; LD  (NNNN),BC +N
	addq.l	#4,d7
	POKE	BC
	jmpnext	20
neg:				; NEG		++
	addq.l	#4,d7
	lsr.w	#8,d5
	move.w	(negtab,a6,d5.w*2),d5
	jmpnext	8
retn:				; RETN		+N
	addq.l	#4,d7
	move.w	-$a(a6),-8(a6)
	RET_PR
	jmpnext	14
im0:				; IM	0	+N
	addq.l	#4,d7
	IM	0
ldia:				; LD	I,A	+N
	addq.l	#4,d7
	move.w	d5,d0
	move.b	#$FF,d0
	move.w	d0,-$e(a6)	
	jmpnext	9
incpc:				; IN	C,(C)	--
	addq.l	#4,d7
	INPC_LO	C
outpcc:				; OUT	(C),C	--
	addq.l	#4,d7
	move.w	BC,d0
	lsl.w	#8,d0
	moveq	#12,d1
	jmp	([outtab+131072,BC.w*4])
	cnop	0,16
	ds.w	7
adchlbc:			; ADC	HL,BC	++
	addq.l	#4,d7
	ADC	HL,BC
ldbcpnn:			; LD  BC,(NNNN) +N
	addq.l	#4,d7
	PEEK	BC
	jmpnext	20
reti:				; RETI		+N
	addq.l	#4,d7
	move.w	-$a(a6),-8(a6)
	RET_PR
	jmpnext	14
ldra:				; LD	R,A	+N
	nop
	tst.w	-8(a6)			; DI or not DI ?
	bne.s	.1
	move.l	cmd_base,a4
	move.l	#cbtab+1024,cb_jumper
	move.l	#ddtab+1024,dd_jumper
	move.l	#edtab+1024,ed_jumper
	move.l	#fdtab+1024,fd_jumper
	move.l	#cbtab+1024,cb_jumper-addab-$8000(a4)
	move.l	#ddtab+1024,dd_jumper-addab-$8000(a4)
	move.l	#edtab+1024,ed_jumper-addab-$8000(a4)
	move.l	#fdtab+1024,fd_jumper-addab-$8000(a4)
	tst.l	CPU?
	bne.s	.10
	opt	p=68030
	movec	cacr,d0
	or.w	#$008,d0
	movec	d0,cacr
	opt	p=68040
	bra.s	.11
.10:
	cinva	ic
.11:
	move.l	a4,cmd_base1
.1:
	move.w	d5,d7
	lsr.w	#8,d7
	rol.b	d7
	sub.l	#9,d6
	move.b	(a5)+,d0		; Go! Get 1st byte...
	lsl.w	#8,d0
	jmp	(a4,d0.w)
	cnop	0,16
	ds.w	7
indpc:				; IN	D,(C)	--
	addq.l	#4,d7
	INPC_HI	D
outpcd:				; OUT	(C),D	--
	addq.l	#4,d7
	move.w	DE,d0
	moveq	#12,d1
	jmp	([outtab+131072,BC.w*4])
	cnop	0,16
	ds.w	7
sbchlde:			; SBC	HL,DE	++
	addq.l	#4,d7
	SBC	HL,DE
ldpnnde:			; LD  (NNNN),DE +N
	addq.l	#4,d7
	POKE	DE
	jmpnext	20
im1:				; IM	1	+N
	addq.l	#4,d7
	IM	1
ldai:				; LD	A,I	++
	addq.l	#4,d7
	move.b	-$e(a6),d1
	and.w	#$0001,d5
	or.w	(ldaitab,a6,d1.w*2),d5
	or.w	-$A(a6),d5
	jmpnext	9
inepc:				; IN	E,(C)	--
	addq.l	#4,d7
	INPC_LO	E
outpce:				; OUT	(C),E	--
	addq.l	#4,d7
	move.w	DE,d0
	lsl.w	#8,d0
	moveq	#12,d1
	jmp	([outtab+131072,BC.w*4])
	cnop	0,16
	ds.w	7
adchlde:			; ADC	HL,DE	++
	addq.l	#4,d7
	ADC	HL,DE
lddepnn:			; LD  DE,(NNNN) +N
	addq.l	#4,d7
	PEEK	DE
	jmpnext	20
im2:				; IM	2	+N
	addq.l	#4,d7
	IM	2
ldar:				; LD	A,R	++
	nop
	cmp.l	cmd_base,a4
	beq.s	.1
	move.b	$dff006,d1
	and.b	#$fe,d1
	eor.b	d7,d1
	bra.s	.2
.1:
	move.b	d7,d1
.2:
	and.w	#$0001,d5
	or.w	(ldartab,a6,d1.w*2),d5
	or.w	-$A(a6),d5
	addq.l	#4,d7
	jmpnext	9
inhpc:				; IN	H,(C)	--
	addq.l	#4,d7
	INPC_HI	H
outpch:				; OUT	(C),H	--
	addq.l	#4,d7
	move.w	HL,d0
	moveq	#12,d1
	jmp	([outtab+131072,BC.w*4])
	cnop	0,16
	ds.w	7
sbchlhl:			; SBC	HL,HL	++
	addq.l	#4,d7
	SBC	HL,HL
ldpnhl2:			; LD  (NNNN),HL	+N
	addq.l	#4,d7
	POKE	HL
	jmpnext	20
rrd:				; RRD		++
	addq.l	#4,d7
	move.b	d5,d1
	move.w	HL,a0
	move.w	d5,d0
	move.b	(a0),d0
	move.l	(rrdtab,a6,d0.l*4),d0
	move.w	d0,d5
	swap	d0
	move.b	d0,(a0)
	and.b	#1,d1
	or.b	d1,d5
	moveq.l	#0,d0
	jmpnext	18
inlpc:				; IN	L,(C)	--
	addq.l	#4,d7
	INPC_LO	L
outpcl:				; OUT	(C),L	--
	addq.l	#4,d7
	move.w	HL,d0
	lsl.w	#8,d0
	moveq	#12,d1
	jmp	([outtab+131072,BC.w*4])
	cnop	0,16
	ds.w	7
adchlhl:			; ADC	HL,HL	++
	addq.l	#4,d7
	ADC	HL,HL
ldhlpn2:			; LD  HL,(NNNN) +N
	addq.l	#4,d7
	PEEK	HL
	jmpnext	20
rld:				; RLD		++
	addq.l	#4,d7
	move.b	d5,d1
	move.w	HL,a0
	move.w	d5,d0
	move.b	(a0),d0
	move.l	(rldtab,a6,d0.l*4),d0
	move.w	d0,d5
	swap	d0
	move.b	d0,(a0)
	and.b	#1,d1
	or.b	d1,d5
	moveq.l	#0,d0
	jmpnext	18
inhlc:				; INF		--
	addq.l	#4,d7
	jmpnext	12
outpc0:				; OUT	(C),0	--
	addq.l	#4,d7
	clr.w	d0
	moveq	#12,d1
	jmp	([outtab+131072,BC.w*4])
	cnop	0,16
	ds.w	7
sbchlsp:			; SBC	HL,SP	++
	addq.l	#4,d7
	move.w	a2,-2(a6)
	move.b	L,d0
	lsl.w	#8,d0
	move.b	-1(a6),d0
	move.b	d5,ccr
	bcc.s	.1
	move.w	6(a7,d0.l*8),d0
	bra.s	.2
.1
	move.w	4(a7,d0.l*8),d0
.2
	move.b	d0,d5
	lsr.w	#8,d0
	move.b	d0,L	; L ready
	move.w	HL,d0
	move.b	-2(a6),d0
	move.b	d5,ccr
	bcc.s	.3
	move.w	6(a7,d0.l*8),d0
	bra.s	.4
.3
	move.w	4(a7,d0.l*8),d0
.4
	move.b	d0,d5
	move.b	L,d0
	move.w	d0,HL	; HL ready
	and.b	#$bf,d5	; Z=0
	tst.w	d2
	bne.s	.5	
	or.b	#$40,d5	; if HL=0, then Z=1
.5
	jmpnext	15
ldpnnsp:			; LD  (NNNN),SP +N
	addq.l	#4,d7
	POKE	a2
	jmpnext	20
inapc:				; IN	A,(C)	--
	addq.l	#4,d7
	INPC_HI	A
outpca:				; OUT	(C),A	--
	addq.l	#4,d7
	move.w	d5,d0
	moveq	#12,d1
	jmp	([outtab+131072,BC.w*4])
	cnop	0,16
;
noout:
	jmpnextd1
	cnop	0,16
;
	opt	p=68030
Out7FFD:
mmu_base_up	equ	*+$14
mmu_base_down	equ	*+$1A
	lsr.w	#8,d0
	move.l	tree_base,a3
	lea	(PageTab,d0.w*8),a0
trdos_flg	equ	*+2
	move.l	2048(a0),p0000-Tree(a3)
	move.w	d0,Copy7FFD
	move.l	(a0)+,pC000-Tree(a3)
	move.l	(a0),a3
	pflush	#0,#0,$ffffc000
	pflush	#0,#0,$00000000
	movec	cacr,d0
	or.w	#$800,d0
	movec	d0,cacr
	jmpnextd1
	opt	p=68040
	cnop	0,16
;
;-------------------------------------
;	Memory Mapper...
;-------------------------------------
PageTab:
page_0:	dc.l	0,0	; 0
page_1:	dc.l	0,0	; 1
page_2:	dc.l	0,0	; 2
page_3:	dc.l	0,0	; 3
page_4:	dc.l	0,0	; 4
page_5:	dc.l	0,0	; 5 
page_6:	dc.l	0,0	; 6
page_7:	dc.l	0,0	; 7
	dc.l	0,0	; 0
	dc.l	0,0	; 1
	dc.l	0,0	; 2
	dc.l	0,0	; 3
	dc.l	0,0	; 4
	dc.l	0,0	; 5 
	dc.l	0,0	; 6
	dc.l	0,0	; 7
;
	ds.l	512-32
;
	ds.l	512
;
Rom_48:	dc.l	0	;  48k Rom
Rom128:	dc.l	0	; 128k Rom
TR_DOS:	dc.l	0	; TR-DOS Rom
;
	cnop	0,16
	ds.w	7
;
adchlsp:			; ADC	HL,SP	++
	addq.l	#4,d7
	move.w	a2,-2(a6)
	move.b	L,d0
	lsl.w	#8,d0
	move.b	-1(a6),d0
	move.b	d5,ccr
	bcc.s	.1
	move.w	2(a7,d0.l*8),d0
	bra.s	.2
.1
	move.w	(a7,d0.l*8),d0
.2
	move.b	d0,d5
	lsr.w	#8,d0
	move.b	d0,L	; L ready
	move.w	HL,d0
	move.b	-2(a6),d0
	move.b	d5,ccr
	bcc.s	.3
	move.w	2(a7,d0.l*8),d0
	bra.s	.4
.3
	move.w	(a7,d0.l*8),d0
.4
	move.b	d0,d5
	move.b	L,d0
	move.w	d0,HL	; HL ready
	and.b	#$bf,d5	; Z=0
	tst.w	d2
	bne.s	.5	
	or.b	#$40,d5	; if HL=0, then Z=1
.5
	jmpnext	15
ldsppnn:			; LD  SP,(NNNN) +N	100%
	addq.l	#4,d7
	move.w	(a5)+,d0
	rol.w	#8,d0
	move.w	d0,a0
	move.w	1(a0),d0
	move.b	(a0),d0
	move.w	d0,a2
	jmpnext	20
ldi:				; LDI		++	100%
	addq.l	#4,d7
	and.b	#$E9,d5		; H , P , N = 0
	move.w	HL,a0
	move.b	(a0),d0
	move.w	DE,a0
	move.b	d0,(a0)
	addq.w	#1,HL
	addq.w	#1,DE
	subq.w	#1,BC
	beq.s	ldi2		; IF BC  = 0 then P = 0
	or.b	#$04,d5		; IF BC <> 0 then P = 1
ldi2:
	jmpnext	16
cpi:				; CPI		++
	addq.l	#4,d7
	move.w	d2,a0
	move.w	d5,d0
	move.b	(a0),d0
	and.b	#$01,d5
	or.b	(cpitab,a6,d0.l),d5
	addq.w	#1,HL
	subq.w	#1,BC
	bne.s	cpi2
	and.b	#$fb,d5
cpi2:
	jmpnext	16
ini:				; INI		--
	addq.l	#4,d7
	jmp	([intab+131072,BC.w*4])
	cnop	0,16
ini_ret:
	move.w	HL,a0
	move.b	d0,(a0)
	addq.w	#1,HL
	and.b	#$BF,d5
	sub.w	#$100,BC
	cmp.w	#$100,BC
	bcc.s	ini1
	or.b	#$40,d5
ini1:
	jmpnext	16
outi:				; OUTI		--
	addq.l	#4,d7
	move.w	HL,a0
	move.w	(a0),d0
	addq.w	#1,HL
	move.l	(outtab+131072,BC.w*4),a0
	moveq	#16,d1
	and.b	#$BF,d5
	sub.w	#$100,BC
	cmp.w	#$100,BC
	bcc.s	outi1
	or.b	#$40,d5
outi1:
	jmp	(a0)
	cnop	0,16
	ds.w	7
ldd:				; LDD		++
	addq.l	#4,d7
	and.b	#$E9,d5		; H , P , N = 0
	move.w	HL,a0
	move.b	(a0),d0
	move.w	DE,a0
	move.b	d0,(a0)
	subq.w	#1,HL
	subq.w	#1,DE
	subq.w	#1,BC
	beq.s	ldd2		; IF BC  = 0 then P = 0
	or.b	#$04,d5		; IF BC <> 0 then P = 1
ldd2:
	jmpnext	16
cp_d:				; CPD		++
	addq.l	#4,d7
	move.w	d2,a0
	move.w	d5,d0
	move.b	(a0),d0
	and.b	#$01,d5
	or.b	(cpitab,a6,d0.l),d5
	subq.w	#1,HL
	subq.w	#1,BC
	bne.s	cpd2
	and.b	#$fb,d5
cpd2:
	jmpnext	16
ind:				; IND		--
	addq.l	#4,d7
	jmp	([intab+131072,BC.w*4])
	cnop	0,16
ind_ret:
	move.w	HL,a0
	move.b	d0,(a0)
	subq.w	#1,HL
	and.b	#$BF,d5
	sub.w	#$100,BC
	cmp.w	#$100,BC
	bcc.s	ind1
	or.b	#$40,d5
ind1:
	jmpnext	16
outd:				; OUTD		--
	addq.l	#4,d7
	move.w	HL,a0
	move.w	(a0),d0
	subq.w	#1,HL
	move.l	(outtab+131072,BC.w*4),a0
	moveq	#16,d1
	and.b	#$BF,d5
	sub.w	#$100,BC
	cmp.w	#$100,BC
	bcc.s	outd1
	or.b	#$40,d5
outd1:
	jmp	(a0)
	cnop	0,16
	ds.w	7
ldir:				; LDIR		++	100%
	addq.l	#4,d7
	cmp.w	HL,DE
	beq.s	ldir0
	move.w	HL,a0
	move.b	(a0),d0
	move.w	DE,a0
	move.b	d0,(a0)
ldir0:
	addq.w	#1,HL
	addq.w	#1,DE
	subq.w	#1,BC
	beq.s	ldir2
	subq.w	#2,a5
	move.w	a5,a5
	jmpnext	21
	cnop	0,16
ldir2:
	and.b	#$E9,d5		; H , P , N = 0
	jmpnext	16
cpir:				; CPIR		++
	addq.l	#4,d7
	move.w	d2,a0
	move.w	d5,d0
	move.b	(a0),d0
	and.b	#$01,d5
	or.b	(cpitab,a6,d0.l),d5
	addq.w	#1,HL
	subq.w	#1,BC
	bne.s	cpir2
	and.b	#$fb,d5
	jmpnext	16
	cnop	0,16
cpir2:
	btst	#6,d5
	bne.s	cpir3
	subq.w	#2,a5
	move.w	a5,a5
cpir3:
	jmpnext	21
inir:				; INIR		--
	addq.l	#4,d7
	jmp	([intab+131072,BC.w*4])
	cnop	0,16
inir_ret:
	move.w	HL,a0
	move.b	d0,(a0)
	addq.w	#1,HL
	sub.w	#$100,BC
	cmp.w	#$100,BC
	bcs.s	inir1
	and.b	#$BF,d5
	subq.w	#2,a5
	jmpnext	21
	cnop	0,16
inir1:
	addq.l	#4,d7
	or.b	#$40,d5
	jmpnext	16
otir:				; OTIR		--
	addq.l	#4,d7
	or.b	#$40,d5
	move.w	HL,a0
	move.w	(a0),d0
	addq.w	#1,HL
	move.l	(outtab+131072,BC.w*4),a0
	moveq	#16,d1
	sub.w	#$100,BC
	cmp.w	#$100,BC
	bcs.s	otir1
	addq.w	#5,d1
	subq.w	#2,a5
	and.b	#$BF,d5
otir1:
	jmp	(a0)
	cnop	0,16
	ds.w	7
lddr:				; LDDR		++
	addq.l	#4,d7
	cmp	HL,DE
	beq.s	lddr0
	move.w	HL,a0
	move.b	(a0),d0
	move.w	DE,a0
	move.b	d0,(a0)
lddr0:
	subq.w	#1,HL
	subq.w	#1,DE
	subq.w	#1,BC
	beq.s	lddr2
	subq.w	#2,a5
	move.w	a5,a5
	jmpnext	21
	cnop	0,16
lddr2:
	and.b	#$E9,d5		; H , P , N = 0
	jmpnext	16
cpdr:				; CPDR		++
	addq.l	#4,d7
	move.w	d2,a0
	move.w	d5,d0
	move.b	(a0),d0
	and.b	#$01,d5
	or.b	(cpitab,a6,d0.l),d5
	subq.w	#1,HL
	subq.w	#1,BC
	bne.s	cpdr2
	and.b	#$fb,d5
	jmpnext	16
	cnop	0,16
cpdr2:
	btst	#6,d5
	bne.s	cpdr3
	subq.w	#2,a5
	move.w	a5,a5
cpdr3:
	jmpnext	21
indr:				; INDR		--
	addq.l	#4,d7
	jmp	([intab+131072,BC.w*4])
	cnop	0,16
indr_ret:
	move.w	HL,a0
	move.b	d0,(a0)
	subq.w	#1,HL
	sub.w	#$100,BC
	cmp.w	#$100,BC
	bcs.s	indr1
	and.b	#$BF,d5
	subq.w	#2,a5
	jmpnext	21
	cnop	0,16
indr1:
	or.b	#$40,d5
	jmpnext	16
otdr:				; OTDR		--
	addq.l	#4,d7
	or.b	#$40,d5
	move.w	HL,a0
	move.w	(a0),d0
	subq.w	#1,HL
	move.l	(outtab+131072,BC.w*4),a0
	moveq	#16,d1
	sub.w	#$100,BC
	cmp.w	#$100,BC
	bcs.s	otdr1
	addq.w	#5,d1
	subq.w	#2,a5
	and.b	#$BF,d5
otdr1:
	jmp	(a0)
	cnop	0,16
;===================================================================
out1F:
	tst.b	trdos_flg+1
	beq	noout
;
	move.w	#2,DWaitCNT
	lsr.w	#8,d0
	cmp.w	#$f4,d0
	beq	cmd_format
	and.w	#$f0,d0
	move.w	d0,Cmd93
	cmp.w	#$00,d0
	beq.w	cmd_t0
	cmp.w	#$10,d0
	beq.s	cmd_seek
	cmp.w	#$50,d0
	beq.s	cmd_step
	cmp.w	#$70,d0
	beq.s	cmd_stepout
	cmp.w	#$80,d0
	beq	cmd_read
	cmp.w	#$a0,d0
	beq	cmd_write
	cmp.w	#$c0,d0
	beq	cmd_rdummy
	cmp.w	#$e0,d0
	beq	cmd_rdummy
	clr.w	Byte93
	move.w	#$d0,Cmd93
	jmpnextd1
cmd_stepout:
	move.w	Track93,d0
	tst.w	d0
	beq.s	cmd_t0
	subq.w	#1,d0
	beq.s	cmd_t0
cmd_step:
	move.w	Track93,d0
	addq.w	#1,d0
	bra.s	cmd_t0
cmd_seek:
	move.w	DummyDat93,d0
cmd_t0:
	cmp.w	#80,d0
	bcs.s	cmd_s1
	move.w	#79,d0
cmd_s1:
	move.w	d0,Track93
	jmpnextd1
cmd_format:
	move.w	Track93,d0
	lsl.w	#5,d0
	btst.b	#4,FF93+1
	bne.s	.1
	add.w	#$10,d0
.1:
	lsl.l	#8,d0
	add.l	#DSKbuf,d0
	btst.b	#0,FF93+1
	beq.s	.2
	add.l	#4096*160,d0
.2:
	move.l	d0,a0
	move.w	#1023,d0
.3:
	clr.l	(a0)+
	dbra	d0,.3
	moveq.l	#0,d0
	clr.w	Byte93
	move.w	#$d0,Cmd93
	jmpnextd1
;
cmd_write:
	btst.b	#0,FF93+1
	beq.s	.1
	st	Change_TRDB
	bra.s	.2
.1:
	st	Change_TRDA
.2:
cmd_read:
	move.w	Track93,d0
	lsl.w	#5,d0
	btst.b	#4,FF93+1
	bne.s	cmd_rw1
	add.w	#$10,d0
cmd_rw1:
	add.w	Sec93,d0
	subq.w	#1,d0
	lsl.l	#8,d0
	add.l	#DSKbuf,d0
	btst.b	#0,FF93+1
	beq.s	.1
	add.l	#4096*160,d0
.1
	move.l	d0,PntDSK
	clr.l	d0
	move.w	#$100,Byte93
	jmpnextd1
cmd_rdummy:
	move.w	Track93,d0
	tst.w	d0
;	bne.s	.1
;	move.w	#1,d0
;.1:
	move.b	d0,DummyHeader
	move.l	#DummyHeader,PntDSK
	move.w	#6,Byte93
	jmpnextd1
	cnop	0,16
out3F:
	tst.b	trdos_flg+1
	beq	noout
	lsr.w	#8,d0
	move.w	d0,Track93
	jmpnextd1
	cnop	0,16
out5F:
	tst.b	trdos_flg+1
	beq	noout
	lsr.w	#8,d0
	move.w	d0,Sec93
	jmpnextd1
	cnop	0,16
out7F:
	tst.b	trdos_flg+1
	beq	noout
	lsr.w	#8,d0
	move.w	d0,DummyDat93
	cmp.w	#$a0,Cmd93
	bne.s	out7F1
	tst.w	Byte93
	beq.s	out7F1
	move.l	PntDSK,a0
	move.b	d0,(a0)+
	move.l	a0,PntDSK
	subq.w	#1,Byte93
out7F1:
	jmpnextd1
	cnop	0,16
outFF:
	tst.b	trdos_flg+1
	beq	noout
	lsr.w	#8,d0
	move.w	d0,FF93
	jmpnextd1
;
	cnop	0,16
;
FF93:
	dc.w	0
DummyDat93:
	dc.w	0
Track93:
	dc.w	0
Sec93:
	dc.w	0
Byte93:
	dc.w	0
Cmd93:
	dc.w	0
PntDSK:
	dc.l	0
;
DummyHeader:
	dc.b	1,0,1,1,$55,$aa
;
Dummy1F:
	dc.w	0
;
	cnop	0,16
in1F:
	tst.b	trdos_flg+1
	beq	InKJ
	cmp.w	#$d0,Cmd93
	beq.s	.1
	cmp.w	#$20,Cmd93
	bcc.s	in1F1
.1:
	move.w	Dummy1F,d0
	eor.w	#2,d0
	move.w	d0,Dummy1F
	tst.w	Track93
	bne	Endin
	or.w	#4,d0
	bra	Endin
in1F1:
	clr.b	d0
	bra	Endin
	cnop	0,16
in3F:
	tst.b	trdos_flg+1
	beq	Endin
	move.w	Track93,d0
	bra	Endin
	cnop	0,16
in5F:
	tst.b	trdos_flg+1
	beq	Endin
	move.w	Sec93,d0
	bra	Endin
	cnop	0,16
in7F:
	tst.b	trdos_flg+1
	beq	Endin
	tst.w	Byte93
	beq	Endin
	move.l	PntDSK,a0
	move.b	(a0)+,d0
	move.l	a0,PntDSK
	subq.w	#1,Byte93
	cmp.w	#2,-$c(a6)
	bne	Endin
	sub.w	#80,d6
	bra	Endin
	cnop	0,16
inFF:
	tst.b	trdos_flg+1
	beq	Endin
	tst.w	Byte93
	beq.s	inFF1
	move.b	#%01111111,d0
	bra	Endin
inFF1:
	move.b	#%10111111,d0
	bra	Endin
;
	cnop	0,16
InKJ:
	clr.w	d0
	tst.w	JoyMode
	bne	Endin
	bsr.s	GetJoy
	clr.w	d1
	bra	Endin
;
	cnop	0,16
GetJoy:
	move.w	joy1dat+$dff000,d0
	move.w	d0,d1
	lsr.w	#1,d0
	and.w	#$101,d0
	eor.w	d0,d1
	clr.w	d0
	btst	#0,d1
	beq.s	NoBack
	or.w	#4,d0
NoBack:
	btst	#1,d1
	beq.s	NoRight
	or.w	#1,d0
NoRight:
	btst	#8,d1
	beq.s	NoFrw
	or.w	#8,d0
NoFrw:
	btst	#9,d1
	beq.s	NoLeft
	or.w	#2,d0
NoLeft:
	btst.b	#7,$bfe001
	bne.s	NoFire
	or.w	#$10,d0
NoFire:
	rts
;
	cnop	0,16
inFADF:
	move.w	#$00ff,d0
	btst.b	#6,$bfe001
	bne.s	.1
	and.w	#$FFFD,d0
.1:
	btst.b	#2,$dff016
	bne.s	.2
	and.w	#$FFFE,d0
.2:
	bra	Endin
	cnop	0,16
inFBDF:
	move.b	joy0dat+$dff001,d0
	bra	Endin
	cnop	0,16
inFFDF:
	move.b	joy0dat+$dff000,d0
	not.b	d0
	bra	Endin

;===================================================================

	cnop	0,16
OutAYreg:
	lsr.w	#8,d0
	and.w	#15,d0
	move.w	d0,AYreg
	jmpnextd1
	cnop	0,16
AYreg:
	dc.w	0
	cnop	0,16
;
AYreg0:		dc.b	0
AYreg1:		dc.b	0
AYreg2:		dc.b	0
AYreg3:		dc.b	0
AYreg4:		dc.b	0
AYreg5:		dc.b	0
AYreg6:		dc.b	0
AYreg7:		dc.b	0
AYreg8:		dc.b	0
AYreg9:		dc.b	0
AYreg10:	dc.b	0
AYreg11:	dc.b	0
AYreg12:	dc.b	0
AYreg13:	dc.b	0
AYreg14:	dc.b	0
AYreg15:	dc.b	0
;
	cnop	0,16
voltab	equ	*-AYreg0
	rept	8
	dc.w	0,0,1,3,5,7,$a,$e,$13,$17,$1b,$23,$2a,$30,$34,$3f
	dcb.w	16,$3f
	endr
;
maxfreq:	macro
	cmp.w	#124,d0
	bcc.s	\@1
	move.w	#124,d0
\@1:
	endm
;
	cnop	0,16
OutAYdat:
	move.l	d1,-(a7)
	lea	AYreg0(pc),a0
	lsr.w	#8,d0
	move.w	AYreg,d1
	move.b	d0,(a0,d1.w)
	move.l	(a7)+,d1
	jmpnextd1
PlayAY:
	clr.l	d0
	clr.l	d1
	lea	AYreg0(pc),a0
	move.w	#$00ff,$dff09e
	btst.b	#4,$A(a0)
	bne	OvlC
	btst.b	#4,9(a0)
	bne	OvlB
	btst.b	#4,8(a0)
	bne	OvlA
NoOvl:
	move.w	0(a0),d0
	ror.w	#4,d0
	and.w	#$fff0,d0
	maxfreq
	move.w	d0,$dff0a6
	move.w	#2,$dff0a4
	move.b	8(a0),d1
	move.w	voltab(a0,d1.w*2),$dff0a8
;
	move.w	2(a0),d0
	ror.w	#4,d0
	and.w	#$fff0,d0
	maxfreq
	move.w	d0,$dff0b6
	move.w	#2,$dff0b4
	move.b	9(a0),d1
	move.w	voltab(a0,d1.w*2),$dff0b8
;
	move.w	4(a0),d0
	ror.w	#4,d0
	and.w	#$fff0,d0
	maxfreq
	move.w	d0,$dff0c6
	move.w	#2,$dff0c4
	move.b	10(a0),d1
	move.w	voltab(a0,d1.w*2),$dff0c8
;
	clr.w	$dff0d8
;
	move.b	7(a0),d1
	lea	(REG7tab,d1.w*8),a0
	move.l	(a0)+,$dff0a0
	move.l	(a0),$dff0b0
	move.l	2044(a0),$dff0c0
;
	rts
OvlA:
	move.l	#OVLsample,$dff0a0
	move.w	#32,$dff0a4
	move.w	11(a0),d0
	ror.w	#4,d0
	and.w	#$fff0,d0
	maxfreq
	move.w	d0,$dff0a6
	move.w	#$8001,$dff09e
;
	move.w	0(a0),d0
	ror.w	#4,d0
	and.w	#$fff0,d0
	maxfreq
	move.w	d0,$dff0b6
	move.w	#2,$dff0b4
	move.b	8(a0),d1
	move.w	voltab(a0,d1.w*2),$dff0b8
;
	move.w	2(a0),d0
	ror.w	#4,d0
	and.w	#$fff0,d0
	maxfreq
	move.w	d0,$dff0c6
	move.w	#2,$dff0c4
	move.b	9(a0),d1
	move.w	voltab(a0,d1.w*2),$dff0c8
;
	move.w	4(a0),d0
	ror.w	#4,d0
	and.w	#$fff0,d0
	maxfreq
	move.w	d0,$dff0d6
	move.w	#2,$dff0d4
	move.b	10(a0),d1
	move.w	voltab(a0,d1.w*2),$dff0d8
;
	move.b	7(a0),d1
	lea	(REG7tab,d1.w*8),a0
	move.l	(a0)+,$dff0b0
	move.l	(a0),$dff0c0
	move.l	2044(a0),$dff0d0
;
	rts
OvlB:
	move.l	#OVLsample,$dff0b0
	move.w	#32,$dff0b4
	move.w	11(a0),d0
	ror.w	#4,d0
	maxfreq
	and.w	#$fff0,d0
	move.w	d0,$dff0b6
	move.w	#$8002,$dff09e
;
	move.w	0(a0),d0
	ror.w	#4,d0
	and.w	#$fff0,d0
	maxfreq
	move.w	d0,$dff0a6
	move.w	#2,$dff0a4
	move.b	8(a0),d1
	move.w	voltab(a0,d1.w*2),$dff0a8
;
	move.w	2(a0),d0
	ror.w	#4,d0
	and.w	#$fff0,d0
	maxfreq
	move.w	d0,$dff0c6
	move.w	#2,$dff0c4
	move.b	9(a0),d1
	move.w	voltab(a0,d1.w*2),$dff0c8
;
	move.w	4(a0),d0
	ror.w	#4,d0
	and.w	#$fff0,d0
	maxfreq
	move.w	d0,$dff0d6
	move.w	#2,$dff0d4
	move.b	10(a0),d1
	move.w	voltab(a0,d1.w*2),$dff0d8
;
	move.b	7(a0),d1
	lea	(REG7tab,d1.w*8),a0
	move.l	(a0)+,$dff0a0
	move.l	(a0),$dff0c0
	move.l	2044(a0),$dff0d0
;
	rts
OvlC:
	move.l	#OVLsample,$dff0c0
	move.w	#32,$dff0c4
	move.w	11(a0),d0
	ror.w	#4,d0
	and.w	#$fff0,d0
	maxfreq
	move.w	d0,$dff0c6
	move.w	#$8004,$dff09e
;
	move.w	0(a0),d0
	ror.w	#4,d0
	and.w	#$fff0,d0
	maxfreq
	move.w	d0,$dff0a6
	move.w	#2,$dff0a4
	move.b	8(a0),d1
	move.w	voltab(a0,d1.w*2),$dff0a8
;
	move.w	2(a0),d0
	ror.w	#4,d0
	and.w	#$fff0,d0
	maxfreq
	move.w	d0,$dff0b6
	move.w	#2,$dff0b4
	move.b	9(a0),d1
	move.w	voltab(a0,d1.w*2),$dff0b8
;
	move.w	4(a0),d0
	ror.w	#4,d0
	and.w	#$fff0,d0
	maxfreq
	move.w	d0,$dff0d6
	move.w	#2,$dff0d4
	move.b	10(a0),d1
	move.w	voltab(a0,d1.w*2),$dff0d8
;
	move.b	7(a0),d1
	lea	(REG7tab,d1.w*8),a0
	move.l	(a0)+,$dff0a0
	move.l	(a0),$dff0b0
	move.l	2044(a0),$dff0d0
;
	rts
;
REG7tab:
	rept	64
	dc.l	AYsample
	dc.l	AYsample
	dc.l	AYsample1
	dc.l	AYsample
	dc.l	AYsample
	dc.l	AYsample1
	dc.l	AYsample1
	dc.l	AYsample1
	endr
	rept	32
	dc.l	AYsample,AYsample
	dc.l	AYsample,AYsample
	dc.l	AYsample,AYsample
	dc.l	AYsample,AYsample
	dc.l	AYsample1,AYsample1
	dc.l	AYsample1,AYsample1
	dc.l	AYsample1,AYsample1
	dc.l	AYsample1,AYsample1
	endr
;
	cnop	0,16
AYin:
	lea	AYreg0(pc),a0
	move.w	AYreg,d0
	move.b	(a0,d0.w),d0
	bra.s	Endin
noin:
	move.b	#255,d0
Endin:
	move.b	-1(a5),d1
	jmp	([inrettab,d1.w*4])
	cnop	0,16
;
itemin:	macro
	rept	\1-xincode
	dc.l	Upor
	endr
	dc.l	\2
xincode	set	\1+1
	endm
;
xincode	set	0
;
inrettab:
	itemin	$40,inpcret_B
	itemin	$48,inpcret_C
	itemin	$50,inpcret_D
	itemin	$58,inpcret_E
	itemin	$60,inpcret_H
	itemin	$68,inpcret_L
	itemin	$78,inpcret_A
	itemin	$A2,ini_ret
	itemin	$AA,ind_ret
	itemin	$B2,inir_ret
	itemin	$BA,indr_ret
	itemin	$DB,inapn_ret
	rept	$100-xincode
	dc.l	Upor
	endr
;
BRDqpnt:
	dc.l	0
	cnop	0,16
OutFE:
	move.l	BRDqpnt,a0
	move.w	d0,(a0)+
	move.w	d6,d0
	sub.l	imod4(a1),d0
;	neg.l	d0
	sub.l	d1,d0
;
;	bpl.s	.1
;	moveq	#0,d0
;.1:
;	cmp.l	#71680,d0
;	bcs.s	.2
;	move.l	#71679,d0
;.2:
;
	move.l	d0,(a0)+
	move.l	a0,BRDqpnt
	clr.l	d0
	jmpnextd1
;
;-------------------------------------
;	Keyboard...
;-------------------------------------
	cnop	0,16
KeyBuf:
	rept	8
	dc.b	$ff
	endr
	cnop	0,16
;
;-------------------------------------
;
;	Init MMU
;
;-------------------------------------
	section	mmu040,bss_f
;
mb_040:
	ds.l	64*8*2	;pages
	ds.l	64*3*2	;roms
;
	ds.b	512
;
mb040:	ds.l	1
;
Pages:
	ds.l	1
page_5a:	ds.l	1
page_7a:	ds.l	1
;
	section	xxmmu,code_f
Setpages:
	tst.l	CPU?
	beq.s	Setp030
;
	move.l	#Out7FFD,a0
	move.l	#Out7FFD_040,a1
	move.w	#len7ffdpatch-1,d0
.1:
	move.b	(a1)+,(a0)+
	dbra	d0,.1
	move.w	coderte,MMUerr
;
Setp040:
       	lea.l	FindMMU,a5
	move.l	4.w,a6
       	jsr    	-30(a6)        	;EXEC Supervisor function
;
	move.l	a0,a1
	move.l	(a0),d0
	and.w	#$fe00,d0
	move.l	d0,mmu_base_up
	move.l	127*4(a1),d0
	and.w	#$fe00,d0
	add.l	#127*4,d0
	move.l	d0,mmu_base_down
	move.l	#mb_040,d0
	and.w	#$fe00,d0
	add.l	#$0200,d0
	move.l	d0,mb040
;
Setp030:
	move.l	#$4000,d1
	move.l	#rambuf,d0
	and.l	#$ffffc000,d0
	add.l	d1,d0
	move.l	d0,Pages
	addq	#1,d0
;
	move.l	d0,p0000
	move.l	d0,Rom_48
	add.l	d1,d0
	move.l	d0,p4000
	move.l	d0,p4000x
	move.l	d0,page_5
	move.l	d0,page_5a
	add.l	d1,d0
	move.l	d0,p8000
	move.l	d0,p8000x
	move.l	d0,page_2
	add.l	d1,d0
	move.l	d0,pC000
	move.l	d0,page_0
;
	add.l	d1,d0		; Set "other" pages...
	move.l	d0,page_1
	add.l	d1,d0
	move.l	d0,page_3
	add.l	d1,d0
	move.l	d0,page_4
	add.l	d1,d0
	move.l	d0,page_6
	add.l	d1,d0
	move.l	d0,page_7
	move.l	d0,page_7a
	add.l	d1,d0
	move.l	d0,Rom128
	move.l	d0,p0000
	add.l	d1,d0
	move.l	d0,TR_DOS
;
	moveq.l	#4,d0
	or.l	d0,Rom_48
	or.l	d0,Rom128
	or.l	d0,TR_DOS
;
	move.l	#treebuf,d0
	and.l	#$ffffff00,d0
	add.l	#$00000100,d0
	move.l	d0,tree_base
	move.l	d0,a0
;
	move.l	#Tree,a1
	sub.l	a1,d0

	add.l	d0,mod0
	add.l	d0,mod1
	add.l	d0,mod2
	add.l	d0,mod3
	add.l	d0,mod4
	add.l	d0,mod5

	move.w	#2047,d0
IniTree:
	move.l	(a1)+,(a0)+
	dbra	d0,IniTree
;
	lea	PageTab,a0
	moveq	#7,d7
	move.l	page_5,d0
	move.l	page_7,d1
	subq.l	#1,d0
	subq.l	#1,d1
Iniscr1:
	move.l	(a0),64(a0)
	move.l	d0,4(a0)
	move.l	d1,68(a0)
	addq.l	#8,a0
	dbra	d7,Iniscr1
;
	lea	PageTab,a0
	lea	128(a0),a1
	move.w	#255-16,d7
inipt1:
	move.l	(a0)+,(a1)+
	move.l	(a0)+,(a1)+
	dbra	d7,inipt1
;
	lea	PageTab+2048,a0
	clr.w	d7
inipt2:
	move.l	Rom_48,d0
	btst	#4,d7
	bne.s	inipt3
	move.l	Rom128,d0
inipt3:
	move.l	d0,(a0)+
	move.l	TR_DOS,(a0)+
	addq.w	#1,d7
	cmp.w	#$100,d7
	bne.s	inipt2
;
	tst.l	CPU?
	beq	.1
	move.l	#$1000,d2
	lea	PageTab,a0
	move.l	mb040,a1
	move.l	#7,d7
.2:
	lea	4*52(a1),a1
	move.l	page_5,d1
	or.w	#$400,d1
	bsr	.4
	move.l	page_2,d1
	or.w	#$400,d1
	bsr	.4
	move.l	(a0)+,d1
	bsr	.4
	lea	$100(a1),a1
	addq.l	#4,a0
	dbra	d7,.2
;
	move.l	Rom_48,d1
	bsr	.4
	move.l	page_5,d1
	or.w	#$400,d1
	bsr	.4
	move.l	page_2,d1
	or.w	#$400,d1
	bsr	.4
	lea	4*52+$100(a1),a1
;
	move.l	Rom128,d1
	bsr.	.4
	move.l	page_5,d1
	or.w	#$400,d1
	bsr	.4
	move.l	page_2,d1
	or.w	#$400,d1
	bsr.s	.4
	lea	4*52+$100(a1),a1
;
	move.l	TR_DOS,d1
	bsr.s	.4
	move.l	page_5,d1
	or.w	#$400,d1
	bsr.s	.4
	move.l	page_2,d1
	or.w	#$400,d1
	bsr.s	.4
;
	lea	PageTab,a0
	lea	2048(a0),a1
	clr.w	d7
.5:
	move.w	d7,d0
	and.l	#$7,d0
	lsl.l	#8,d0
	lsl.l	#1,d0
	add.l	mb040,d0
	addq.l	#3,d0
	move.l	d0,(a0)
	addq.l	#8,a0
	move.l	mb040,d0
	add.l	#64*4*8*2+3,d0
	btst	#4,d7
	bne.s	.6
	add.l	#64*4*2,d0
.6:
	move.l	d0,(a1)+
	move.l	mb040,d0
	add.l	#64*4*10*2+3,d0
	move.l	d0,(a1)+
	addq.w	#1,d7
	cmp.w	#$100,d7
	bne.s	.5
;
.1:
	rts
.4:
;	or.b	#$20,d1
	move.l	d1,(a1)+
	add.l	d2,d1
	move.l	d1,(a1)+
	add.l	d2,d1
	move.l	d1,(a1)+
	add.l	d2,d1
	move.l	d1,(a1)+
	rts
;
	opt	p=68040
;
FindMMU	movec	srp,a0
	movec	tc,d0
	rte
;
	cnop	0,16
Out7FFD_040:
	lsr.w	#8,d0
	move.w	d0,Copy7FFD
;
	lea	(PageTab,d0.w*8),a0
;trdos_flg	equ	*+2
	move.l	2048(a0),$12345678
	move.l	(a0)+,$12345678
	move.l	(a0),a3
;
	cinva	dc
	pflushan
	jmpnextd1
len7ffdpatch	equ	*-Out7FFD_040
	cnop	0,16
;
;----------------------------------------
;
;	MMU Code...
;
;----------------------------------------
;
	Section	mmu,code_f
;
tMMU:
;
CodeForCRP:
	dc.l	$80000202
tree_base:
	dc.l	0
CodeForTC:
	dc.l	$80E08442
CodeForTT0:
	dc.w	$401f
	dc.w	$8107
;
Tree:
mod0:	dc.l	tree2_l+2	;16Mb
treeadr	set	$01000001
	rept	254
	dc.l	treeadr
treeadr	set	treeadr+$01000000
	endr
mod1:	dc.l	tree2_h+2
tree2_l:
mod2:
treeadr	set	$00100001
	dc.l	tree3_l+2	;1Mb
	rept	63
	dc.l	treeadr
treeadr	set	treeadr+$00100000
	endr
tree3_l:
mod3:	dc.l	tree4_l+2	;64Kb
	ds.l	63
tree4_l:
p0000:
	dc.l	0
p4000:
	dc.l	0
p8000x:
	dc.l	0
	dc.l	0
	ds.l	60
tree2_h:
	ds.l	15
mod4:	dc.l	tree3_h+2	;1Mb
	ds.l	48
tree3_h:
	ds.l	15
mod5:	dc.l	tree4_h+2	;64Kb
	ds.l	48
tree4_h:
	dc.l	0
p4000x:
	dc.l	0
p8000:
	dc.l	0
pC000:
	dc.l	0
;
	list
treelen	equ	*-Tree
	nolist
;
treebuf:
	ds.l	5000
;
	section	buffers1,bss_f
;
outtab:
	ds.l	65536
intab:
	ds.l	65536
;
BRDquene0:
	ds.w	3*(71680/11+1)
BRDquene1:
	ds.w	3*(71680/11+1)
BRDscr:
	ds.b	4096*3
BRDtab:
	ds.w	71680
;
	section	Disk,bss_f
;
tDISK:
;
DSKbuf:
	ds.b	4096*160
Pulses:
	ds.b	4096*160
EndPulses	equ	*-1000
;
;----------------------------------------
;
;	Load SNA, Z80, etc... files
;
;----------------------------------------

	section	LoadFiles,code_f

LoadSNA:				; Load *.SNA files
	move.w	#$0010,d0		; Set 48k Rom...
	bsr.w	SetPage
	move.l	SNA_base,a0
	move.b	(a0)+,-$e(a6)		; I
	move.w	(a0)+,d2		; HL'
	rol.w	#8,d2
	move.w	(a0)+,d3		; DE'
	rol.w	#8,d3
	move.w	(a0)+,d4		; BC'
	rol.w	#8,d4
	move.w	(a0)+,d5		; AF'
	rol.w	#8,d5
	swap	d2			; EXX
	swap	d3
	swap	d4
	swap	d5			; EX	AF,AF'
	move.w	(a0)+,d2		; HL
	rol.w	#8,d2
	move.w	(a0)+,d3		; DE
	rol.w	#8,d3
	move.w	(a0)+,d4		; BC
	rol.w	#8,d4
	move.b	(a0)+,-5(a6)		; IY
	move.b	(a0)+,-6(a6)
	move.b	(a0)+,-3(a6)		; IX
	move.b	(a0)+,-4(a6)
	move.b	(a0)+,d0		; bit 2 = 0 - DI, = 1 - EI
	and.w	#$0004,d0
	move.w	d0,-$8(a6)		; IFF1
	move.w	d0,-$a(a6)		; IFF2
	move.b	(a0)+,d7		; R
	rol.b	d7
	move.w	(a0)+,d5		; AF
	rol.w	#8,d5
	move.w	(a0)+,d0		; SP
	rol.w	#8,d0
	move.w	d0,ZXSP
	move.b	(a0)+,-$b(a6)		; Int Number
	move.b	(a0)+,d0		; BorderColor
	and.w	#$00FF,d0
	move.w	d0,BrdClr
;
	move.l	Pages,a1		; Copy $c000 bytes to $4000
	add.l	#$4000,a1
	move.w	#$bfff,d0
sna1:
	move.b	(a0)+,(a1)+
	dbra	d0,sna1
;
	move.w	#$0052,ZXPC		; RET
	clr.l	d6
	movem.l	d2-d7,ZXR_save		; Save ZX Regs...
	rts

LoadZ80:				; Load *.z80 files
	move.l	SNA_base,a0
	move.w	(a0)+,d5		; AF
	move.w	(a0)+,d4		; BC
	rol.w	#8,d4
	move.w	(a0)+,d2		; HL
	rol.w	#8,d2
	clr.l	d0			; PC
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,a5
	move.w	(a0)+,d0		; SP
	rol.w	#8,d0
	move.w	d0,ZXSP
	move.b	(a0)+,-$e(a6)		; I
	move.b	(a0)+,d7		; R
	rol.b	d7
	move.b	(a0)+,d1		; ... byte 12
	move.w	(a0)+,d3		; DE
	rol.w	#8,d3
	swap	d2			; EXX
	swap	d3
	swap	d4
	swap	d5			; EX	AF,AF'
	move.w	(a0)+,d4		; BC'
	rol.w	#8,d4
	move.w	(a0)+,d3		; DE'
	rol.w	#8,d3
	move.w	(a0)+,d2		; HL'
	rol.w	#8,d2
	move.w	(a0)+,d5		; AF'
	move.b	(a0)+,-5(a6)		; IY
	move.b	(a0)+,-6(a6)
	move.b	(a0)+,-3(a6)		; IX
	move.b	(a0)+,-4(a6)
	move.b	(a0)+,d0		; DI or EI ?
	tst.b	d0
	beq.s	.1
	move.w	#$0004,d0
.1
	and.w	#$0004,d0
	move.w	d0,-$8(a6)		; IFF1
	move.b	(a0)+,d0		; DI or EI ?
	tst.b	d0
	beq.s	.2
	move.w	#$0004,d0
.2
	and.w	#$0004,d0
	move.w	d0,-$a(a6)		; IFF2
	move.b	(a0)+,d0		; Int Number
	and.w	#$0003,d0
	move.w	d0,-$c(a6)
	swap	d2			; EXX
	swap	d3
	swap	d4
	swap	d5			; EX	AF,AF'
;
	move.w	#$0010,d0		; Set 48k Rom...
	bsr.w	SetPage
;
	cmp.w	#$0000,a5
	beq.s	v2.01
v1.45:
	move.l	Pages,a1
	add.l	#$4000,a1
zloop:
	cmp.l	#$00eded00,(a0)
	beq.s	z80exit
	move.b	(a0)+,d0
	cmp.b	#$ed,d0
	bne.s	zloop2
	cmp.b	#$ed,(a0)
	bne.s	zloop2
	addq.l	#1,a0
	move.b	(a0)+,d1		; How many
	move.b	(a0)+,d0		; data
zloop3:
	move.b	d0,(a1)+
	subq.b	#1,d1
	bne.s	zloop3
	bra.s	zloop
zloop2:
	move.b	d0,(a1)+
	bra.s	zloop
z80exit:
	move.w	a5,ZXPC			; RET
	clr.l	d6
	movem.l	d2-d7,ZXR_save		; Save ZX Regs...
	rts
v2.01:
	cmp.w	#$1700,(a0)+
	bne.w	v3.00
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,a5		; Reload PC...
	move.b	(a0)+,d0
	cmp.b	#2,d0
	bcs.s	v2_48
v2_128:				; v2.01 128k shapshot...
	move.b	(a0)+,d0
	lea	19(a0),a0
v3_128_2:
	and.w	#$00ff,d0
	bsr.w	SetPage
;
	movem.l	d7,-(a7)
;
	moveq.l	#$7,d7
v2_128l:
	move.w	(a0)+,d0
	move.b	(a0)+,d1
	rol.w	#8,d0
	subq.b	#$3,d1
	and.w	#$00ff,d1
	move.l	(PageTab,d1.w*8),a1
	tst.l	CPU?
	beq.s	.1
	move.l	a1,d1
	and.l	#$FFFFFF00,d1
	move.l	d1,a1
	move.l	$f0(a1),d1
	and.l	#$FFFFF000,d1
	addq.l	#1,d1
	move.l	d1,a1
.1:
	subq.l	#1,a1
	bsr.w	LoadPage
	dbra	d7,v2_128l
;
	movem.l	(a7)+,d7
	bra.s	z80exit
v2_48:				; v2.01  48k snapshot...
	lea	20(a0),a0
v3_48_2:
	move.w	(a0)+,d0
	move.b	(a0)+,d1
	rol.w	#8,d0
	move.l	Pages,a1
	add.l	#$8000,a1
	bsr.s	LoadPage
	move.w	(a0)+,d0
	move.b	(a0)+,d1
	rol.w	#8,d0
	bsr.s	LoadPage
	move.w	(a0)+,d0
	move.b	(a0)+,d1
	rol.w	#8,d0
	sub.l	#$c000,a1
	bsr.s	LoadPage
	bra.w	z80exit
v3.00:
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,a5		; Reload PC...
	move.b	(a0)+,d0
	cmp.b	#$3,d0
	bcs.s	v3_48
v3_128:				; v3.00 128k shapshot...
	move.b	(a0)+,d0
	lea	50(a0),a0
	bra.w	v3_128_2
v3_48:				; V3.00  48k shapshot...
	lea	51(a0),a0
	bra.w	v3_48_2
LoadPage:				; A1 , D0 - lenght
	tst.w	d0
	beq.s	LP_Exit
	move.b	(a0)+,d6
	subq.w	#1,d0
	cmp.b	#$ed,d6
	bne.s	LoadP2
	cmp.b	#$ed,(a0)
	bne.s	LoadP2
	addq.l	#1,a0
	move.b	(a0)+,d1		; How many
	move.b	(a0)+,d6		; data
	subq.w	#3,d0
LoadP3:
	move.b	d6,(a1)+
	subq.b	#1,d1
	bne.s	LoadP3
	bra.s	LoadPage
LoadP2:
	move.b	d6,(a1)+
	bra.s	LoadPage
LP_Exit:
	rts
SetPage:
	move.w	d0,Copy7FFD
	move.l	tree_base,a3
	lea	(PageTab,d0.w*8),a1
	move.l	2048(a1),p0000-Tree(a3)
	move.l	(a1),pC000-Tree(a3)
	rts
;
WaitKBD:
	nop
	tst.w	WaitKBD?
	beq.s	.1
	tst.w	KeyClick
	bne.s	.1
	subq.w	#2,a5
	move.w	a5,a5
.1:
	jmpnext	16
Rom:
	incbin	"zx-emul/roms/48_Max.rom"
Rom_128:
	incbin	"zx-emul/roms/128_Max.rom"
TrDos:
	incbin	"zx-emul/roms/trdos_Max.rom"

;========================================
;
;	ZX-Spectrum memory
;
;========================================

	section	ZXram,bss_f
tZXRAM:
;
rambuf:	; 	main  pages  rom128 TRDOS tmp
	ds.b	65536+16384*5+16384+16384+16384
Z2Ptab:
	ds.l	65536

;========================================
;
;	Chip Data: Screen & Copper
;
;========================================

	section	Screen,data_c
;
tCHIP:
;
ZXScreen:			; bpl1
	ds.b	6144
DummyBpl:
	ds.b	6144		; rest planes
;
Copper:
	dc.w	$1fc,$0000
;
	dc.w	$106,$0
First16pal:
	dc.w	$1FE,0,$182,0,$184,0,$186,0
	dc.w	$188,0,$18a,0,$18c,0,$18e,0
	dc.w	$190,0,$192,0,$194,0,$196,0
	dc.w	$198,0,$19a,0,$19c,0,$19e,0
;
@bpa	equ	*+2
	dc.w	$e0,0,$e2,0
;
	dc.w	$100,$1201
	dc.w	$104,0,$102,$0200
	dc.w	bpl1mod,0
	dc.w	bpl2mod,0
	dc.w	$4b01,$fffe
	dc.w	intreq,$8010
;
vcop_pos	set	$4c01
;
xcopper:
	rept	192
;
	dc.w	bltapt
	dc.w	0
	dc.w	bltapt+2
	dc.w	0
	dc.w	bltdpt
	dc.w	0
	dc.w	bltdpt+2
	dc.w	0
	dc.w	bltsize,17*64+1
	dc.w	vcop_pos+70,$fffe
	dc.w	$1fe,0000
	dc.w	$1fe,0000
	dc.w	$010c,0,$010c,0,$010c,0,$010c,0,$010c,0,$010c,0,$010c,0,$010c,0
	dc.w	$010c,0,$010c,0,$010c,0,$010c,0,$010c,0,$010c,0,$010c,0,$010c,0
	dc.w	$010c,0,$010c,0,$010c,0,$010c,0,$010c,0,$010c,0,$010c,0,$010c,0
	dc.w	$010c,0,$010c,0,$010c,0,$010c,0,$010c,0,$010c,0,$010c,0,$010c,0
;
vcop_pos	set	(vcop_pos+$100)&$ffff
	endr	
	dc.w	intreq,$8004
	dc.w	$100,$0201
	dc.w	$102,$0000
;
	dc.w	$106,$000
	dc.w	$10c,$0000
;	dc.w	$180,$000
pal_disk_a:
	dc.w	$182,$f00
	dc.w	$184,$ff0
	dc.w	$186,$fff
	dc.w	$188,$88d
;
pal_disk_b:
	dc.w	$18A,$000
	dc.w	$18C,$000
	dc.w	$18E,$000
	dc.w	$190,$000
;
pal_lock:
	dc.w	$192,$000
;
pal_tape:
	dc.w	$194,$000
;
	dc.w	$196,$000
	dc.w	$198,$000,$19a,0,$19c,0,$19e,0
;
	dc.w	$0c01,$fffe
@bpa_s	equ	*+2
	dc.w	$e0,0,$e2,0
	dc.w	$e4,0,$e6,0
	dc.w	$e8,0,$ea,0
	dc.w	$ec,0,$ee,0
	dc.w	$0d01,$fffe
	dc.w	$100,$4201
	dc.w	$ffff,$fffe
;
StatusLine:
	incbin	"zx-emul/gfx/cbspeccy_statusline.raw"
CBLogo:
	incbin	"zx-emul/gfx/cbspeccy_logo.raw"
;
AYsample:
	rept	256
	dc.w	$7f00
	endr
AYsample1:
	rept	256
	dc.w	$7f7f
	endr
OVLsample:
	dc.w	0,1,2,3,5,7,$a,$e,$13,$17,$1b,$23,$2a,$30,$34,$3f
	dc.w	0,1,2,3,5,7,$a,$e,$13,$17,$1b,$23,$2a,$30,$34,$3f
	dc.w	$3f,$34,$30,$2a,$23,$1b,$17,$13,$e,$a,7,5,3,2,1,0

;============================================
;
;	CMD's section
;
;============================================

	section	CMDs,bss_f
;
tCMDS:
;
	ds.b	2
cmd_buf:
	ds.b	65536+256
	ds.b	xLen*193*8*2

;===========================================	
;
;	KeyBoard Routines
;
;===========================================

	section	KeyRout,bss_f
;
tKEYR:
;
KeyRpnt:
	ds.l	256
KeyRoutines:
	ds.b	$4000

;===========================================
;
;	TZX file loader...
;
;===========================================

	section	TZX,code_f
;
MICtimer:
	dc.l	$c0000000
StartStop:
	dc.w	0
;------------------------------------------
GetMICproc:
	move.w	d6,d1
	sub.l	imod4(a1),d1
	sub.l	MICtimer,d1
	bpl.s	.1
	jmp	NextPulse
.1:
	move.w	CurrentPulse,d0
	clr.l	d1
LenGetMICproc	equ	*-GetMICproc
;------------------------------------------
CurrentPulse:
	dc.w	$ff
;
	cnop	0,8
;
NextPulse:
	move.l	d0,-(a7)
	neg.l	d1
	move.l	PulsePNT,a0
Npulse2:
	eor.w	#$40,CurrentPulse
Npulsex:
	clr.l	d0
	move.w	(a0)+,d0
	beq.s	Npulse1
Npulse3:
	sub.l	d0,d1
	bpl.s	Npulse2
	ext.l	d6
	add.l	d6,d1
	sub.l	imod4(a1),d1
	move.l	d1,MICtimer
	move.l	a0,PulsePNT
GetMIC1:
	clr.l	d1
	move.l	(a7)+,d0
;
GetMIC:
	move.w	d6,d1
	sub.l	imod4(a1),d1
	sub.l	MICtimer,d1
	bmi.s	NextPulse
	move.w	CurrentPulse,d0
	clr.l	d1
	move.b	-1(a5),d1
	jmp	([inrettab,d1.w*4])
;
Npulse1:
	move.l	(a0)+,d0
	bne.s	Npulse3
;
	move.w	(a0)+,d0
	beq	ParseTZX
;----------------------------------------
	movem.l	d0/d4-d7/a1,-(a7)
	move.l	#Pulses,PulsePNT
	move.l	TZXfilepnt,a0
	move.l	SaveTZXd7,d7
.2:
	cmp.l	#EndPulses,PulsePNT
	bcs.s	.22
	move.l	d7,SaveTZXd7
	clr.w	d0
	bsr	MakePulse
	bsr	MakePulse
	bsr	MakePulse
	moveq	#1,d0
	bsr	MakePulse
	bra.s	.8
.22:
	moveq	#7,d6
	move.b	(a0)+,d4
.3:
	move.l	TZXzerop,d0
	lsl.b	#1,d4
	bcc.s	.4
	move.l	TZXonep,d0
.4:
	move.l	d0,-(a7)
	bsr	MakePulse
	move.l	(a7)+,d0
	bsr	MakePulse
	dbra	d6,.3
	subq.l	#1,d7
	bne.s	.2
;
	move.b	TZXlastbit,d5
	move.b	(a0)+,d4
.6:
	move.l	TZXzerop,d0
	lsl.b	#1,d4
	bcc.s	.7
	move.l	TZXonep,d0
.7:
	move.l	d0,-(a7)
	bsr	MakePulse
	move.l	(a7)+,d0
	bsr	MakePulse
	sub.b	#1,d5
	bne.s	.6
	bsr	MakePause
.8:
	move.l	a0,TZXfilepnt
	movem.l	(a7)+,d0/d4-d7/a1
	move.l	#Pulses,a0
	move.l	a0,PulsePNT
	bra	Npulsex
;--------------------------------------------
ParseTZX:
	movem.l	d0-d7/a0-a6,-(a7)
	move.l	#Pulses,PulsePNT
	move.l	TZXfilepnt,a0
;
	move.b	(a0)+,d0
	beq	TZX_eof
	pea	TZXparseexit
	cmp.b	#$21,d0
	beq	TZX_21
	cmp.b	#$22,d0
	beq	TZX_22
	cmp.b	#$10,d0
	beq	TZX_10
	cmp.b	#$11,d0
	beq	TZX_11
	cmp.b	#$12,d0
	beq	TZX_12
	cmp.b	#$13,d0
	beq	TZX_13
	cmp.b	#$14,d0
	beq	TZX_14
;	cmp.b	#$15,d0
;	beq	TZX_15
	cmp.b	#$20,d0
	beq	TZX_20
	cmp.b	#$2A,d0
	beq	TZX_2A
	cmp.b	#$30,d0
	beq	TZX_30
	cmp.b	#$31,d0
	beq	TZX_31
	cmp.b	#$32,d0
	beq	TZX_32
	cmp.b	#$33,d0
	beq	TZX_33
	cmp.b	#$35,d0
	beq	TZX_35
	clr.w	StartStop
	move.l	#$c0000000,MICtimer
	jmp	Upor
;
TZX_eof:
	clr.w	d0
	bsr	MakePulse
	bsr	MakePulse
	bsr	MakePulse
	bsr	MakePulse
	move.l	#$c0000000,MICtimer
	clr.w	StartStop
	move.l	TAP_base,TZXfilepnt
	add.l	#10,TZXfilepnt
	move.l	#Pulses,PulsePNT
	movem.l	(a7)+,d0-d7/a0-a6
	bra	GetMIC1
;
TZXparseexit:
	clr.w	d0
	bsr	MakePulse
	bsr	MakePulse
	bsr	MakePulse
	bsr	MakePulse
TZXparseexit1:
	move.l	a0,TZXfilepnt
	move.l	#Pulses,PulsePNT
	movem.l	(a7)+,d0-d7/a0-a6
	tst.w	StartStop
	beq	GetMIC1
	move.l	PulsePNT,a0
	clr.l	d0
	move.w	(a0)+,d0
	bra	Npulse3
TZX_21:
	clr.l	d0
	move.b	(a0)+,d0
	add.l	d0,a0
	rts
TZX_33:
	clr.l	d0
	move.b	(a0)+,d0
	move.l	d0,d1
	add.l	d0,d0
	add.l	d1,d0
	add.l	d0,a0
	rts
TZX_22:
;	addq.l	#4,a7
	rts
TZX_10:
	move.w	#$ff,CurrentPulse
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,TZX_pause
	clr.l	d7
	move.w	(a0)+,d7
	rol.w	#8,d7
;
	move.w	#5000,d6
.1:
	move.l	#2168,d0
	bsr	MakePulse
	dbra	d6,.1
;
	move.l	#667,d0
	bsr	MakePulse
	move.l	#735,d0
	bsr	MakePulse
;
	move.l	#855,TZXzerop
	move.l	#1710,TZXonep
	move.b	#8,TZXlastbit
	bra	GenPulses
;
MakePause:
	tst.w	TZX_pause
	bne.s	MakePause1
	move.w	#100,d0
	bra	MakePulse
MakePause1:
	clr.w	d0
	bsr	MakePulse
	move.w	TZX_pause,d0
	mulu	#3500,d0
	swap	d0
	bsr	MakePulse
	swap	d0
	bsr	MakePulse
	rts
TZX_pause:
	dc.w	0
SaveTZXd7:
	dc.l	0
TZXlastbit:
	dc.w	0
;
TZX_11:
	move.w	#$bf,CurrentPulse
;
	move.w	$0a(a0),d6
	rol.w	#8,d6
	subq.w	#1,d6
.1:
	clr.l	d0
	move.w	(a0),d0
	rol.w	#8,d0
	bsr	MakePulse
	dbra	d6,.1
	addq.l	#2,a0
;
	clr.l	d0
	move.w	(a0)+,d0
	rol.w	#8,d0
	bsr	MakePulse
	clr.l	d0
	move.w	(a0)+,d0
	rol.w	#8,d0
	bsr	MakePulse
;
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,TZXzerop+2
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,TZXonep+2
	addq.l	#2,a0
;
	move.b	(a0)+,TZXlastbit	;last bit
;
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,TZX_pause
;
	clr.l	d7
	move.b	2(a0),d7
	lsl.l	#8,d7
	move.b	1(a0),d7
	lsl.l	#8,d7
	move.b	(a0),d7
	addq.l	#3,a0
;
GenPulses:
	subq.l	#1,d7
	beq.s	.5
.2:
	cmp.l	#EndPulses,PulsePNT
	bcs.s	.22
	move.l	d7,SaveTZXd7
	clr.w	d0
	bsr	MakePulse
	bsr	MakePulse
	bsr	MakePulse
	moveq	#1,d0
	bsr	MakePulse
	addq.l	#4,a7
	bra	TZXparseexit1
.22:
	moveq	#7,d6
	move.b	(a0)+,d4
.3:
	move.l	TZXzerop,d0
	lsl.b	#1,d4
	bcc.s	.4
	move.l	TZXonep,d0
.4:
	move.l	d0,-(a7)
	bsr	MakePulse
	move.l	(a7)+,d0
	bsr	MakePulse
	dbra	d6,.3
	subq.l	#1,d7
	bne.s	.2
;
.5:
	move.b	TZXlastbit,d5
	move.b	(a0)+,d4
.6:
	move.l	TZXzerop,d0
	lsl.b	#1,d4
	bcc.s	.7
	move.l	TZXonep,d0
.7:
	move.l	d0,-(a7)
	bsr	MakePulse
	move.l	(a7)+,d0
	bsr	MakePulse
	sub.b	#1,d5
	bne.s	.6
	bra	MakePause
TZXzerop:
	dc.l	0
TZXonep:
	dc.l	0
;
TZX_14:
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,TZXzerop+2
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,TZXonep+2
;
	move.b	(a0)+,TZXlastbit	;last bit
;
	move.w	(a0)+,d0
	rol.w	#8,d0
	move.w	d0,TZX_pause
;
	clr.l	d7
	move.b	2(a0),d7
	lsl.l	#8,d7
	move.b	1(a0),d7
	lsl.l	#8,d7
	move.b	(a0),d7
	addq.l	#3,a0
	bra	GenPulses
;
TZX_12:
	move.w	2(a0),d6
	rol.w	#8,d6	
	subq.w	#1,d6
.1:
	clr.l	d0
	move.w	(a0),d0
	rol.w	#8,d0
	bsr.w	MakePulse
	dbra	d6,.1
	addq.l	#4,a0
	rts
;
TZX_13:
	move.b	(a0)+,d6
.1:
	clr.l	d0
	move.w	(a0)+,d0
	rol.w	#8,d0
	bsr.w	MakePulse
	sub.b	#1,d6
	bne.s	.1
	rts
;
TZX_20:
	move.w	(a0)+,d0
	tst.w	d0
	beq.s	.1
	rol.w	#8,d0
	mulu	#3500,d0
	bra.w	MakePulse
.1:
	clr.w	StartStop
	move.l	#$c0000000,MICtimer
	rts
;
TZX_2A:
	addq.l	#4,a0
	tst.w	Lock?
	beq.s	.1
	clr.w	StartStop
	move.l	#$c0000000,MICtimer
.1:
	rts
;
TZX_30:
	clr.l	d0
	move.b	(a0)+,d0
	add.l	d0,a0
	rts
TZX_31:
	clr.l	d0
	addq.l	#1,a0
	move.b	(a0)+,d0
	add.l	d0,a0
	rts
TZX_32:
	clr.l	d0
	move.w	(a0)+,d0
	rol.w	#8,d0
	add.l	d0,a0
	rts
TZX_35:
	clr.l	d0
	move.b	$13(a0),d0
	lsl.l	#8,d0
	move.b	$12(a0),d0
	lsl.l	#8,d0
	move.b	$11(a0),d0
	lsl.l	#8,d0
	move.b	$10(a0),d0
	add.l	d0,a0
	add.l	#$14,a0
	rts
;------------------------------------------
MakePulse:
	move.l	PulsePNT,a1
	move.w	d0,(a1)+
	move.l	a1,PulsePNT
	rts
;
TapDisp:
	dc.l	0
TZXfilepnt:
	dc.l	0
	dc.w	0
	even
;
PulsePNT:
	dc.l	Pulses
;
LoadTap:				; Load *.TAP files...
	nop
	movem.l	d0-d2/d4/a1,-(a7)
	clr.w	KeyClick
;
	swap	d5
	clr.b	d5
;
	move.l	TAP_base,a0
	cmp.l	#"ZXTa",(a0)
	bne	.tap
	cmp.l	#"pe!"*256+$1a,4(a0)
	bne	.tap
;
	move.l	TZXfilepnt,a0
.parse:
	move.b	(a0)+,d0
	cmp.b	#$10,d0
	beq.s	.doit
	pea	.parse
	cmp.b	#$2A,d0
	beq	TZX_2A
	cmp.b	#$30,d0
	beq	TZX_30
	cmp.b	#$31,d0
	beq	TZX_31
	cmp.b	#$32,d0
	beq	TZX_32
	cmp.b	#$33,d0
	beq	TZX_33
	cmp.b	#$35,d0
	beq	TZX_35
	clr.w	StartStop
	move.l	#$c0000000,MICtimer
	jmp	Upor
.doit:
	move.w	(a0)+,d1
	rol.w	#8,d1
	mulu	#3500,d1
;
	neg.l	d1
	ext.l	d6
	add.l	d6,d1
	sub.l	imod4(a1),d1
	move.l	d1,MICtimer
;
	move.w	#-1,StartStop
	move.w	(a0)+,d0	; block lenght
	rol.w	#8,d0
	lea	(a0,d0.l),a1
	move.l	a1,TZXfilepnt
	bra.s	.common
.tap:
	move.l	TAP_size,d1
	add.l	TAP_base,d1
	cmp.l	TapDisp,d1	; Check End Of Tape...
	bne.s	.1
	move.l	TAP_base,TapDisp	; Reload Begin Of Tape...
.1
	move.l	TapDisp,a0
	move.w	(a0)+,d0	; block lenght
	rol.w	#8,d0
	lea	(a0,d0.l),a1
	move.l	a1,TapDisp
;
.common:
;
	move.w	-4(a6),a1	; IX -> A1
	moveq	#0,d1
	moveq	#-1,d4
;
	bra.s	.2
.4:
	tst.w	d4
	bne.s	.5
	move.b	d2,(a1)+
	move.w	a1,a1
	bra.s	.6
.5:
	lsl.w	#8,d2
	cmp.w	d2,d5
	bne.s	.3
	add.w	#1,d3	
	moveq	#0,d4
.6:
	sub.w	#1,d3
.2:
	tst.w	d0
	beq.s	.3
	sub.w	#1,d0
	move.b	(a0)+,d2
;
	eor.b	d2,d1
	tst.w	d3
	bne.s	.4
	tst.b	d1
	bne.s	.3
	or.b	#1,d5
.3:
	move.w	a1,-4(a6)	; A1 -> IX
;
	movem.l	(a7)+,d0-d2/d4/a1
	move.b	(a5)+,d0		; Go! Get 1st byte...
	lsl.w	#8,d0
	jmp	(a4,d0.w)

;==============================================
;
;	CBSpeccy GUI
;
;==============================================

	section	GUI,code_f
;
	include	zx-emul/gui/zxgui.s
;